(* ::Package:: *)

(************************************************************************)
(* This file was generated automatically by the Mathematica front end.  *)
(* It contains Initialization cells from a Notebook file, which         *)
(* typically will have the same name as this file except ending in      *)
(* ".nb" instead of ".m".                                               *)
(*                                                                      *)
(* This file is intended to be loaded into the Mathematica kernel using *)
(* the package loading commands Get or Needs.  Doing so is equivalent   *)
(* to using the Evaluate Initialization Cells menu command in the front *)
(* end.                                                                 *)
(*                                                                      *)
(* DO NOT EDIT THIS FILE.  This entire file is regenerated              *)
(* automatically each time the parent Notebook file is saved in the     *)
(* Mathematica front end.  Any changes you make to this file will be    *)
(* overwritten.                                                         *)
(************************************************************************)



If[MemberQ[$Packages,"HypExp`"],Print["The package HypExp is already loaded..."];Abort[]]


BeginPackage["HypExp`",{"HPL`","Global`"}]


If[!ValueQ[HPLInt::usage],Print["Version 2 of HypExp requires version 2 of the HPL Package"];Abort[]]


Print["***********************************\n***********  HypExp 2.0  ************\n***********************************\nAuthors:\n Tobias Huber:  RWTH Aachen,\n
Daniel Maitre: SLAC, University of Zurich.\n"];


$HPLAutoReduceToMinimalSet=True
$HPLAutoConvertToKnownFunctions=True


MyHypExpansion::usage = "MyHypExpansion[J,{a1,...,aJ},{\[Alpha]1,...,\[Alpha]J},{b1,...,bJ-1},{\[Beta]1,...,\[Beta]J-1},x,\[Epsilon],n] gives the \[Epsilon] Expansion of order n of HypergeometricPFQ[{a1+\[Alpha]1\[Epsilon],...,aJ+\[Alpha]J\[Epsilon]},{b1+\[Beta]1\[Epsilon],...,bJ-1+\[Beta]J-1\[Epsilon]},x] for integer values of a1,...,aJ and b1,...,bJ-1 and arbitrary values of \[Alpha]i and \[Beta]i (also symbols)"


HypExp::usage="HypExp[Hypergeometric2F1[...],x,\[Epsilon],n] gives the expansion of the Hypergeometric function around \[Epsilon]=0 until order \[Epsilon]^n"


$HypExpFailed::usage="Result of a failed calculation with the package HypExp"


HypExpAddToLib::usage="HypExpAddToLiB[\!\(\*SubscriptBox[\"a\", \"1\"]\),...,\!\(\*SubscriptBox[\"a\", \"J\"]\),\!\(\*SubscriptBox[\"b\", \"1\"]\),...,\!\(\*SubscriptBox[\"b\", 
RowBox[{\"J\", \"-\", \"1\"}]]\),n] adds the expansion to order \!\(\*SuperscriptBox[\"\[Epsilon]\", \"n\"]\) of HypergeometricPFQ[{\!\(\*SubscriptBox[\"a\", \"1\"]\)+\!\(\*SubscriptBox[\"\[Alpha]\", \"1\"]\)\[Epsilon],...,\!\(\*SubscriptBox[\"a\", \"J\"]\)+\!\(\*SubscriptBox[\"\[Alpha]\", \"J\"]\)\[Epsilon]},{\!\(\*SubscriptBox[\"b\", \"1\"]\)+\!\(\*SubscriptBox[\"\[Beta]\", \"1\"]\)\[Epsilon],...,\!\(\*SubscriptBox[\"b\", 
RowBox[{\"J\", \"-\", \"1\"}]]\)+\!\(\*SubscriptBox[\"\[Beta]\", 
RowBox[{\"J\", \"-\", \"1\"}]]\)\[Epsilon]},x] to the library"


HypExpInt::usage="HypExpInt[chi1,chi2,chi3,chi4,chi5,z] gives the definite integral from u = 0 ... 1 of u^chi1*Log[u]^chi2*Log[1-u]^chi3*Log[1-z*u]^chi4/(u*z-1)^chi5 with the chi's being non-negative integers and chi2+chi3+chi4+1-KroneckerDelta[chi5,0]\[LessEqual]5."
HypExpU::usage="HypExpU[n,m,p] evaluates the definite integral from u = 0 ... 1 of Log[u]^n*Log[1-u]^m u^p for non-negative integers n,m and p being any integer. If p < 0, then the integral is covergent if and only if m + p >= 0."


HypExpIsKnownToOrder::usage="HypExpIsKnownToOrder[\!\(\*SubscriptBox[\"a\", \"1\"]\),...,\!\(\*SubscriptBox[\"a\", \"J\"]\),\!\(\*SubscriptBox[\"b\", \"1\"]\),...,\!\(\*SubscriptBox[\"b\", 
RowBox[{\"J\", \"-\", \"1\"}]]\),n] returns True if the expansion of HypergeometricPFQ[{\!\(\*SubscriptBox[\"a\", \"1\"]\)+\!\(\*SubscriptBox[\"\[Alpha]\", \"1\"]\)\[Epsilon],...,\!\(\*SubscriptBox[\"a\", \"J\"]\)+\!\(\*SubscriptBox[\"\[Alpha]\", \"J\"]\)\[Epsilon]},{\!\(\*SubscriptBox[\"b\", \"1\"]\)+\!\(\*SubscriptBox[\"\[Beta]\", \"1\"]\)\[Epsilon],...,\!\(\*SubscriptBox[\"b\", 
RowBox[{\"J\", \"-\", \"1\"}]]\)+\!\(\*SubscriptBox[\"\[Beta]\", 
RowBox[{\"J\", \"-\", \"1\"}]]\)\[Epsilon]},x] is in the library, False if not."


$HypExpPolyLogRules::usage="If $HypExpPolyLogRules is set True, additional Rules for PolyLog are applied systematically. They are listed in hep-ph/0507094, Appendix A1. The default setting is False"


HypExp::sorry="Sorry, HypExp is not able to expand this function..."


HypExpInt::long="Please be patient. This might take a while..."
HypExpU::long="Please be patient. This might take a while..."


MyHypExpansion::zeroC="The Hypergeometric function 2F1[a,b,c,x] is not defined for c=0."


MyHypExpansion::nosymbolicexpansionparameter="The expansion parameter `1` is not a symbol"


MyHypExpansion::"nointegerparameter"="MyHypExpansion (currently) only works for parameters of the form a+\[Alpha]\[Epsilon] with a integer (no symbol) and \[Alpha] arbitrary (also symbolic). The argument `1` does not fulfil this requirement..."


HypExp::loaded="HypExp loaded! It allows the expansion of hypergeometric functions around their parameters. \n The new provided commands are:\n - HypExp\n - HypExpInt\n - HypExpU\n - HypExpAddToLib\n - HypExpIsKnownToOrder"


HypExp::divergent="The expansion of HypergeometricPFQ[`1`,`2`,1] is not convergent! The result might be wrong, or not...";


HypExp::expnotdef="The expansion of HypergeometricPFQ[`1`,`2`,1] is not convergent!"


HypExpInt::args="Wrong number of arguments in HypExpInt, expected 6, found `1`";
HypExpU::args="Wrong number of arguments in HypExpU, expected 3, found `1`";


Begin["`Private`"]


If[Head[General::spell]==String,Off[General::spell];spellswitchedoff=True,spellswitchedoff=False];
If[Head[SeriesData::sdatc]==String,Off[SeriesData::sdatc];seriesdataswitchedoff=True,seriesdataswitchedoff=False];
(*Off[Syntax::bktwrn];*)


Weight[Z[n_,mm_List,xx_List]]:=Apply[Plus,mm]
Weight[S[n_,mm_List,xx_List]]:=Apply[Plus,mm]


StoZ:={S[n_,m_List,x_List]^e_Integer?Positive:>MyStoZ[S[n,m,x]]^e,
S[n_,m_List,x_List]:>Switch[Length[m],
0,1,
1,Module[{i},X[x[[1]],i,m[[1]],n]],
_,Module[{i1,i2},X[x[[1]],i1,m[[1]],n] X[x[[2]],i2,m[[2]],i1-1] S[i2,Delete[m,{{1},{2}}],Delete[x,{{1},{2}}]]+S[n,Prepend[Delete[m,{{1},{2}}],m[[1]]+m[[2]]],Prepend[Delete[x,{{1},{2}}],x[[1]]x[[2]]]]
]]};
ZtoS:=Z[n_,m_List,x_List]:>Switch[Length[m],
0,1,
1,Module[{i},X[x[[1]],i,m[[1]],n]],
_,Module[{i1,i2},X[x[[1]],i1,m[[1]],n] X[x[[2]],i2,m[[2]],i1] Z[i2-1,Delete[m,{{1},{2}}],Delete[x,{{1},{2}}]]]-Z[n,Prepend[Delete[m,{{1},{2}}],m[[1]]+m[[2]]],Prepend[Delete[x,{{1},{2}}],x[[1]]x[[2]]]
]];


convertXtoZ:={XforZ[x_List,m_List,i_List]:>Z[i[[1]],m,x],X[x_,i_,m_,n_]:>Z[n,{m},{x}]};
convertXtoS:={XforS[x_List,m_List,i_List]:>S[i[[1]],m,x],X[x_,i_,m_,n_]:>S[n,{m},{x}]};


MyStoZ[x_]:=Expand[MyCollectXforZ[Expand[Expand[x]//.StoZ]]]//.convertXtoZ


prodZ:=Z[n_,mm1_List,x1_List] Z[n_,mm2_List,x2_List]:>(Module[{i},X[x1[[1]],i,mm1[[1]],n] Z[i-1,Delete[mm1,1],Delete[x1,1]] Z[i-1,mm2,x2]]+Module[{i},X[x2[[1]],i,mm2[[1]],n] Z[i-1,Delete[mm2,1],Delete[x2,1]] Z[i-1,mm1,x1]]+Module[{i},X[x1[[1]] x2[[1]],i,mm1[[1]]+mm2[[1]],n] Z[i-1,Delete[mm1,1],Delete[x1,1]]Z[i-1,Delete[mm2,1],Delete[x2,1]]])/;Length[mm1]>0&&Length[mm2]>0;prodZ2:=Z[n_,mm1_List,x1_List]^2:>(2 Module[{i},X[x1[[1]],i,mm1[[1]],n] Z[i-1,Delete[mm1,1],Delete[x1,1]] Z[i-1,mm1,x1]]+Module[{i},X[x1[[1]]^2,i,2 mm1[[1]],n] Z[i-1,Delete[mm1,1],Delete[x1,1]]^2])/;Length[mm1]>0;
prodZn:=Z[n_,mm1_List,x1_List]^e_Integer:>Switch[e,
2,Z[n,mm1,x1]^2/.prodZ2,
_,(Z[n,mm1,x1]^2/.prodZ2) Z[n,mm1,x1]^(e-2)]/;e>=2&&Length[mm1]>0;
prodS:=S[n_,mm1_List,x1_List] S[n_,mm2_List,x2_List]:>(Module[{i},X[x1[[1]],i,mm1[[1]],n] S[i,Delete[mm1,1],Delete[x1,1]] S[i,mm2,x2]]+Module[{i},X[x2[[1]],i,mm2[[1]],n] S[i,Delete[mm2,1],Delete[x2,1]] S[i,mm1,x1]]-Module[{i},X[x1[[1]] x2[[1]],i,mm1[[1]]+mm2[[1]],n] S[i,Delete[mm1,1],Delete[x1,1]]S[i,Delete[mm2,1],Delete[x2,1]]])/;Length[mm1]>0&&Length[mm2]>0;


prodS2:=S[n_,mm1_List,x1_List]^2:>(2 Module[{i},X[x1[[1]],i,mm1[[1]],n] S[i,Delete[mm1,1],Delete[x1,1]] S[i,mm1,x1]]-Module[{i},X[x1[[1]]^2,i,2 mm1[[1]],n] S[i,Delete[mm1,1],Delete[x1,1]]^2])/;Length[mm1]>0;
prodSn:=S[n_,mm1_List,x1_List]^e_Integer:>Switch[e,
2,S[n,mm1,x1]^2/.prodS2,
_,(S[n,mm1,x1]^2/.prodS2) S[n,mm1,x1]^(e-2)]/;e>=2&&Length[mm1]>0;


simplZ:=Z[n_,{},{}]:>1;
simplS:=S[n_,{},{}]:>1;


MyProductExpansionZ[initial_]:=(
final=Expand[initial]//.{simplZ,prodZ,prodZ2,prodZn};
Return[If[MatchQ[initial,final],final,MyProductExpansionZ[final]]]
)


collectXforZ1:=X[x1_,i1_,m1_,n1_] X[x2_,i2_,m2_,i1_-1]:>XforZ[List[x1,x2],List[m1,m2],List[n1,i2]];
collectXforZ2:=X[x1_,i1_,m1_,n1_]XforZ[x2_List,m2_List,i2_List]:>XforZ[Prepend[x2,x1],Prepend[m2,m1],List[n1,i2[[2]]]]/;i2[[1]]==i1-1;
collectXforZ3:=X[x1_,i1_,m1_,n1_]XforZ[x2_List,m2_List,i2_List]:>XforZ[Append[x2,x1],Append[m2,m1],List[i2[[1]],i1]]/;i2[[2]]-1==n1;
collectXforZ4:=XforZ[x1_List,m1_List,i1_List]XforZ[x2_List,m2_List,i2_List]:>XforZ[Join[x1,x2],Join[m1,m2],List[i1[[1]],i2[[2]]]]/;i1[[2]]-1==i2[[1]];


collectXforZ5:=X[x1_,i1_,m1_,n1_] X[x2_,i2_,m2_,i1_]:>XforZ[List[x1,x2],List[m1,m2],List[n1,i2]]+X[x1 x2,i1,m1+m2,n1];
collectXforZ6:=X[x1_,i1_,m1_,n1_]XforZ[x2_List,m2_List,i2_List]:>XforZ[Prepend[x2,x1],Prepend[m2,m1],List[n1,i2[[2]]]]+XforZ[ReplacePart[x2,x1 x2[[1]],1],ReplacePart[m2,m1+m2[[1]],1],List[n1,i2[[2]]]]/;i2[[1]]==i1;
collectXforZ7:=X[x1_,i1_,m1_,n1_]XforZ[x2_List,m2_List,i2_List]:>XforZ[Append[x2,x1],Append[m2,m1],List[i2[[1]],i1]]+XforZ[ReplacePart[x2,x1 x2[[-1]],-1],ReplacePart[m2,m1+m2[[-1]],-1],List[i2[[1]],i1]]/;i2[[2]]==n1;
collectXforZ8:=XforZ[x1_List,m1_List,i1_List]XforZ[x2_List,m2_List,i2_List]:>XforZ[Join[x1,x2],Join[m1,m2],List[i1[[1]],i2[[2]]]]+XforZ[Join[ReplacePart[x1,x1[[-1]] x2[[1]],-1],Delete[x2,1]],Join[ReplacePart[m1,m1[[-1]]+m2[[1]],-1],Delete[m2,1]],List[i1[[1]],i2[[2]]]]/;i1[[2]]==i2[[1]];


collectXforZ:={collectXforZ1,collectXforZ2,collectXforZ3,collectXforZ4,collectXforZ5,collectXforZ6,collectXforZ7,collectXforZ8};


reconstructZ:=X[x_,i_,m_,n_] Z[i_-1,mm_List,xx_List]:>Z[n,Prepend[mm,m],Prepend[xx,x]];


MyCollectXforZ[initial_]:=(
final=Expand[initial]//.collectXforZ;
Return[If[MatchQ[initial,final],final,MyCollectXforZ[final]]]
)


collectXforS1:=X[x1_,i1_,m1_,n1_] X[x2_,i2_,m2_,i1_]:>XforS[List[x1,x2],List[m1,m2],List[n1,i2]];
collectXforS2:=X[x1_,i1_,m1_,n1_]XforS[x2_List,m2_List,i2_List]:>XforS[Prepend[x2,x1],Prepend[m2,m1],List[n1,i2[[2]]]]/;i2[[1]]==i1;
collectXforS3:=X[x1_,i1_,m1_,n1_]XforS[x2_List,m2_List,i2_List]:>XforS[Append[x2,x1],Append[m2,m1],List[i2[[1]],i1]]/;i2[[2]]==n1;
collectXforS4:=XforS[x1_List,m1_List,i1_List]XforS[x2_List,m2_List,i2_List]:>XforS[Join[x1,x2],Join[m1,m2],List[i1[[1]],i2[[2]]]]/;i1[[2]]==i2[[1]];


collectXforS5:=X[x1_,i1_,m1_,n1_] X[x2_,i2_,m2_,i1_-1]:>XforS[List[x1,x2],List[m1,m2],List[n1,i2]]-X[x1 x2,i1,m1+m2,n1];
collectXforS6:=X[x1_,i1_,m1_,n1_]XforS[x2_List,m2_List,i2_List]:>XforS[Prepend[x2,x1],Prepend[m2,m1],List[n1,i2[[2]]]]-XforS[ReplacePart[x2,x1 x2[[1]],1],ReplacePart[m2,m1+m2[[1]],1],List[n1,i2[[2]]]]/;i2[[1]]==i1-1;
collectXforS7:=X[x1_,i1_,m1_,n1_]XforS[x2_List,m2_List,i2_List]:>XforS[Append[x2,x1],Append[m2,m1],List[i2[[1]],i1]]-XforS[ReplacePart[x2,x1 x2[[-1]],-1],ReplacePart[m2,m1+m2[[-1]],-1],List[i2[[1]],i1]]/;i2[[2]]-1==n1;
collectXforS8:=XforS[x1_List,m1_List,i1_List]XforS[x2_List,m2_List,i2_List]:>XforS[Join[x1,x2],Join[m1,m2],List[i1[[1]],i2[[2]]]]-XforS[Join[Replace[x1,x1[[-1]] x2[[1]],-1],Delete[x2,1]],Join[Replace[m1,m1[[-1]]+m2[[1]],-1],Delete[m2,1]],List[i1[[1]],i2[[2]]]]/;i1[[2]]-1==i2[[1]];


collectXforS:={collectXforS1,collectXforS2,collectXforS3,collectXforS4,collectXforS5,collectXforS6,collectXforS7,collectXforS8};


reconstructS:=X[x_,i_,m_,n_] S[i_,mm_List,xx_List]:>S[n,Prepend[mm,m],Prepend[xx,x]];


MyZProductSimplify[initial_]:=(
final=MyProductExpansionZ[initial]//.reconstructZ//.collectXforZ//.convertXtoZ;
Return[If[MatchQ[initial,final],final,MyZProductSimplify[final]]]
)


sync[Z[K_+HypExpi,m_List,xx_List]]:=If[K==-1,Z[K+HypExpi,m,xx],Z[HypExpi-1,m,xx]+Sum[xx[[1]]^(j) Den[j,m[[1]],xx[[1]]] If[Length[m]>1,Z[HypExpi-1+j,Delete[m,1],Delete[xx,1]],1],{j,0,K}]];
sync[Z[HypExpi,m_List,xx_List]]:=Z[HypExpi-1,m,xx]+Den[0,m[[1]],xx[[1]]] If[Length[m]>1,Z[HypExpi-1,Delete[m,1],Delete[xx,1]],1];
sync[x_]:=x


MySyncronize[initial_]:=(
final=sync//@Expand[initial];
Return[If[MatchQ[initial,final],final,MySyncronize[final]]]
)


NumericalZ[Z[n_,m_List,x_List]]:=If[Length[m]==0,If[n<0,0,1],Sum[x[[1]]^j/(j)^m[[1]] Z[j-1,Delete[m,1],Delete[x,1]],{j,1,n}]]
NumericalZ[x_]:=x


NuZ:={Z[n_,m_List,x_List]:>NumericalZ//@Z[n,m,x]/;Length[m]>0,Z[n_,m_,x_]:>NumericalZ//@Z[n,m,x]};


NumZ[x_]:=x//.NuZ;


NumericalS[S[n_,m_List,x_List]]:=If[Length[m]==0,If[n<=0,0,1],Sum[x[[1]]^j/(j)^m[[1]] S[j,Delete[m,1],Delete[x,1]],{j,1,n}]]
NumericalS[x_]:=x


NuS:={S[n_,m_List,x_List]:>NumericalS//@S[n,m,x]/;Length[m]>0,S[n_,m_,x_]:>NumericalS//@S[n,m,x]};


NumS[x_]:=x//.NuS;


gexp[G[a_+HypExpi+\[Alpha]_ HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1+\[Alpha] HypExp\[Epsilon]] Gamma[a+HypExpi] (1+Sum[(HypExp\[Epsilon] \[Alpha])^j Z[HypExpi+a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Sum[Den[-j-1,1,\[Alpha]]/((-a-1-j)! (-1)^(-a-1-j) j!),{j,0,-a-1}] gexp[G[HypExpi+\[Alpha] HypExp\[Epsilon]],n]
]//.SimplGamma;
gexp[G[a_+HypExpi+HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1+HypExp\[Epsilon]] Gamma[a+HypExpi] (1+Sum[(HypExp\[Epsilon])^j Z[HypExpi+a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Sum[Den[-j-1,1,1]/((-a-1-j)! (-1)^(-a-1-j) j!),{j,0,-a-1}] gexp[G[HypExpi+HypExp\[Epsilon]],n]
]//.SimplGamma;
gexp[G[a_+HypExpi-HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1-HypExp\[Epsilon]] Gamma[a+HypExpi] (1+Sum[(-HypExp\[Epsilon])^j Z[HypExpi+a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Sum[Den[-j-1,1,-1]/((-a-1-j)! (-1)^(-a-1-j) j!),{j,0,-a-1}] gexp[G[HypExpi-HypExp\[Epsilon]],n]
]//.SimplGamma;

gexp[G[HypExpi+\[Alpha]_ HypExp\[Epsilon]],n_]:=
Gamma[1+\[Alpha] HypExp\[Epsilon]] Gamma[HypExpi] (1+Sum[(HypExp\[Epsilon] \[Alpha])^j Z[HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])//.SimplGamma;
gexp[G[HypExpi+HypExp\[Epsilon]],n_]:=
Gamma[1+HypExp\[Epsilon]] Gamma[HypExpi] (1+Sum[(HypExp\[Epsilon])^j Z[HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])//.SimplGamma;
gexp[G[HypExpi-HypExp\[Epsilon]],n_]:=
Gamma[1-HypExp\[Epsilon]] Gamma[HypExpi] (1+Sum[(-HypExp\[Epsilon])^j Z[HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])//.SimplGamma;

gexp[G[a_+\[Alpha]_ HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1+\[Alpha] HypExp\[Epsilon]] Gamma[a] (1+Sum[(HypExp\[Epsilon] \[Alpha])^j Z[a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Gamma[1+\[Alpha] HypExp\[Epsilon]]/(\[Alpha] HypExp\[Epsilon]) Gamma[1-a]^-1 (-1)^(-a) (1+Sum[(HypExp\[Epsilon] \[Alpha])^j S[-a,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])]//.SimplGamma
gexp[G[a_+HypExp\[Epsilon] ],n_]:=If[a>0,
Gamma[1+HypExp\[Epsilon]] Gamma[a] (1+Sum[(HypExp\[Epsilon])^j Z[a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Gamma[1+HypExp\[Epsilon]]/(HypExp\[Epsilon]) Gamma[1-a]^-1 (-1)^(-a) (1+Sum[(HypExp\[Epsilon])^j S[-a,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])]//.SimplGamma
gexp[G[a_-HypExp\[Epsilon] ],n_]:=If[a>0,
Gamma[1-HypExp\[Epsilon]] Gamma[a] (1+Sum[(-HypExp\[Epsilon])^j Z[a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Gamma[1-HypExp\[Epsilon]]/(-HypExp\[Epsilon]) Gamma[1-a]^-1 (-1)^(-a) (1+Sum[(-HypExp\[Epsilon])^j S[-a,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])]//.SimplGamma

gexp[invG[a_+\[Alpha]_ HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1+\[Alpha] HypExp\[Epsilon]]^-1 Gamma[a]^-1 (1+Sum[(-HypExp\[Epsilon] \[Alpha])^j S[a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Gamma[1+\[Alpha] HypExp\[Epsilon]]^-1 \[Alpha] HypExp\[Epsilon] Gamma[1-a] (-1)^(-a)(1+Sum[(-HypExp\[Epsilon] \[Alpha])^j Z[-a,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])]
gexp[invG[a_+HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1+HypExp\[Epsilon]]^-1 Gamma[a]^-1 (1+Sum[(-HypExp\[Epsilon])^j S[a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Gamma[1+HypExp\[Epsilon]]^-1 HypExp\[Epsilon] Gamma[1-a] (-1)^(-a)(1+Sum[(-HypExp\[Epsilon])^j Z[-a,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])]
gexp[invG[a_-HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1-HypExp\[Epsilon]]^-1 Gamma[a]^-1 (1+Sum[(HypExp\[Epsilon])^j S[a-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Gamma[1-HypExp\[Epsilon]]^-1 (-HypExp\[Epsilon]) Gamma[1-a] (-1)^(-a)(1+Sum[(HypExp\[Epsilon])^j Z[-a,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])]

myCoeff[i_,j_]:=Module[{x},Coefficient[x Product[(x+jj),{jj,0,i}],x^(j+2)]]

gexp[invG[a_+HypExpi+\[Alpha]_ HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1+\[Alpha] HypExp\[Epsilon]]^-1 Gamma[a+HypExpi]^-1 (1+Sum[(-HypExp\[Epsilon] \[Alpha])^j S[a+HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Sum[myCoeff[-a,j] (-1)^(-a-j) Sum[Binomial[j,jj](\[Alpha] HypExp\[Epsilon])^jj Den[0,-j+jj,1],{jj,0,j}],{j,0,-a}] gexp[invG[HypExpi+\[Alpha] HypExp\[Epsilon]],n]]//.SimplGamma
gexp[invG[a_+HypExpi+HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1+HypExp\[Epsilon]]^-1 Gamma[a+HypExpi]^-1 (1+Sum[(-HypExp\[Epsilon])^j S[a+HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
Sum[myCoeff[-a,j] (-1)^(-a-j) Sum[Binomial[j,jj](HypExp\[Epsilon])^jj Den[0,-j+jj,1],{jj,0,j}],{j,0,-a}] gexp[invG[HypExpi+HypExp\[Epsilon]],n]]//.SimplGamma
gexp[invG[a_+HypExpi-HypExp\[Epsilon]],n_]:=If[a>0,
Gamma[1-HypExp\[Epsilon]]^-1 Gamma[a+HypExpi]^-1 (1+Sum[(HypExp\[Epsilon])^j S[a+HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}]),
 Sum[myCoeff[-a,j] (-1)^(-a-j) Sum[Binomial[j,jj](-HypExp\[Epsilon])^jj Den[0,-j+jj,1],{jj,0,j}],{j,0,-a}]gexp[invG[HypExpi-HypExp\[Epsilon]],n]]//.SimplGamma

gexp[invG[HypExpi+\[Alpha]_ HypExp\[Epsilon]],n_]:=Gamma[1+\[Alpha] HypExp\[Epsilon]]^-1 Gamma[HypExpi]^-1 (1+Sum[(-HypExp\[Epsilon] \[Alpha])^j S[HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])//.SimplGamma 
gexp[invG[HypExpi+HypExp\[Epsilon]],n_]:=Gamma[1+HypExp\[Epsilon]]^-1 Gamma[HypExpi]^-1 (1+Sum[(-HypExp\[Epsilon])^j S[HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])//.SimplGamma 
gexp[invG[HypExpi-HypExp\[Epsilon]],n_]:=Gamma[1-HypExp\[Epsilon]]^-1 Gamma[HypExpi]^-1 (1+Sum[(HypExp\[Epsilon])^j S[HypExpi-1,Table[1,{ii,j}],Table[1,{ii,j}]],{j,n}])//.SimplGamma 

gexp[invG[\[Alpha]_ HypExp\[Epsilon]],n_]:=Gamma[1+\[Alpha] HypExp\[Epsilon]]^-1 (\[Alpha] HypExp\[Epsilon])//.SimplGamma
gexp[invG[HypExp\[Epsilon]],n_]:=Gamma[1+HypExp\[Epsilon]]^-1 (HypExp\[Epsilon])//.SimplGamma
gexp[invG[-HypExp\[Epsilon]],n_]:=Gamma[1-HypExp\[Epsilon]]^-1 (-HypExp\[Epsilon])//.SimplGamma

gexp[G[\[Alpha]_ HypExp\[Epsilon]],n_]:=Gamma[1+\[Alpha] HypExp\[Epsilon]] (\[Alpha] HypExp\[Epsilon])^-1//.SimplGamma
gexp[G[HypExp\[Epsilon]],n_]:=Gamma[1+HypExp\[Epsilon]] (HypExp\[Epsilon])^-1//.SimplGamma
gexp[G[-HypExp\[Epsilon]],n_]:=Gamma[1-HypExp\[Epsilon]] (-HypExp\[Epsilon])^-1//.SimplGamma

gexp[G[a_],n_]:=Gamma[a]//.SimplGamma

gexp[invG[a_],n_]:=Gamma[a]^-1//.SimplGamma
gexp[x_,n_]:=x


GammaExpand[x_,theorder_]:=gexp[#,theorder]&//@x;


SimplGamma={Gamma[a_+HypExpi]^-1:>Sum[(-1)^j/((a-1-j)! j!) Den[j,1,1]Gamma[HypExpi]^-1,{j,0,a-1}],Gamma[a_+HypExpi]:>Sum[myCoeff[a-1,j] Den[0,-j-1,1],{j,0,a-1}] Gamma[HypExpi]}


prodDen1:=Den[j_,n_,x1_] Den[j_,m_,x2_]:>Den[j,n+m,x1 x2]/;n!=0&&m!=0&&j>=0;
prodDen2:=Den[j_,n_,\[Alpha]_] Den[j_,m_,\[Alpha]_]:>Den[j,n+m,\[Alpha]]/;n!=0&&m!=0&&j<0;
powDen1:=Den[j_,n_,x_]^e_:>Den[j,e n,x^e]/;j>=0;
powDen2:=Den[j_,n_,x_]^e_:>Den[j,e n,x]/;j<0;
partialDen1:=Den[j1_,n1_,x_] Den[j2_,n2_,x_]:>1/(j2-j1) (MyDenProduct2[Den[j1,n1,x] Den[j2,n2-1,x]]-MyDenProduct2[Den[j1,n1-1,x] Den[j2,n2,x]])/;j1!=j2&&j1>=0&&j2>=0&&n1>0&&n2>0;
partialDen2:=Den[j1_,n1_,\[Alpha]1_] Den[j2_,n2_,\[Alpha]2_]:>1/(j2-j1+(\[Alpha]2-\[Alpha]1) HypExp\[Epsilon]) (MyDenProduct2[Den[j1,n1,\[Alpha]1] Den[j2,n2-1,\[Alpha]2]]-MyDenProduct2[Den[j1,n1-1,\[Alpha]1] Den[j2,n2,\[Alpha]2]])/;(j1!=j2||Not[MatchQ[\[Alpha]1,\[Alpha]2]])&&j1<0&&j2<0&&n1>0&&n2>0&&j1!=j2;
(*This is to avoid getting to many 1/\[Epsilon] artificially from partial fractionning 1/(i-j+\[Alpha]1\[Epsilon])*1/(i-j+\[Alpha]2\[Epsilon]). The solution is to first traet the Den's with differnet negative j end only then the ones with same j... *)
partialDenSameNegJ:=Den[j_,n1_,\[Alpha]1_] Den[j_,n2_,\[Alpha]2_]:>1/((\[Alpha]2-\[Alpha]1) HypExp\[Epsilon]) (MyDenProduct2[Den[j,n1,\[Alpha]1] Den[j,n2-1,\[Alpha]2]]-MyDenProduct2[Den[j,n1-1,\[Alpha]1] Den[j,n2,\[Alpha]2]])/;Not[MatchQ[\[Alpha]1,\[Alpha]2]]&&j<0&&n1>0&&n2>0;

partialDen3:=Den[j1_,n1_,x1_] Den[j2_,n2_,x2_]:>MyDenProduct2[Den[j1,n1+1,x1] Den[j2,n2+1,x2](Den[0,-2,1]+(j1+j2) Den[0,-1,1]+j1 j2)]/;j1>=0&&j2>=0&&n1<0&&n2<0;
partialDen4:=Den[j1_,n1_,\[Alpha]1_] Den[j2_,n2_,\[Alpha]2_]:>MyDenProduct2[Den[j1,n1+1,\[Alpha]1] Den[j2,n2+1,\[Alpha]2](Den[0,-2,1]+(j1+j2+HypExp\[Epsilon] (\[Alpha]1+\[Alpha]2)) Den[0,-1,1]+(j1+\[Alpha]1 HypExp\[Epsilon]) (j2+\[Alpha]2 HypExp\[Epsilon]))]/;j1<0&&j2<0&&n1<0&&n2<0;

partialDen5:=Den[j1_,n1_,x1_] Den[j2_,n2_,x2_]:>MyDenProduct2[Den[j1,n1-1,x1] Den[j2,n2+1,x2] (1+(j2-j1) Den[j1,1,1])]/;j1>=0&&j2>=0&&n1>0&&n2<0;
partialDen6:=Den[j1_,n1_,\[Alpha]1_] Den[j2_,n2_,\[Alpha]2_]:>MyDenProduct2[Den[j1,n1-1,\[Alpha]1] Den[j2,n2+1,\[Alpha]2] (1+(j2-j1+HypExp\[Epsilon] (\[Alpha]2-\[Alpha]1)) Den[j1,1,\[Alpha]1])]/;j1<0&&j2<0&&n1>0&&n2<0;
partialDen7:=Den[j1_,n1_,\[Alpha]_] Den[j2_,n2_,x_]:>MyDenProduct2[Den[j1,n1-1,\[Alpha]] Den[j2,n2+1,x] (1+(j2-j1-\[Alpha] HypExp\[Epsilon]) Den[j1,1,\[Alpha]])]/;j1<0&&j2>=0&&n1>0&&n2<0;
partialDen8:=Den[j1_,n1_,x_] Den[j2_,n2_,\[Alpha]_]:>MyDenProduct2[Den[j1,n1-1,x] Den[j2,n2+1,\[Alpha]] (1+(j2-j1+\[Alpha] HypExp\[Epsilon]) Den[j1,1,1])]/;j1>=0&&j2<0&&n1>0&&n2<0;

partialDen9:=Den[j1_,n1_,\[Alpha]_] Den[j2_,n2_,x_]:>MyDenProduct2[Den[j1,n1-1,\[Alpha]] Den[j2,n2-1,x] (1/(j2-j1-\[Alpha] HypExp\[Epsilon]) (Den[j1,1,\[Alpha]]-Den[j2,1,1]))]/;j1<0&&j2>=0&&n1>0&&n2>0;
partialDen10:=Den[j1_,n1_,\[Alpha]_] Den[j2_,n2_,x_]:>MyDenProduct2[Den[j1,n1+1,\[Alpha]] Den[j2,n2+1,x] (Den[0,-2,1]+Den[0,-1,1] (j1+j2+\[Alpha] HypExp\[Epsilon])+j2 (j1+\[Alpha] HypExp\[Epsilon]) )]/;j1<0&&j2>=0&&n1<0&&n2<0;



zeroDen1:=Den[j1_,0,x1_] Den[j2_,n_,x2_]:>Den[j2,n,x1 x2]/;j1>=0;
zeroDen2:=Den[j1_,0,\[Alpha]1_] Den[j2_,n_,\[Alpha]2_]:>Den[j2,n,\[Alpha]2]/;j1<0;
reduceDen:=Den[j_,m_,1] Z[HypExpi-1,mm_List,xx_List]:>Switch[Length[mm],
0,x^-1 Den[j-1,m,1]-1/j^m,
_,x^-1 MyDenProduct[Den[j-1,m,1] Z[HypExpi-1,mm,xx]]-MyDenProduct[Den[j,m,xx[[1]]] Den[0,mm[[1]],xx[[1]]]] Z[HypExpi-1,Delete[mm,1],Delete[xx,1]]]/;j>0;

negoffset[order_]:={
Den[j_,0,\[Alpha]_] Z[HypExpi-1,mm_List,xx_List]:>Z[HypExpi-1,mm,xx]/;j<0,
Den[j_,m_,\[Alpha]_] Z[HypExpi-1,mm_List,xx_List]:>Sum[x^k/(k+j+\[Alpha] HypExp\[Epsilon])^m NumZ[Z[k-1,mm,xx]],{k,1,-j-1}]+x^(-j)/(\[Alpha] HypExp\[Epsilon])^m NumZ[Z[-j-1,mm,xx]]+x^(-j) MyNegOffset[Expand[MyDenProduct[MySyncronize[Expand[If[m>0,
Sum[(-\[Alpha] HypExp\[Epsilon])^k Den[0,m+k,1] (m+k-1)!/(k! (m-1)!) Z[-j+HypExpi-1,mm,xx],{k,0,order}],
Sum[(\[Alpha] HypExp\[Epsilon])^k Den[0,m+k,1] m!/(m-k)!/k! Z[-j+HypExpi-1,mm,xx],{k,0,Min[order,m]}]
]]]]],order-Weight[Z[HypExpi-1,mm,xx]]]/;j<0
};
SimplDen:={prodDen1,prodDen2,partialDen1,partialDen2,partialDen3,partialDen4,partialDen5,partialDen6,partialDen7,partialDen8,partialDen9,partialDen10,zeroDen1,zeroDen2,powDen1,powDen2};


MyDenProduct[initial_]:=(
final=Expand[initial]//.SimplDen//.partialDenSameNegJ;
Return[If[MatchQ[initial,final],final,MyDenProduct[final]]]
)
MyDenProduct2[initial_]:=Expand[initial]//.SimplDen//.partialDenSameNegJ;


MyReduceDen[initial_]:=(
final=Expand[initial]//.reduceDen;
Return[If[MatchQ[initial,final],final,MyReduceDen[final]]]
)


MyNegOffset[initial_,order_]:=initial//.negoffset[order];


MyPolynom[m_]:=LerchPhi[x,-m,j]/. {j^e_:>Den[1,-e,1],j->Den[0,-1,1]+Den[0,0,1]};
ConvertToDenLastZ={intmarker HypExpi^e_.->Den[0,-e,1],intmarker->Den[0,0,1]}
LastZConstruct2:={Den[0,m_,1] Z[HypExpi-1,mm_List,xx_List]:>If[m==0,Z[HypExpi-1,mm,xx],Z[Prepend[mm,m],Prepend[xx,x]]],Z[HypExpi-1,mm_List,xx_List]:>Switch[Length[mm],
0,x OneOverOneMinusZ[x],
1,HPL[mm,x] x OneOverOneMinusZ[x],
_,x HPL[mm,x]OneOverOneMinusZ[x]],Z[mm_List,xx_List]:>Switch[Length[mm],
1,PolyLog[mm[[1]],x],
_,Collect[x fff[-mm[[1]],mm[[2]]] Z[HypExpi-1,Delete[mm,{{1},{2}}],Table[1,{j,1,Length[mm]-2}]],{Den[___],Z[___]}]]/;mm[[1]]<0};


fff[m_,m2_]:=Collect[intmarker Apart[LerchPhi[x,-m,HypExpi+1]/HypExpi^m2,HypExpi],{HypExpi^(_:1) intmarker^(_:1),HypExpi^(_:1),intmarker^(_:1)}]/. ConvertToDenLastZ


FinalReplaceDen:={Den[k_,m_,1]:>x^(-k) (HPL[{m},x]-Sum[x^j/j^m,{j,1,k}])/;k>=0&&m>0,Den[0,0,1]:>x OneOverOneMinusZ[x],Den[k_,m_,1]:>x LerchPhi[x,m,k+1]/;k>=0};
FinalReplaceZ:={Z[mm_List,xx_List]:>HPL[mm,x]/;MatchQ[xx[[1]],x]};
FinalNegOffset[order_]:=Den[j_,m_,\[Alpha]_]:>If[MatchQ[m,0],x OneOverOneMinusZ[x],If[m>0,\!\(
\*UnderoverscriptBox[\(\[Sum]\), \(k = 0\), \(order\)]
\*FractionBox[\(
\*SuperscriptBox[\((\(-HypExp\[Epsilon]\)\ \[Alpha])\), \(k\)]\ HPL[{k + m}, x]\ \(\((k + m - 1)\)!\)\), \(\(k!\)\ \(\((m - 1)\)!\)\)]\)/x^j,\!\(
\*UnderoverscriptBox[\(\[Sum]\), \(k = 0\), \(order\)]
\*FractionBox[\(
\*SuperscriptBox[\((\(-HypExp\[Epsilon]\)\ \[Alpha])\), \(k\)]\ PolyLog[k + m, x]\ \(\((k + m - 1)\)!\)\), \(\(k!\)\ \(\((m - 1)\)!\)\)]\)/x^j]+(\!\(
\*UnderoverscriptBox[\(\[Sum]\), \(k = 1\), \(\(-j\) - 1\)]\(Series[
\*FractionBox[
SuperscriptBox[\(x\), \(k\)], 
SuperscriptBox[\((j + k + \[Alpha]\ HypExp\[Epsilon])\), \(m\)]], {HypExp\[Epsilon], 0, order}]\)\)+1/(x^j (\[Alpha] HypExp\[Epsilon])^m))]/;j<0;


NumberOfIn[a_,L_]:=Apply[Plus,If[MatchQ[a,#],1,0]&/@L]


RequiredOrderForN[n_,j_,a_List]:=Min[Max[-j-1+NumberOfIn[j,a],n],n+NumberOfIn[j,a]]


AdditionalOrdersForNegA[n_,a_List]:=Max[RequiredOrderForN[n,#,a]&/@Union[Cases[a,_?Negative]]]-n


AO[a_]:=Max[NumberOfIn[#,a]&/@Union[Cases[a,_?Negative]],0]


ZPart[J_,\[Alpha]_List,\[Beta]_List,order_]:=Product[(1+Sum[(HypExp\[Epsilon] \[Alpha][[j]])^jj Z[HypExpi-1,Table[1,{ii,jj}],Table[1,{ii,jj}]],{jj,order}]),{j,1,J}] Product[(1+Sum[(-HypExp\[Epsilon] \[Beta][[j]])^jj S[HypExpi-1,Table[1,{ii,jj}],Table[1,{ii,jj}]],{jj,order}]),{j,1,J-1}]


ZPR[J_,\[Alpha]_List,\[Beta]_List,order_]:=MyZProductSimplify[MyStoZ[Normal[Series[ZPart[J,\[Alpha],\[Beta],order],{HypExp\[Epsilon],0,order}]]]];


paramlist[J_]:=Flatten[Join[Table[ToExpression[StringJoin["alpha",ToString[ii]]],{ii,1,J}],Table[ToExpression[StringJoin["beta",ToString[ii]]],{ii,1,J-1}]]]


PZRule2=<<PZRule2.m
PZRule3=<<PZRule3.m
PZRule4=<<PZRule4.m
PZRule5=<<PZRule5.m
PZRule6=<<PZRule6.m
PZRule7=<<PZRule7.m
PZRule8=<<PZRule8.m
PZRule9=<<PZRule9.m
PZRule10=<<PZRule10.m



PZReplacementRules[2,ww_]:=PZRule2/;ww<=8
PZReplacementRules[3,ww_]:=PZRule3/;ww<=7
PZReplacementRules[4,ww_]:=PZRule4/;ww<=6
PZReplacementRules[5,ww_]:=PZRule5/;ww<=5
PZReplacementRules[6,ww_]:=PZRule6/;ww<=4
PZReplacementRules[7,ww_]:=PZRule7/;ww<=3
PZReplacementRules[8,ww_]:=PZRule8/;ww<=3
PZReplacementRules[9,ww_]:=PZRule9/;ww<=3
PZReplacementRules[10,ww_]:=PZRule10/;ww<=3



PPZReplacementRules[JJ_,ww_]:=Module[{r},
r=ZPR[JJ,Table[ToExpression[StringJoin["#",ToString[ii]]],{ii,1,JJ}],Table[ToExpression[StringJoin["#",ToString[ii]]],{ii,JJ+1,2 JJ-1}],ww];
r=Collect[r,HypExp\[Epsilon]^a_. Z[___],PZ]/.HypExp\[Epsilon]^a_. Z[x_,mm_List,xx_List] PZ[pol_]:>PZ[JJ,a,mm,pol]/;MatchQ[xx,Table[1,{ii,1,Length[mm]}]]&&a==Apply[Plus,mm];
r=Apply[List,r];
Return[Cases[r//.PZ[J_,w_,mm_List,pol_]:>PZ[J,w,mm]->FullSimplify[pol],_Rule]
]]


PZReplacementRules[JJ_,ww_]:=Function[Evaluate[PPZReplacementRules[JJ,ww]]]


If[StringMatchQ[$Version,"*5.0*"],Tuples[ll_List,0]:={{}};Tuples[ll_List,n_]:=Partition[Flatten[Outer[List,Sequence@@Table[ll,{jj,1,n}]]],n]]


HPL1/: Derivative[mm_List,1][HPL1]:=If[MatchQ[#2,0],If[Not[#1[[-1]]==0],If[1>=Length[#1],HPL`Private`S[#1,1],0],Log[0]],DerofHPL1[#1,#2]]&/;MatchQ[mm,Table[0,{j,1,Length[mm]}]]&&ArrayQ[mm,1,IntegerQ]


HPL1/: Derivative[0,1][HPL1]:=If[MatchQ[#2,0],If[Not[#1[[-1]]==0],If[1>=Length[#1],HPL`Private`S[#1,1],0],Log[0]],DerofHPL1[#1,#2]]&


HPL1/: Derivative[mm_List,n_Integer?Positive][HPL1]:=If[#2==0,If[Not[#1[[-1]]==0],If[n>=Length[#1],n! HPL`Private`S[#1,n],0],Log[0]],Derivative[0,1][Derivative[mm,n-1][HPL1]][#1,#2]]&/;n>1&&MatchQ[mm,Table[0,{j,1,Length[mm]}]]


HPL1/: Derivative[0,n_Integer?Positive][HPL1]:=If[#2==0,If[Not[#1[[-1]]==0],If[n>=Length[#1],n! HPL`Private`S[#1,n],0],Log[0]],Derivative[0,1][Derivative[0,n-1][HPL2]][#1,#2]]&/;n>1


DerofHPL1:=Switch[
Length[#1],
	0,0,
	1,Switch[#1[[1]],
		0,1/2 xpart1[-2,0,#2],
		1,1/2 xpart1[-1,1,#2]+1/2 xpart1[0,1,#2],
		-1,1/2 xpart1[-1,1,#2]-1/2 xpart1[0,1,#2],
		plus,xpart1[-1,1,#2],
		minus,xpart1[0,1,#2],
		sq,xpart1[-1,1/2,#2],
		sq2,xpart1[-2,1/2,#2],
		n_Integer?Positive,1/2 xpart1[-2,0,#2] HPL2[{#1[[1]]-1},#2],
		n_Integer?Negative,1/2 xpart1[-2,0,#2] HPL2[{#1[[1]]+1},#2],
		_,$HPLDerivativeFailed
	],
	_,Switch[#1[[1]],
		0,1/2 xpart1[-2,0,#2] HPL1[Delete[#1,1],#2],
		1,(1/2 xpart1[-1,1,#2]+1/2 xpart1[0,1,#2]) HPL1[Delete[#1,1],#2],
		-1,(1/2 xpart1[-1,1,#2]-1/2 xpart1[0,1,#2]) HPL1[Delete[#1,1],#2],
plus,xpart1[-1,1,#2] HPL1[Delete[#1,1],#2],
		minus,xpart1[0,1,#2] HPL1[Delete[#1,1],#2],
		sq,xpart1[-1,1/2,#2] HPL1[Delete[#1,1],#2],
		sq2,xpart1[-2,1/2,#2]HPL1[Delete[#1,1],#2],
		n_Integer?Positive,  1/2 xpart1[-2,0,#2]HPL1[ReplacePart[#1,#1[[1]]-1,1],#2],
		n_Integer?Negative,1/2 xpart1[-2,0,#2] HPL1[ReplacePart[#1,#1[[1]]+1,1],#2],
		_,$HPLDerivativeFailed
	]
]&/;$HPLUsexpart


$HPLUsexpart=True


HPL2/:Derivative[mm_List,1][HPL2]:=If[MatchQ[#2,0],If[Not[#1[[-1]]==0],If[1>=Length[#1],HPL`Private`S[#1,1],0],Log[0]],DerofHPL2[#1,#2]]&/;MatchQ[mm,Table[0,{j,1,Length[mm]}]]&&ArrayQ[mm,1,IntegerQ]


HPL2/:Derivative[0,1][HPL2]:=If[MatchQ[#2,0],If[Not[#1[[-1]]==0],If[1>=Length[#1],HPL`Private`S[#1,1],0],Log[0]],DerofHPL2[#1,#2]]&


HPL2/:Derivative[mm_List,n_Integer?Positive][HPL2]:=If[#2==0,If[Not[#1[[-1]]==0],If[n>=Length[#1],n! HPL`Private`S[#1,n],0],Log[0]],Derivative[0,1][Derivative[mm,n-1][HPL2]][#1,#2]]&/;n>1&&MatchQ[mm,Table[0,{j,1,Length[mm]}]]


HPL2/:Derivative[mm_List,n_Integer?Positive][HPL2]:=If[#2==0,If[Not[#1[[-1]]==0],If[n>=Length[#1],n! HPL`Private`S[#1,n],0],Log[0]],Derivative[0,1][Derivative[mm,n-1][HPL2]][#1,#2]]&/;n>1&&MatchQ[mm,Table[0,{j,1,Length[mm]}]]


HPL2/:Derivative[mm_List,n_Integer?Positive][HPL2]:=If[#2==0,If[Not[#1[[-1]]==0],If[n>=Length[#1],n! HPL`Private`S[#1,n],0],Log[0]],Derivative[0,1][Derivative[mm,n-1][HPL2]][#1,#2]]&/;n>1&&MatchQ[mm,Table[0,{j,1,Length[mm]}]]


DerofHPL2:=-(1/2) xpart[-1,3,#2] Switch[
Length[#1],
	0,0,
	1,Switch[#1[[1]],
		0,xpart[-1,-1,#2],
		1,-xpart[0,-2,#2]-xpart[1,-1,#2],
		-1,-xpart[0,-2,#2]+xpart[1,-1,#2],
		plus,-2 xpart[0,-2,#2],
		minus,-2 xpart[1,-1,#2],
		sq,-I xpart[0,-1,#2],
		sq2,-I xpart[-1,-2,#2],
		n_Integer?Positive,xpart[-1,-1,#2] HPL2[{#1[[1]]-1},#2],
		n_Integer?Negative,xpart[-1,-1,#2]  HPL2[{#1[[1]]+1},#2],
		_,$HPLDerivativeFailed
	],
	_,Switch[#1[[1]],
		0,xpart[-1,-1,#2] HPL2[Delete[#1,1],#2],
		1,(-xpart[0,-2,#2]-xpart[1,-1,#2]) HPL2[Delete[#1,1],#2],
		-1,(-xpart[0,-2,#2]+xpart[1,-1,#2]) HPL2[Delete[#1,1],#2],
plus,-2 xpart[0,-2,#2] HPL2[Delete[#1,1],#2],
		minus,-2 xpart[1,-1,#2] HPL2[Delete[#1,1],#2],
		sq,-I xpart[0,-1,#2]  HPL2[Delete[#1,1],#2],
		sq2,-I xpart[-1,-2,#2] HPL2[Delete[#1,1],#2],
		n_Integer?Positive, xpart[-1,-1,#2] HPL2[ReplacePart[#1,#1[[1]]-1,1],#2],
		n_Integer?Negative,xpart[-1,-1,#2] HPL2[ReplacePart[#1,#1[[1]]+1,1],#2],
		_,$HPLDerivativeFailed
	]
]&/;$HPLUsexpart


$HPLUsexpart=True


HPL32HPLrule=HPL3[mm_,x_]:>HPL[mm,(1-Sqrt[1-x])/(1+Sqrt[1-x])]


HPL3/:Derivative[mm_List,1][HPL3]:=If[MatchQ[#2,0],If[Not[#1[[-1]]==0],If[1>=Length[#1],HPL`Private`S[#1,1],0],Log[0]],DerofHPL3[#1,#2]]&/;MatchQ[mm,Table[0,{j,1,Length[mm]}]]&&ArrayQ[mm,1,IntegerQ]

HPL3/:Derivative[0,1][HPL3]:=If[MatchQ[#2,0],If[Not[#1[[-1]]==0],If[1>=Length[#1],HPL`Private`S[#1,1],0],Log[0]],DerofHPL3[#1,#2]]&

HPL3/:Derivative[mm_List,n_Integer?Positive][HPL3]:=If[#2==0,If[Not[#1[[-1]]==0],If[n>=Length[#1],n! HPL`Private`S[#1,n],0],Log[0]],Derivative[0,1][Derivative[mm,n-1][HPL3]][#1,#2]]&/;n>1&&MatchQ[mm,Table[0,{j,1,Length[mm]}]]

HPL3/:Derivative[0,n_Integer?Positive][HPL3]:=If[#2==0,If[Not[#1[[-1]]==0],If[n>=Length[#1],n! HPL`Private`S[#1,n],0],Log[0]],Derivative[0,1][Derivative[0,n-1][HPL3]][#1,#2]]&/;n>1

DerofHPL3:=Switch[Length[#1],
0,0,
1,Switch[#1[[1]],
0,xpart1[-2,1/2,#2],
1,(xpart1[-2,1,#2]-xpart1[-2,1/2,#2])/2,
-1,(-xpart1[-2,0,#2]+xpart1[-2,1/2,#2])/2,
plus,(xpart1[-2,1,#2]-xpart1[-2,0,#2])/2,
minus,(xpart1[-2,1,#2]-2 xpart1[-2,1/2,#2]+xpart1[-2,0,#2])/2,
sq,$Failed,
sq2,$Failed,
n_Integer?Positive,xpart1[-2,1/2,#2] HPL3[{#1[[1]]-1},#2],
n_Integer?Negative,xpart1[-2,1/2,#2] HPL3[{#1[[1]]+1},#2],_,$HPLDerivativeFailed],
_,Switch[#1[[1]],
0,xpart1[-2,1/2,#2] HPL3[Delete[#1,1],#2],1,(xpart1[-2,1,#2]-xpart1[-2,1/2,#2])/2 HPL3[Delete[#1,1],#2],
-1,(-xpart1[-2,0,#2]+xpart1[-2,1/2,#2])/2 HPL3[Delete[#1,1],#2],
plus,(xpart1[-2,1,#2]-xpart1[-2,0,#2])/2  HPL3[Delete[#1,1],#2],
minus,(xpart1[-2,1,#2]-2 xpart1[-2,1/2,#2]+xpart1[-2,0,#2])/2 HPL3[Delete[#1,1],#2],sq,$Failed,
sq2,$Failed,
n_Integer?Positive,xpart1[-2,1/2,#2] HPL3[ReplacePart[#1,#1[[1]]-1,1],#2],n_Integer?Negative,xpart1[-2,1/2,#2]  HPL3[ReplacePart[#1,#1[[1]]+1,1],#2],_,$HPLDerivativeFailed]]&/;$HPLUsexpart

$HPLUsexpart=True



xpart/:xpart[j1_,k1_,x___] xpart[j2_,k2_,x___]:=xpart[j1+j2,k1+k2,x]


xpart/:Derivative[0,0,1][xpart]:=#1/2 xpart[#1-2,#2,#3]-#2/2 xpart[#1,#2+2,#3]&


xpart/:xpart[j1_,k1_,x___]^exp_:=xpart[exp j1,exp k1,x]


xpartrule=Module[{j,k},xpart[j_,k_,x_:x]:>(Sqrt[x])^(j-k) (Sqrt[x/(x-1)])^k]


x2xpartrule={ 1/ Sqrt[1-x/(-1+x)]:>-I xpart[0,-1],1/(1-x/(-1+x)):>xpart[0,0]-xpart[2,0], Sqrt[x/(-1+x)]:>xpart[1,1],1/ Sqrt[x/(-1+x)]->xpart[-1,-1],(-1+x)^k_.:>xpart[0,-2 k],(x)^j_:>xpart[2 j,0],x xpart[j_,k_,x]:>xpart[j+2,k,x],x xpart[j_,k_]:>xpart[j+2,k]};


xpartRedRule={xpart[j_,k_Integer?(EvenQ[#]&&Negative[#]&),x___]:>xpart[j,k+2,x]+xpart[j+2,k+2,x]};


ypart/:ypart[j1_,k1_,y___] ypart[j2_,k2_,y___]:=ypart[j1+j2,k1+k2,y]


ypart/:ypart[j1_,k1_,y___]^exp_:=ypart[exp j1,exp k1,y]


ypartrule=Module[{k,j},ypart[j_,k_,y_:y]:>y^j/(1-y^2)^k];


ypart0[j_Integer?Positive,k_]:=0;
ypart0[j_,k_]:=Module[{t},(ypart[j,k,t]/.ypartrule//Apart)/.t^(_Integer?Negative)->0/.t->0]


(*xpart2rule=xpart[j_,k_,x_:x]:>Sqrt[x]^j (1/Sqrt[1-x])^k (I)^k;*)


xpart2rule=xpart[j_,k_,x_:x]:>Sqrt[x]^(j-k) I^k Sqrt[x/(1-x)]^k


xpart1rule=xpart1[j_,k_,x_:x]:>Sqrt[x]^j/(1-x)^k;


xpart1/:xpart1[j1_,k1_,x___] xpart1[j2_,k2_,x___]:=xpart1[j1+j2,k1+k2,x]


xpart1/:Derivative[0,0,1][xpart1]:=#1/2 xpart1[#1-2,#2,#3]+#2 xpart1[#1,#2+1,#3]&


xpart1/:xpart1[j1_,k1_,x___]^exp_:=xpart1[exp j1,exp k1,x]


x2xpart1rule={Sqrt[x]/(-1+x):>-xpart1[1,1,x],(1/(-1+x)):>-xpart1[0,1,x],(-1+x)^j_:>(-1)^j xpart1[0,-j,x],(1-x)^j_:>xpart1[0,-j,x],Sqrt[x]/(-1+Sqrt[x]):>-xpart1[1,1,x]-xpart1[2,1,x],Sqrt[x]/(1+Sqrt[x]):>xpart1[1,1,x]-xpart1[2,1,x],(1/(1-x)):>xpart1[0,1,x],x^j_.:>xpart1[2 j,0,x]};


plusorminus[j_]:=If[EvenQ[j],plus,minus]


Clear[LL]


LL[j_Integer?Positive,Log,y_:y]:=1/(j+1)(-ypart[j+1,0,y] HPL`Private`HH[minus]+(HPL`Private`HH[plusorminus[j]]-Sum[(1+(-1)^(l+j+1)) ypart[l,0,y]/l,{l,1,j+1}]))


LL[0,Log,y_:y]:=-2 ypart[1,0,y]-ypart[1,0,y] HPL`Private`HH[minus]+HPL`Private`HH[plus]


LL[j_Integer?Negative,Log,y_:y]:=1/(j+1)(ypart[j+1,0,y] (-HPL`Private`HH[minus])+(1+(-1)^(-j-1)) HPL`Private`HH[0]+(HPL`Private`HH[plusorminus[j]]+Sum[(1+(-1)^(l)) ypart[l+j+1,0,y]/(l+j+1),{l,1,-j-2}]))


LL[0,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[-1,k-1,y]+LL[-2,k-2,y]+LL[0,k-1,y])


LL[1,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[0,k-1,y]-1)


LL[j_Integer,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[j-1,k-1,y]-ypart0[j-1,k-1]-(j-1) LL[j-2,k-1,y])


LL[j_Integer,1,y_:y]:=-1/2 (ypart[j-1,0,y] (-HPL`Private`HH[minus])-(j-1) LL[j-2,Log,y])


LL[-1,0,y_:y]:=HPL`Private`HH[0]


LL[j_Integer,0,y_:y]:=1/(j+1)ypart[j+1,0,y]


LL[-1,1,y_:y]:=HPL`Private`HH[minus]/2+HPL`Private`HH[0]


LL[1,1,y_:y]:=HPL`Private`HH[minus]/2


LL[0,1,y_:y]:=HPL`Private`HH[plus]/2


LL[-1,Log,y_:y]:=-HPL`Private`HH[0,minus]


LL[j_,k_Integer?Negative,y_:y]:=Sum[Binomial[-k,kk] (-1)^kk  LL[j+2 kk,0,y],{kk,0,-k}]


LL[0,-1/2,y_:y]:=1/2 (ypart[1,-1/2,y]+HPL`Private`HH[sq])


LL[1,1/2,y_:y]:=-ypart[0,-1/2,y]


LL[0,1/2,y_:y]:=HPL`Private`HH[sq]


LL[0,3/2,y_:y]:=ypart[1,1/2,y]


LL[-1,-(1/2),y_:y]:=ypart[0,-1/2,y]+HPL`Private`HH[sq2]


LL[-1,1/2,y_:y]:=HPL`Private`HH[sq2]


LL[1,Rational[k_,2],y_:y]:=-ypart[0,(k-2)/2,y]/(2-k)


LL[0,Rational[k_?Positive,2],y_:y]:=LL[0,Rational[k-2,2],y]+ypart[1,0,y] LL[1,k/2,y]+LL[0,(k-2)/2,y]/(2-k)


LL[0,Rational[k_Integer?Negative,2],y_:y]:=1/(-k+1) (ypart[1,k/2,y]-k LL[0,(k+2)/2])


LL[j_Integer?Positive,Rational[k_Integer,2],y_:y]:=-ypart[j-1,(k-2)/2,y]/(2-k)+ (j-1)/(2-k)  LL[j-2,(k-2)/2,y]


LL[j_Integer?(#<-1&),Rational[k_Integer,2],y_:y]:=ypart[j+1,k/2,y]/(j+1)- k/(j+1)  LL[j+2,(k+2)/2,y]


LL[-1,Rational[k_Integer?(#<=-1&),2],y_:y]:= LL[-1,(k+2)/2,y]-LL[1,(k+2)/2,y]


LL[-1,Rational[k_Integer?(#>-1&),2],y_:y]:= LL[1,k/2,y]+LL[-1,(k-2)/2,y]


LL[j_,k_Integer?Negative]:=Sum[Binomial[-k,kk] (-1)^kk  LL[j+2 kk,0],{kk,0,-k}]


Clear[myint]


myint[0]=0;


myint[p_Plus]:=myint/@p


myint[ypart[j_,k_,y_:y] HPL`Private`HH[mm__],jadd_:0]:=II[j+jadd,k,{mm}]
myint[ypart[j_,k_,y_:y],jadd_:0]:=LL[j+jadd,k,y]


myint[coeff___ ypart[j_,k_,y_:y] HPL`Private`HH[mm__],jadd_:0]:=coeff II[j+jadd,k,{mm}]
myint[coeff___ ypart[j_,k_,y_:y],jadd_:0]:=coeff LL[j+jadd,k,y]


myint[coeff___ ypart[j_,k_,y_:y],jadd_:0]:=coeff LL[j+jadd,k,y]


myint[coeff___ HPL`Private`HH[plus]]:=coeff (ypart[1,0,y] HPL`Private`HH[plus]-2 myint[ypart[1,1,y]])
myint[coeff___ HPL`Private`HH[minus]]:= coeff (ypart[1,0,y] HPL`Private`HH[minus]-2 myint[ypart[2,1,y]])
myint[coeff___ HPL`Private`HH[0]]:=coeff (ypart[1,0,y] HPL`Private`HH[0]-ypart[1,0,y])


myint[coeff___ HPL`Private`HH[plus,mm__]]:=coeff (ypart[1,0,y] HPL`Private`HH[plus,mm]-2 myint[ypart[1,1,y]  HPL`Private`HH[mm]])
myint[coeff___ HPL`Private`HH[minus,mm__]]:=coeff (ypart[1,0,y] HPL`Private`HH[minus,mm]-2 myint[ypart[2,1,y] HPL`Private`HH[mm]])
myint[coeff___ HPL`Private`HH[0,mm__]]:=coeff (ypart[1,0,y] HPL`Private`HH[0,mm]-myint[HPL`Private`HH[mm]])


LLHPL0[j_Integer?Negative,k_,mm_List]:=Module[{t},SeriesCoefficient[(Apart[LL[j,k,t]/.ypart[jj_,kk_,y_:y]:>ypart[jj,kk,t]/.ypartrule,t] /.HPL`Private`HH[0]->0)(Series[HPL[mm,t],{t,0,-j}]/.{HPL[{0},t]->0,Log[t]->0})//Expand,0]]


LLHPL0[j_Integer?NonNegative,k_,mm_List]:=0


II[0,1,{mm__}]:=HPL`Private`HH[plus,mm]/2
II[1,1,{mm__}]:=HPL`Private`HH[minus,mm]/2
II[-1,0,{mm__}]:=HPL`Private`HH[0,mm]


II[j_Integer,k_Integer,{plus}]:=LL[j,k] HPL`Private`HH[plus]-LLHPL0[j,k,{plus}]-myint[LL[j,k] 2 ypart[0,1,y]//HPL`Private`HProductExpand]
II[j_Integer,k_Integer,{minus}]:=LL[j,k] HPL`Private`HH[minus]-LLHPL0[j,k,{minus}]-myint[LL[j,k] 2 ypart[1,1,y]//HPL`Private`HProductExpand]
II[j_Integer,k_Integer,{0}]:=LL[j,k] HPL`Private`HH[0]-LLHPL0[j,k,{0}]-myint[LL[j,k] ypart[-1,0,y]//HPL`Private`HProductExpand]


II[j_Integer,k_Integer,{plus,mm__}]:=LL[j,k,y] HPL`Private`HH[plus,mm]-LLHPL0[j,k,{plus,mm}]-myint[LL[j,k,y] 2 ypart[0,1,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II[j_Integer,k_Integer,{minus,mm__}]:=LL[j,k] HPL`Private`HH[minus,mm]-LLHPL0[j,k,{minus,mm}]-myint[LL[j,k] 2 ypart[1,1,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II[j_Integer,k_Integer,{0,mm__}]:=LL[j,k] HPL`Private`HH[0,mm]-LLHPL0[j,k,{0,mm}]-myint[LL[j,k] ypart[-1,0,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II[j_Integer,k_Integer,{sq,mm__}]:=LL[j,k] HPL`Private`HH[sq,mm]-myint[LL[j,k] ypart[0,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II[j_Integer,k_Integer,{sq2,mm__}]:=LL[j,k] HPL`Private`HH[sq2,mm]-myint[LL[j,k] ypart[-1,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II[0,1/2,{mm__}]:=HPL`Private`HH[sq,mm]


II[-1,1/2,{mm__}]:=HPL`Private`HH[sq2,mm]


II[j_,k_,{1,mm___}]:=(II[j,k,{plus,mm}]+II[j,k,{minus,mm}])/2
II[j_,k_,{-1,mm___}]:=(II[j,k,{plus,mm}]-II[j,k,{minus,mm}])/2


II[j_Integer,k_Rational,{plus}]:=LL[j,k] HPL`Private`HH[plus]-myint[LL[j,k] 2 ypart[0,1,y]//HPL`Private`HProductExpand]
II[j_Integer,k_Rational,{minus}]:=LL[j,k] HPL`Private`HH[minus]-myint[LL[j,k] 2  ypart[1,1,y]//HPL`Private`HProductExpand]
II[j_Integer,k_Rational,{0}]:=LL[j,k] HPL`Private`HH[0]-myint[LL[j,k] ypart[-1,0,y]//HPL`Private`HProductExpand]


II[j_Integer,k_Rational,{plus,mm__}]:=LL[j,k] HPL`Private`HH[plus,mm]-myint[LL[j,k,y] 2 ypart[0,1,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II[j_Integer,k_Rational,{minus,mm__}]:=LL[j,k] HPL`Private`HH[minus,mm]-myint[LL[j,k] 2  ypart[1,1,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II[j_Integer,k_Rational,{0,mm__}]:=LL[j,k] HPL`Private`HH[0,mm]-myint[LL[j,k] ypart[-1,0,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II[j_Integer,k_Rational,{sq,mm__}]:=LL[j,k,y] HPL`Private`HH[sq,mm]-myint[LL[j,k] ypart[0,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II[j_Integer,k_Rational,{sq2,mm__}]:=LL[j,k,y] HPL`Private`HH[sq2,mm]-myint[LL[j,k,y] ypart[-1,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


HPLInt1[sum_Plus,jadd_:0]:=HPLInt1[#,jadd]&/@sum


HPLInt1[coeff___?(FreeQ[#,x]&) xpart1[j_,k_,x_:x],jadd_:0]:=HPL`Private`HProductExpand[coeff (2)  LL[j+jadd+1,k]/.ypart[jj_,kk_,y_:y]->xpart1[jj,kk,x]]/.HPL`Private`HH[mm__]->HPL1[{mm},x]


HPLInt1[xpart1[j_,k_,x_:x],jadd_:0]:=HPL`Private`HProductExpand[2 LL[1+jadd+j,k]/.ypart[jj_,kk_,y_:y]->xpart1[jj, kk,x]]/.HPL`Private`HH[mm__]->HPL1[{mm},x]


HPLInt1[coeff_?(FreeQ[#,x]&) ,-2]:=coeff 2 HPL1[{0},x]


HPLInt1[coeff___?(FreeQ[#,x]&),jadd_:0]:=coeff xpart1[jadd+2,0,x]/(jadd/2+1)


HPLInt1[coeff___?(FreeQ[#,x]&) xpart1[j_,k_,x_:x] HPL1[mm_List,x],jadd_:0]:=HPL`Private`HProductExpand[(2  coeff II[1+jadd+j,k,mm]/.ypart[jjj_,kkk_,y_:y]->xpart1[jjj,kkk,x])]/.HPL`Private`HH[mmm__]->HPL1[{mmm},x]


HPLInt1[coeff___?(FreeQ[#,x]&)  HPL1[mm_List,x],jadd_:0]:=HPL`Private`HProductExpand[2  coeff II[1+jadd,0,mm]/.ypart[j_,k_,y_:y]->xpart1[j, k,x]]/.HPL`Private`HH[mmm__]->HPL1[{mmm},x]


HPLInt1[HPL1[mm_List,x],jadd_:0]:=HPL`Private`HProductExpand[2 II[1+jadd,0,mm]/.ypart[j_,k_,y_:y]->xpart1[j, k,x]]/.HPL`Private`HH[mmm__]->HPL1[{mmm},x]


HPL2HPL1rule=HPL[m_,Sqrt[x]]->HPL1[m,x];


HPL12HPLrule=HPL1[m_,x_]->HPL[m,Sqrt[x]];


HPLInt2[sum_Plus,jadd_:0]:=HPLInt2[#,jadd]&/@sum


HPLInt2[coeff___?(FreeQ[#,x]&) xpart[j_,k_,x_:x],jadd_:0]:=HPL`Private`HProductExpand[coeff (-2) (I)^(jadd+j-k)  LL[k+1+jadd+j-k,2+(jadd+j-k)/2]/.ypart[jj_,kk_,y_:y]->xpart[jj,jj-2 kk,x] (-I)^(2 kk)]/.HPL`Private`HH[mmm__]->HPL2[{mmm},x]


HPLInt2[xpart[j_,k_,x_:x],jadd_:0]:=(-2) (I)^(jadd+j-k)  LL[k+1+jadd+j-k,2+(jadd+j-k)/2]/.ypart[jj_,kk_,y_:y]->xpart[jj,jj-2 kk,x] (-I)^(2 kk)/.y->Sqrt[x/(x-1)]//HPL`Private`HProductExpand


HPLInt2[coeff_?(FreeQ[#,x]&) ,-2]:=coeff (2 HPL2[{0},x]+HPL2[{minus},x])


HPLInt2[coeff___?(FreeQ[#,x]&),jadd_:0]:=coeff xpart[jadd+2,0,x]/(jadd/2+1)


HPLInt2[coeff___?(FreeQ[#,x]&) xpart[j_,k_,x_:x] HPL2[mm_List,x],jadd_:0]:=HPL`Private`HProductExpand[-2 (I)^(jadd+j-k) coeff II[k+1+jadd+j-k,2+(jadd+j-k)/2,mm]/.ypart[jjj_,kkk_,y_:y]->xpart[jjj,jjj-2 kkk,x] (-I)^(2 kkk)]/.HPL`Private`HH[mmm__]->HPL2[{mmm},x]


HPLInt2[coeff___?(FreeQ[#,x]&)  HPL2[mm_List,x],jadd_:0]:=HPL`Private`HProductExpand[-2 (I)^jadd coeff II[1+jadd,2+jadd/2,mm]/.ypart[j_,k_,y_:y]->xpart[j,j-2 k,x] (-I)^(2 k)]/.HPL`Private`HH[mmm__]->HPL2[{mmm},x]


HPLInt2[HPL2[mm_List,x],jadd_:0]:=HPL`Private`HProductExpand[-2 (I)^jadd  II[1+jadd,2+jadd/2,mm]/.ypart[j_,k_,y_:y]->xpart[j,j-2 k,x] (-I)^(2 k)]/.HPL`Private`HH[mmm__]->HPL2[{mmm},x]


HPL2HPL2rule=HPL[m_,Sqrt[x/(-1+x)]]->HPL2[m,x];


HPL22HPLrule=HPL2[m_,x_]-> HPL[m,I Sqrt[x/(1-x)]];


Clear[myint2]


myint2[0]=0;
myint2[1]=ypart[1,0,y];


myint2[p_Plus]:=myint2/@p


myint2[ypart[j_,k_,y_:y] HPL`Private`HH[mm__],jadd_:0]:=II2[j+jadd,k,{mm}]
myint2[ypart[j_,k_,y_:y],jadd_:0]:=LL2[j+jadd,k,y]


myint2[coeff___ ypart[j_,k_,y_:y] HPL`Private`HH[mm__],jadd_:0]:=coeff II2[j+jadd,k,{mm}]
myint2[coeff___ ypart[j_,k_,y_:y],jadd_:0]:=coeff LL2[j+jadd,k,y]


myint2[coeff___ ypart[j_,k_,y_:y],jadd_:0]:=coeff LL2[j+jadd,k,y]


myint2[coeff___ HPL`Private`HH[]]:=coeff (ypart[1,0,y] HPL`Private`HH[plus]-2 myint[ypart[1,1,y]])
myint[coeff___ HPL`Private`HH[minus]]:= coeff (ypart[1,0,y] HPL`Private`HH[minus]-2 myint[ypart[2,1,y]])
myint[coeff___ HPL`Private`HH[0]]:=coeff (ypart[1,0,y] HPL`Private`HH[0]-ypart[1,0,y])


myint[HPL`Private`HH[plus]]:=(ypart[1,0,y] HPL`Private`HH[plus]-2 myint[ypart[1,1,y]])
myint[HPL`Private`HH[minus]]:= (ypart[1,0,y] HPL`Private`HH[minus]-2 myint[ypart[2,1,y]])
myint[HPL`Private`HH[0]]:=(ypart[1,0,y] HPL`Private`HH[0]-ypart[1,0,y])


myint[coeff___ HPL`Private`HH[plus,mm__]]:=coeff (ypart[1,0,y] HPL`Private`HH[plus,mm]-2 myint[ypart[1,1,y]  HPL`Private`HH[mm]])
myint[coeff___ HPL`Private`HH[minus,mm__]]:=coeff (ypart[1,0,y] HPL`Private`HH[minus,mm]-2 myint[ypart[2,1,y] HPL`Private`HH[mm]])
myint[coeff___ HPL`Private`HH[0,mm__]]:=coeff (ypart[1,0,y] HPL`Private`HH[0,mm]-myint[HPL`Private`HH[mm]])


plusorminus[j_]:=If[EvenQ[j],plus,minus]


LL2[j_Integer?Positive,Log,y_:y]:=1/(j+1)(-ypart[j+1,0,y]( HPL`Private`HH[1]-HPL`Private`HH[-1]) +(HPL`Private`HH[1]+(-1)^j HPL`Private`HH[-1]-Sum[(1+(-1)^(l+j+1)) ypart[l,0,y]/l,{l,1,j+1}]))


LL2[0,Log,y_:y]:=-2 ypart[1,0,y]-ypart[1,0,y] (HPL`Private`HH[1]-HPL`Private`HH[-1])+HPL`Private`HH[1]+HPL`Private`HH[-1]


LL2[j_Integer?Negative,Log,y_:y]:=1/(j+1)(ypart[j+1,0,y] (HPL`Private`HH[-1]-HPL`Private`HH[1])+(1+(-1)^(-j-1)) HPL`Private`HH[0]+(HPL`Private`HH[1]+(-1)^j HPL`Private`HH[-1]+Sum[(1+(-1)^(l)) ypart[l+j+1,0,y]/(l+j+1),{l,1,-j-2}]))


LL2[0,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[-1,k-1,y]+LL2[-2,k-2,y]+LL2[0,k-1,y])


LL2[1,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[0,k-1,y]-1)


LL2[j_Integer,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[j-1,k-1,y]-ypart0[j-1,k-1]-(j-1) LL2[j-2,k-1,y])


LL2[j_Integer,1,y_:y]:=-1/2 (ypart[j-1,0,y] (HPL`Private`HH[-1]-HPL`Private`HH[1])-(j-1) LL2[j-2,Log,y])


LL2[-1,0,y_:y]:=HPL`Private`HH[0]


LL2[j_Integer,0,y_:y]:=1/(j+1)ypart[j+1,0,y]


LL2[-1,1,y_:y]:=(HPL`Private`HH[1]-HPL`Private`HH[-1])/2+HPL`Private`HH[0]


LL2[1,1,y_:y]:=(HPL`Private`HH[1]-HPL`Private`HH[-1])/2


LL2[0,1,y_:y]:=(HPL`Private`HH[1]+HPL`Private`HH[-1])/2


LL2[-1,Log,y_:y]:=(HPL`Private`HH[-1]-HPL`Private`HH[1])


LL2[j_,k_Integer?Negative,y_:y]:=Sum[Binomial[-k,kk] (-1)^kk  LL2[j+2 kk,0,y],{kk,0,-k}]


LL2[Rational[j_?(#>-3&),2],Log,y_:y]:=1/(j+2)(2 (  HPL`Private`HH[sq3]+(-1)^((j+1)/2)HPL`Private`HH[sq4]) -4 Sum[(1+(-1)^(l+(j-1)/2)) ypart[(2 l-1)/2,0,y]/(2 l-1),{l,1,(j+3)/2}]-2  ypart[(j+2)/2,0,y]  (HPL`Private`HH[1]-HPL`Private`HH[-1]) )


LL2[Rational[j_?(#<=-3&),2],Log,y_:y]:=1/(j+2)(2 (  HPL`Private`HH[sq3]+(-1)^((j+1)/2)HPL`Private`HH[sq4]) +4 Sum[(1+(-1)^(l+(j-1)/2)) ypart[(2 l-1)/2,0,y]/(2 l-1),{l,(j+5)/2,0}]-2  ypart[(j+2)/2,0,y]  (HPL`Private`HH[1]-HPL`Private`HH[-1]) )


LL2[0,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[-1,k-1,y]+LL2[-2,k-2,y]+LL2[0,k-1,y])


LL2[1,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[0,k-1,y]-1)


LL2[j_,k_Integer?(#>1&),y_:y]:=1/2/(k-1)(ypart[j-1,k-1,y]-ypart0[j-1,k-1]-(j-1) LL2[j-2,k-1,y])


LL2[j_,1,y_:y]:=-1/2 (ypart[j-1,0,y] (HPL`Private`HH[-1]-HPL`Private`HH[1])-(j-1) LL2[j-2,Log,y])


LL2[j_,0,y_:y]:=1/(j+1)ypart[j+1,0,y]


LL2[j_,k_Integer?Negative,y_:y]:=Sum[Binomial[-k,kk] (-1)^kk  LL2[j+2 kk,0,y],{kk,0,-k}]


Clear[II2]


II2[0,1,{mm__}]:=(HPL`Private`HH[1,mm]+HPL`Private`HH[-1,mm])/2
II2[1,1,{mm__}]:=(HPL`Private`HH[1,mm]-HPL`Private`HH[-1,mm])/2
II2[-1,0,{mm__}]:=HPL`Private`HH[0,mm]


II2[j_Integer,k_Integer,{1}]:=LL2[j,k] HPL`Private`HH[1]-LLHPL0[j,k,{1}]-myint2[LL2[j,k] (ypart[0,1,y]+ypart[1,1,y])//HPL`Private`HProductExpand]
II2[j_Integer,k_Integer,{-1}]:= LL2[j,k] HPL`Private`HH[-1]-LLHPL0[j,k,{-1}]-myint2[LL2[j,k] (ypart[0,1,y]-ypart[1,1,y])//HPL`Private`HProductExpand]
II2[j_Integer,k_Integer,{0}]:=LL2[j,k] HPL`Private`HH[0]-LLHPL0[j,k,{0}]-myint2[LL2[j,k] ypart[-1,0,y]//HPL`Private`HProductExpand]


II2[j_Integer,k_Integer,{1,mm__}]:=LL2[j,k,y] HPL`Private`HH[1,mm]-LLHPL0[j,k,{1,mm}]-myint2[LL2[j,k,y] (ypart[0,1,y]+ypart[1,1,y]) HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II2[j_Integer,k_Integer,{-1,mm__}]:=LL2[j,k] HPL`Private`HH[-1,mm]-LLHPL0[j,k,{-1,mm}]-myint2[LL2[j,k] (ypart[0,1,y]-ypart[1,1,y]) HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II2[j_Integer,k_Integer,{0,mm__}]:=LL2[j,k] HPL`Private`HH[0,mm]-LLHPL0[j,k,{0,mm}]-myint2[LL2[j,k] ypart[-1,0,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II2[j_Integer,k_Integer,{sq,mm__}]:=LL2[j,k] HPL`Private`HH[sq,mm]-myint2[LL2[j,k] ypart[0,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II2[j_Integer,k_Integer,{sq2,mm__}]:=LL2[j,k] HPL`Private`HH[sq2,mm]-myint2[LL2[j,k] ypart[-1,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


LLHPL0[j_?Negative,k_,mm_List]:=Module[{t},SeriesCoefficient[(Apart[LL[j,k,t]/.ypart[jj_,kk_,y_:y]:>ypart[jj,kk,t]/.ypartrule,t] /.HPL`Private`HH[0]->0)(Series[HPL[mm,t],{t,0,-2 j}]/.{HPL[{0},t]->0,Log[t]->0})//Expand,0]]


LLHPL0[j_?NonNegative,k_,mm_List]:=0


II2[j_,k_Integer,{1}]:=LL2[j,k] HPL`Private`HH[1]-LLHPL0[j,k,{1}]-myint2[LL2[j,k] (ypart[0,1,y]+ypart[1,1,y])//HPL`Private`HProductExpand]
II2[j_,k_Integer,{-1}]:= LL2[j,k] HPL`Private`HH[-1]-LLHPL0[j,k,{-1}]-myint2[LL2[j,k] (ypart[0,1,y]-ypart[1,1,y])//HPL`Private`HProductExpand]
II2[j_,k_Integer,{0}]:=LL2[j,k] HPL`Private`HH[0]-LLHPL0[j,k,{0}]-myint2[LL2[j,k] ypart[-1,0,y]//HPL`Private`HProductExpand]


II2[j_,k_Integer,{1,mm__}]:=LL2[j,k,y] HPL`Private`HH[1,mm]-LLHPL0[j,k,{1,mm}]-myint2[LL2[j,k,y] (ypart[0,1,y]+ypart[1,1,y]) HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II2[j_,k_Integer,{-1,mm__}]:=LL2[j,k] HPL`Private`HH[-1,mm]-LLHPL0[j,k,{-1,mm}]-myint2[LL2[j,k] (ypart[0,1,y]-ypart[1,1,y]) HPL`Private`HH[mm]//HPL`Private`HProductExpand]
II2[j_,k_Integer,{0,mm__}]:=LL2[j,k] HPL`Private`HH[0,mm]-LLHPL0[j,k,{0,mm}]-myint2[LL2[j,k] ypart[-1,0,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II2[j_,k_Integer,{sq,mm__}]:=LL2[j,k] HPL`Private`HH[sq,mm]-myint2[LL2[j,k] ypart[0,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II2[j_,k_Integer,{sq2,mm__}]:=LL2[j,k] HPL`Private`HH[sq2,mm]-myint2[LL2[j,k] ypart[-1,1/2,y] HPL`Private`HH[mm]//HPL`Private`HProductExpand]


II2[0,1/2,{mm__}]:=HPL`Private`HH[sq,mm]


II2[-1,1/2,{mm__}]:=HPL`Private`HH[sq2,mm]


sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[3,3,2,m_]:= Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Beta]1,\[Beta]2}],Evaluate[-I xpart[0,1,x]-1-I xpart[0,1,x](Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[3,3,2,#[[1]],Delete[#,{1}]]HPL2[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))/.zero->0]]


Co[3,3,2,minus,{r_,rest___}]:=coeff[3,3,2,minus,{r,rest}]Co[3,3,2,r,{rest}]


Co[3,3,2,minus,{r_,rest___}]:=-(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) Co[3,3,2,r,{rest}]


Co[3,3,2,0,{___}]:=0


Co[3,3,2,plus,{}]:=0
Co[3,3,2,minus,{}]:=-\[Alpha]1-\[Alpha]2-\[Alpha]3+\[Beta]1+\[Beta]2


Co[3,3,2,plus,{plus}]:=\[Alpha]3 \[Beta]1-\[Beta]1^2+\[Alpha]3 \[Beta]2-\[Beta]1 \[Beta]2-\[Beta]2^2+\[Alpha]2 (-\[Alpha]3+\[Beta]1+\[Beta]2)+\[Alpha]1 (-\[Alpha]2-\[Alpha]3+\[Beta]1+\[Beta]2)


Co[3,3,2,plus,{minus}]:=0


Co[3,3,2,plus,{plus,r_,rest___}]:=(\[Alpha]3 \[Beta]1-\[Beta]1^2+\[Alpha]3 \[Beta]2-\[Beta]1 \[Beta]2-\[Beta]2^2+\[Alpha]2 (-\[Alpha]3+\[Beta]1+\[Beta]2)+\[Alpha]1 (-\[Alpha]2-\[Alpha]3+\[Beta]1+\[Beta]2)) Co[3,3,2,r,{rest}]


Co[3,3,2,plus,{minus,0,rest___}]:=-2 (\[Beta]1 \[Beta]2 Co[3,3,2,plus,{rest}]+(\[Beta]1+\[Beta]2) Co[3,3,2,plus,{minus,rest}])


Co[3,3,2,plus,{minus,minus,rest___}]:=-(\[Beta]1 \[Beta]2 Co[3,3,2,plus,{rest}]+(\[Beta]1+\[Beta]2) Co[3,3,2,plus,{minus,rest}])


Co[3,3,2,plus,{minus,plus,r_,rest___}]:=(-\[Alpha]3 \[Beta]1^2+\[Beta]1^3-\[Alpha]3 \[Beta]1 \[Beta]2+\[Beta]1^2 \[Beta]2-\[Alpha]3 \[Beta]2^2+\[Beta]1 \[Beta]2^2+\[Beta]2^3-\[Alpha]2 (\[Beta]1^2+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2))-\[Alpha]1 (\[Beta]1^2+\[Alpha]2 (\[Alpha]3-\[Beta]1-\[Beta]2)+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2))) Co[3,3,2,r,{rest}]


Co[3,3,2,plus,{minus,plus}]:=(-\[Alpha]3 \[Beta]1^2+\[Beta]1^3-\[Alpha]3 \[Beta]1 \[Beta]2+\[Beta]1^2 \[Beta]2-\[Alpha]3 \[Beta]2^2+\[Beta]1 \[Beta]2^2+\[Beta]2^3-\[Alpha]2 (\[Beta]1^2+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2))-\[Alpha]1 (\[Beta]1^2+\[Alpha]2 (\[Alpha]3-\[Beta]1-\[Beta]2)+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2))) 


Co[3,3,2,plus,{0,r_,rest___}]:=2 Co[3,3,2,plus,{minus,r,rest}]


sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[3,2,2,m_]:=Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Beta]1,\[Beta]2}],Evaluate[xpart1[2,1,x]+xpart1[0,1,x]  (Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[3,2,2,#[[1]],Delete[#,{1}]]HPL1[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))]]


Co[3,2,2,minus,{r_,rest___}]:=coeff[3,2,2,minus,{r,rest}]Co[3,2,2,r,{rest}]


NPlusTestFact[L_List]:=Module[{res},
If[FreeQ[L,0],Return[1]];
res=(Cases[L,plus|0]//.{{b___,plus,plus}->{b},{b___,0,plus}->{b,plus}});
If[MatchQ[res,{}],Return[1]];
 Return[If[MatchQ[res[[-1]],0],0,1]]]


Co[3,2,2,0,ll:{(0)...,r:(plus|minus),rest___}]:=NPlusTestFact[{0,r,rest}] Module[{n=Length[ll//.{z___,(plus|minus),___}->{z}]+1},(-2)^(n)(-sym[n+1,\[Beta]1,\[Beta]2]+(\[Alpha]1+\[Alpha]2) sym[n,\[Beta]1,\[Beta]2]-\[Alpha]1 \[Alpha]2 sym[n-1,\[Beta]1,\[Beta]2])]Co[3,2,2,r,{rest}]/(\[Alpha]1+\[Alpha]2-\[Beta]1-\[Beta]2)


Co[3,2,2,plus,{r_,rest___}]:=coeff[3,2,2,plus,{r,rest}]Co[3,2,2,r,{rest}]If[OddQ[Count[{r,rest},plus]],xpart1[-1,0,x],xpart1[1,0,x]]


Co[3,2,2,plus,{}]:=(\[Alpha]1+\[Alpha]2-\[Beta]1-\[Beta]2) xpart1[1,0,x]


Co[3,2,2,minus,{}]:=\[Alpha]3


coeff[3,2,2,minus,_?(EvenQ[Count[#,plus]]&)]:=\[Alpha]3


coeff[3,2,2,minus,_?(OddQ[Count[#,plus]]&)]:=(\[Alpha]1+\[Alpha]2-\[Beta]1-\[Beta]2)


coeff[3,2,2,plus,_?(EvenQ[Count[#,plus]]&)]:=(\[Alpha]1+\[Alpha]2-\[Beta]1-\[Beta]2)


coeff[3,2,2,plus,_?(OddQ[Count[#,plus]]&)]:=\[Alpha]3


(*f[mm__]:=Co[3,2,2,0,{0,mm}]+2 (\[Beta]1+\[Beta]2) Co[3,2,2,0,{mm}]+4 \[Beta]1 \[Beta]2 Co[3,2,2,{mm}[[1]],Delete[{mm},1]]/._xpart->1//Simplify
Select[Tuples[{plus,minus,0},12],(NPlusTestFact[#]==1&&#[[1]]==0&)];
f@@@%//Union  *)


sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[3,1,1,m_]:=Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Beta]1,\[Beta]2}],Evaluate[xpart1[2,1,x]+ xpart1[0,1,x](Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[3,1,1,#[[1]],Delete[#,{1}]]HPL1[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))]]


Co[3,1,1,minus,{r_,rest___}]:=coeff[3,1,1,minus,{r,rest}]Co[3,1,1,r,{rest}]


Co[3,1,1,0,{r_,rest___}]:=coeff[3,1,1,0,{r,rest}]Co[3,1,1,r,{rest}] 


Co[3,1,1,plus,{r_,rest___}]:=coeff[3,1,1,plus,{r,rest}]Co[3,1,1,r,{rest}]If[OddQ[Count[{r,rest},plus]],xpart1[-1,0,x],xpart1[1,0,x]]


Co[3,1,1,plus,{}]:=(\[Alpha]1-\[Beta]1) xpart1[1,0,x]


Co[3,1,1,minus,{}]:=(\[Alpha]2+\[Alpha]3-\[Beta]2) 


coeff[3,1,1,minus,_?(EvenQ[Count[#,plus]]&)]:=(\[Alpha]2+\[Alpha]3-\[Beta]2)


coeff[3,1,1,minus,_?(OddQ[Count[#,plus]]&)]:=\[Alpha]1-\[Beta]1


coeff[3,1,1,plus,_?(EvenQ[Count[#,plus]]&)]:=\[Alpha]1-\[Beta]1


coeff[3,1,1,plus,_?(OddQ[Count[#,plus]]&)]:=(\[Alpha]2+\[Alpha]3-\[Beta]2)




coeff[3,1,1,0,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],0]&)]:=(2 (\[Alpha]2-\[Beta]2) (\[Alpha]3-\[Beta]2))/(\[Alpha]2+\[Alpha]3-\[Beta]2)


coeff[3,1,1,0,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],0]&)]:=-2 \[Beta]2
coeff[3,1,1,0,_?(OddQ[Count[#,plus]]&)]:=-2 \[Beta]1



sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[3,0,1,m_]:= Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Beta]1,\[Beta]2}],Evaluate[(Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[3,0,1,#[[1]],Delete[#,{1}]]HPL2[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))]]


Co[3,0,1,minus,{r_,rest___}]:=coeff[3,0,1,minus,{r,rest}]Co[3,0,1,r,{rest}]


Co[3,0,1,0,{r_,rest___}]:=coeff[3,0,1,0,{r,rest}]Co[3,0,1,r,{rest}] 


Co[3,0,1,plus,{r_,rest___}]:=coeff[3,0,1,plus,{r,rest}]Co[3,0,1,r,{rest}]If[OddQ[Count[{r,rest},plus]],xpart[-1,-1,x],xpart[1,1,x]]


Co[3,0,1,plus,{}]:=-\[Alpha]3 xpart[1,1,x]


Co[3,0,1,minus,{}]:=0


coeff[3,0,1,0,_?(OddQ[Count[#,plus]]&)]:=-2 \[Beta]1
coeff[3,0,1,0,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],plus]&)]:=-2 (\[Beta]2)
coeff[3,0,1,0,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],plus]&)]:=(2 (\[Alpha]1-\[Beta]2) (\[Alpha]2-\[Beta]2))/(\[Alpha]1+\[Alpha]2-\[Beta]2)




coeff[3,0,1,minus,_?(OddQ[Count[#,plus]]&)]:=-\[Alpha]1-\[Alpha]2+\[Beta]2-\[Alpha]3
coeff[3,0,1,minus,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],plus]&)]:=-(\[Beta]2)
coeff[3,0,1,minus,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],plus]&)]:=((\[Alpha]1-\[Beta]2) (\[Alpha]2-\[Beta]2))/(\[Alpha]1+\[Alpha]2-\[Beta]2)




coeff[3,0,1,plus,_?(OddQ[Count[#,plus]]&)]:=\[Alpha]1+\[Alpha]2-\[Beta]2
coeff[3,0,1,plus,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],plus]&)]:=\[Beta]2-\[Alpha]3
coeff[3,0,1,plus,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],plus]&)]:=-(((\[Alpha]1-\[Beta]2) (\[Alpha]2-\[Beta]2)+(\[Alpha]1+\[Alpha]2-\[Beta]2) \[Alpha]3)/(\[Alpha]1+\[Alpha]2-\[Beta]2))




Ansatz[3,1,0,m_]:=Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Beta]1,\[Beta]2}],Evaluate[xpart1[0,1/2,x]-xpart1[0,0,x]+(Plus@@(Function[{n},\[Epsilon]^n Plus@@((xpart1[0,1/2,x] Co[3,1,0,#[[1]],Delete[#,{1}]]HPL3[#,x])&/@Tuples[{1,0,-1},n])]/@Range[1,m]))]]



Co[3,1,0,-1,{r_,rest___}]:=2 \[Alpha]1 Co[3,1,0,r,{rest}]
Co[3,1,0,1,{r_,rest___}]:=2 (\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) Co[3,1,0,r,{rest}]


Co[3,1,0,0,{1,r_,rest___}]:=2 (\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) (\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) Co[3,1,0,r,{rest}]


Co[3,1,0,0,{-1,r_,rest___}]:=2 (-\[Alpha]2^2-(\[Alpha]3-\[Beta]1) (\[Alpha]3-\[Beta]2)+\[Alpha]1 (\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2)+\[Alpha]2 (-\[Alpha]3+\[Beta]1+\[Beta]2)) Co[3,1,0,r,{rest}]+2 (\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) Co[3,1,0,0,{r,rest}]-2 Co[3,1,0,0,{0,r,rest}]


Co[3,1,0,0,{0,1,r_,rest___}]:=2 (\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) (\[Beta]1^2+\[Alpha]2 (\[Alpha]3-\[Beta]1-\[Beta]2)+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2)) Co[3,1,0,r,{rest}]


Co[3,1,0,0,{0,0,rest___}]:=-\[Beta]1 \[Beta]2 Co[3,1,0,0,{rest}]-(\[Beta]1+\[Beta]2) Co[3,1,0,0,{0,rest}]


Co[3,1,0,0,{0,-1,r_,rest___}]:=2 ((\[Alpha]3-\[Beta]1) (\[Alpha]3-\[Beta]2) (\[Beta]1+\[Beta]2)+\[Alpha]2^2 (-\[Alpha]3+\[Beta]1+\[Beta]2)-\[Alpha]2 (-\[Alpha]3+\[Beta]1+\[Beta]2)^2+\[Alpha]1 (\[Beta]1^2+\[Alpha]2 (\[Alpha]3-\[Beta]1-\[Beta]2)+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2)))Co[3,1,0,r,{rest}]-2 (\[Alpha]2-\[Beta]1-\[Beta]2) (-\[Alpha]3+\[Beta]1+\[Beta]2)  Co[3,1,0,0,{r,rest}]+2 (\[Beta]1+\[Beta]2) Co[3,1,0,0,{0,r,rest}]


Co[3,1,0,0,{0,-1}]:=2 ((\[Alpha]3-\[Beta]1) (\[Alpha]3-\[Beta]2) (\[Beta]1+\[Beta]2)+\[Alpha]2^2 (-\[Alpha]3+\[Beta]1+\[Beta]2)-\[Alpha]2 (-\[Alpha]3+\[Beta]1+\[Beta]2)^2+\[Alpha]1 (\[Beta]1^2+\[Alpha]2 (\[Alpha]3-\[Beta]1-\[Beta]2)+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2)))


Co[3,1,0,0,{0,1}]:=2 (\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) (\[Beta]1^2+\[Alpha]2 (\[Alpha]3-\[Beta]1-\[Beta]2)+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]3 (\[Beta]1+\[Beta]2))


Co[3,1,0,0,{-1}]:=2 (-\[Alpha]2^2-(\[Alpha]3-\[Beta]1) (\[Alpha]3-\[Beta]2)+\[Alpha]1 (\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2)+\[Alpha]2 (-\[Alpha]3+\[Beta]1+\[Beta]2))


Co[3,1,0,0,{1}]:=2 (\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2) (\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2)


Co[3,1,0,1,{}]:=2 (\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2)
Co[3,1,0,-1,{}]:=2 \[Alpha]1


Co[3,1,0,0,{}]:=0


Co[3,1,0,0,{0}]:=0


sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[2,1,1,m_]:=Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Beta]1}],Evaluate[xpart1[2,1,x]+xpart1[0,1,x](Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[2,1,1,#[[1]],Delete[#,{1}]]HPL1[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))]]


Co[2,1,1,minus,{r_,rest___}]:=coeff[2,1,1,minus,{r,rest}]Co[2,1,1,r,{rest}]


Co[2,1,1,0,{r_,rest___}]:=coeff[2,1,1,0,{r,rest}]Co[2,1,1,r,{rest}] 


Co[2,1,1,plus,{r_,rest___}]:=coeff[2,1,1,plus,{r,rest}]Co[2,1,1,r,{rest}]If[OddQ[Count[{r,rest},plus]],xpart1[-1,0,x],xpart1[1,0,x]]


Co[2,1,1,plus,{}]:=(\[Alpha]1-\[Beta]1) xpart1[1,0,x]


Co[2,1,1,minus,{}]:=(\[Alpha]2) 


coeff[2,1,1,minus,_?(EvenQ[Count[#,plus]]&)]:=(\[Alpha]2)


coeff[2,1,1,minus,_?(OddQ[Count[#,plus]]&)]:=\[Alpha]1-\[Beta]1


coeff[2,1,1,plus,_?(EvenQ[Count[#,plus]]&)]:=\[Alpha]1-\[Beta]1


coeff[2,1,1,plus,_?(OddQ[Count[#,plus]]&)]:=(\[Alpha]2)




coeff[2,1,1,0,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],0]&)]:=0


coeff[2,1,1,0,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],0]&)]:=0
coeff[2,1,1,0,_?(OddQ[Count[#,plus]]&)]:=-2 \[Beta]1


sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[2,0,1,m_]:= Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Beta]1}],Evaluate[(Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[2,0,1,#[[1]],Delete[#,{1}]]HPL2[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))]]


Co[2,0,1,minus,{r_,rest___}]:=coeff[2,0,1,minus,{r,rest}]Co[2,0,1,r,{rest}]


Co[2,0,1,0,{r_,rest___}]:=coeff[2,0,1,0,{r,rest}]Co[2,0,1,r,{rest}] 


Co[2,0,1,plus,{r_,rest___}]:=coeff[2,0,1,plus,{r,rest}]Co[2,0,1,r,{rest}]If[OddQ[Count[{r,rest},plus]],xpart[-1,-1,x],xpart[1,1,x]]


Co[2,0,1,plus,{}]:=-\[Alpha]2 xpart[1,1,x]


Co[2,0,1,minus,{}]:=0


coeff[2,0,1,0,_?(OddQ[Count[#,plus]]&)]:=-2 \[Beta]1
coeff[2,0,1,0,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],plus]&)]:=0
coeff[2,0,1,0,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],plus]&)]:=0




coeff[2,0,1,minus,_?(OddQ[Count[#,plus]]&)]:=-\[Alpha]1-\[Alpha]2
coeff[2,0,1,minus,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],plus]&)]:=0
coeff[2,0,1,minus,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],plus]&)]:=0




coeff[2,0,1,plus,_?(OddQ[Count[#,plus]]&)]:=\[Alpha]1
coeff[2,0,1,plus,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],plus]&)]:=0
coeff[2,0,1,plus,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],plus]&)]:=-\[Alpha]2




sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[2,2,1,m_]:= Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Beta]1}],Evaluate[-I xpart[0,1,x]-1-I xpart[0,1,x](Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[2,2,1,#[[1]],Delete[#,{1}]]HPL2[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))/.zero->0]]


Co[2,2,1,minus,{r_,rest___}]:=coeff[2,2,1,minus,{r,rest}]Co[2,2,1,r,{rest}]


Co[2,2,1,0,{r_,rest___}]:=coeff[2,2,1,0,{r,rest}]Co[2,2,1,r,{rest}] 


Co[2,2,1,plus,{r_,rest___}]:=coeff[2,2,1,plus,{r,rest}]Co[2,2,1,r,{rest}]


Co[2,2,1,plus,{}]:=-(\[Alpha]1-\[Beta]1) (\[Alpha]2-\[Beta]1) zero



Co[2,2,1,minus,{}]:=-(\[Alpha]1+\[Alpha]2-\[Beta]1)





coeff[2,2,1,0,_?(EvenQ[Count[#,plus]]&)]:=0
coeff[2,2,1,0,_?(OddQ[Count[#,plus]]&)]:=-2\[Beta]1

coeff[2,2,1,minus,_?(EvenQ[Count[#,plus]]&)]:=-\[Alpha]1-\[Alpha]2+\[Beta]1
coeff[2,2,1,minus,_?(OddQ[Count[#,plus]]&)]:=-\[Beta]1


coeff[2,2,1,plus,_?(OddQ[Count[#,plus]]&)]:=1/zero
coeff[2,2,1,plus,_?(EvenQ[Count[#,plus]]&)]:= -(\[Alpha]1-\[Beta]1) (\[Alpha]2-\[Beta]1) zero


Ansatz[2,1,0,m_]:=Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Beta]1}],Evaluate[xpart1[0,1/2,x]-xpart1[0,0,x]+(Plus@@(Function[{n},\[Epsilon]^n Plus@@((xpart1[0,1/2,x] Co[2,1,0,#[[1]],Delete[#,{1}]]HPL3[#,x])&/@Tuples[{1,0,-1},n])]/@Range[1,m]))]]



Co[2,1,0,-1,{r_,rest___}]:=2 \[Alpha]1 Co[2,1,0,r,{rest}]


Co[2,1,0,1,{r_,rest___}]:=2 (\[Alpha]1+\[Alpha]2-\[Beta]1)  Co[2,1,0,r,{rest}]


Co[2,1,0,0,{0,rest___}]:=-\[Beta]1 Co[2,1,0,0,{rest}] 


Co[2,1,0,0,{1,r_,rest___}]:=2 (\[Alpha]2-\[Beta]1) (\[Alpha]1+\[Alpha]2-\[Beta]1) Co[2,1,0,r,{rest}]


Co[2,1,0,0,{1}]:=2 (\[Alpha]2-\[Beta]1) (\[Alpha]1+\[Alpha]2-\[Beta]1)


Co[2,1,0,0,{-1,r_,rest___}]:=2 ((\[Alpha]1-\[Alpha]2) (\[Alpha]2-\[Beta]1)Co[2,1,0,r,{rest}]+\[Alpha]2 Co[2,1,0,0,{r,rest}])


Co[2,1,0,0,{-1}]:=2 (\[Alpha]1-\[Alpha]2) (\[Alpha]2-\[Beta]1)


Co[2,1,0,-1,{}]:=2 \[Alpha]1
Co[2,1,0,1,{}]:=2 (\[Alpha]1+\[Alpha]2-\[Beta]1)


Co[2,1,0,0,{}]:=0


sym[n_,a_,b_]:=Sum[a^ii b^(n-ii),{ii,0,n}]


Ansatz[4,1,1,m_]:=Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Alpha]4,\[Beta]1,\[Beta]2,\[Beta]3}],Evaluate[xpart1[2,1,x]+ xpart1[0,1,x](Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[4,1,1,#[[1]],Delete[#,{1}]]HPL1[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))]]


Co[4,1,1,minus,{r_,rest___}]:=coeff[4,1,1,minus,{r,rest}]Co[4,1,1,r,{rest}]


Co[4,1,1,0,{0,0,rest___}]:=-2 (\[Beta]2+\[Beta]3) Co[4,1,1,0,{0,rest}]-4 \[Beta]2 \[Beta]3 Co[4,1,1,0,{rest}]/;EvenQ[Count[{rest},plus]]


Co[4,1,1,0,{r_,rest___}]:=coeff[4,1,1,0,{r,rest}]Co[4,1,1,r,{rest}] 


Co[4,1,1,plus,{r_,rest___}]:=coeff[4,1,1,plus,{r,rest}]Co[4,1,1,r,{rest}]If[OddQ[Count[{r,rest},plus]],xpart1[-1,0,x],xpart1[1,0,x]]


Co[4,1,1,plus,{}]:=(\[Alpha]1-\[Beta]1) xpart1[1,0,x]


Co[4,1,1,minus,{}]:=(\[Alpha]2+\[Alpha]3+\[Alpha]4-\[Beta]2-\[Beta]3) 


coeff[4,1,1,minus,_?(EvenQ[Count[#,plus]]&)]:=(\[Alpha]2+\[Alpha]3+\[Alpha]4-\[Beta]2-\[Beta]3)


coeff[4,1,1,minus,_?(OddQ[Count[#,plus]]&)]:=\[Alpha]1-\[Beta]1


coeff[4,1,1,plus,_?(EvenQ[Count[#,plus]]&)]:=\[Alpha]1-\[Beta]1


coeff[4,1,1,plus,_?(OddQ[Count[#,plus]]&)]:=(\[Alpha]2+\[Alpha]3+\[Alpha]4-\[Beta]2-\[Beta]3)


coeff[4,1,1,0,_?(EvenQ[Count[#,plus]]&&UnsameQ[#[[1]],0]&)]:=(2 (-\[Alpha]4 \[Beta]2+\[Beta]2^2+\[Alpha]3 (\[Alpha]4-\[Beta]2-\[Beta]3)+\[Alpha]2 (\[Alpha]3+\[Alpha]4-\[Beta]2-\[Beta]3)-\[Alpha]4 \[Beta]3+\[Beta]2 \[Beta]3+\[Beta]3^2))/(\[Alpha]2+\[Alpha]3+\[Alpha]4-\[Beta]2-\[Beta]3)


coeff[4,1,1,0,_?(EvenQ[Count[#,plus]]&&SameQ[#[[1]],0]&)]:=(2 (\[Alpha]4 \[Beta]2^2-\[Beta]2^3+\[Alpha]4 \[Beta]2 \[Beta]3-\[Beta]2^2 \[Beta]3+\[Alpha]4 \[Beta]3^2-\[Beta]2 \[Beta]3^2-\[Beta]3^3+\[Alpha]3 (\[Beta]2^2+\[Beta]2 \[Beta]3+\[Beta]3^2-\[Alpha]4 (\[Beta]2+\[Beta]3))+\[Alpha]2 (\[Beta]2^2+\[Alpha]3 (\[Alpha]4-\[Beta]2-\[Beta]3)+\[Beta]2 \[Beta]3+\[Beta]3^2-\[Alpha]4 (\[Beta]2+\[Beta]3))))/(-\[Alpha]4 \[Beta]2+\[Beta]2^2+\[Alpha]3 (\[Alpha]4-\[Beta]2-\[Beta]3)+\[Alpha]2 (\[Alpha]3+\[Alpha]4-\[Beta]2-\[Beta]3)-\[Alpha]4 \[Beta]3+\[Beta]2 \[Beta]3+\[Beta]3^2)

coeff[4,1,1,0,_?(OddQ[Count[#,plus]]&)]:=-2 \[Beta]1


sym[n_,a__]:=Plus@@(Times@@#&/@(Sort/@Tuples[{a},n]//Union))


Ansatz[4,3,3,m_]:=Function[Evaluate[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Alpha]4,\[Beta]1,\[Beta]2,\[Beta]3}],Evaluate[xpart1[2,1,x]+xpart1[0,1,x]  (Plus@@(Function[{n},\[Epsilon]^n Plus@@ ((Co[4,3,3,#[[1]],Delete[#,{1}]]HPL1[#,x])&/@Flatten[{Append[#,plus],Append[#,minus]}&/@Tuples[{plus,0,minus},n-1],1])]/@Range[1,m]))]]


Co[4,3,3,minus,{r_,rest___}]:=coeff[4,3,3,minus,{r,rest}]Co[4,3,3,r,{rest}]


NPlusTestFact[L_List]:=Module[{res},
If[FreeQ[L,0],Return[1]];
res=(Cases[L,plus|0]//.{{b___,plus,plus}->{b},{b___,0,plus}->{b,plus}});
If[MatchQ[res,{}],Return[1]];
 Return[If[MatchQ[res[[-1]],0],0,1]]]


Co[4,3,3,0,{0,minus}]:=0
Co[4,3,3,0,{0,0,minus}]:=0


Co[4,3,3,0,ll:{r:(plus|minus)}]:=NPlusTestFact[{0,r}] (2 (\[Alpha]1 \[Alpha]2+\[Alpha]2 \[Alpha]3+\[Alpha]3 \[Alpha]1-\[Alpha]1 \[Beta]1-\[Alpha]2 \[Beta]1-\[Alpha]3 \[Beta]1+\[Beta]1^2-\[Alpha]1 \[Beta]2-\[Alpha]2 \[Beta]2-\[Alpha]3 \[Beta]2+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]1 \[Beta]3-\[Alpha]2 \[Beta]3-\[Alpha]3 \[Beta]3+\[Beta]1 \[Beta]3+\[Beta]2 \[Beta]3+\[Beta]3^2)/(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3) Co[4,3,3,r,{}] )


Co[4,3,3,0,ll:{r:(plus|minus),rest__}]:=NPlusTestFact[{0,r,rest}] (2 (\[Alpha]1 \[Alpha]2+\[Alpha]2 \[Alpha]3+\[Alpha]3 \[Alpha]1-\[Alpha]1 \[Beta]1-\[Alpha]2 \[Beta]1-\[Alpha]3 \[Beta]1+\[Beta]1^2-\[Alpha]1 \[Beta]2-\[Alpha]2 \[Beta]2-\[Alpha]3 \[Beta]2+\[Beta]1 \[Beta]2+\[Beta]2^2-\[Alpha]1 \[Beta]3-\[Alpha]2 \[Beta]3-\[Alpha]3 \[Beta]3+\[Beta]1 \[Beta]3+\[Beta]2 \[Beta]3+\[Beta]3^2)/(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3) Co[4,3,3,r,{rest}] )


Co[4,3,3,0,{0,minus,rest__}]:=-4NPlusTestFact[{0,minus,rest}](\[Alpha]1 \[Alpha]2 \[Beta]1+\[Alpha]1 \[Alpha]3 \[Beta]1+\[Alpha]2 \[Alpha]3 \[Beta]1-\[Alpha]1 \[Beta]1^2-\[Alpha]2 \[Beta]1^2-\[Alpha]3 \[Beta]1^2+\[Beta]1^3+\[Alpha]1 \[Alpha]2 \[Beta]2+\[Alpha]1 \[Alpha]3 \[Beta]2+\[Alpha]2 \[Alpha]3 \[Beta]2-\[Alpha]1 \[Beta]1 \[Beta]2-\[Alpha]2 \[Beta]1 \[Beta]2-\[Alpha]3 \[Beta]1 \[Beta]2+\[Beta]1^2 \[Beta]2-\[Alpha]1 \[Beta]2^2-\[Alpha]2 \[Beta]2^2-\[Alpha]3 \[Beta]2^2+\[Beta]1 \[Beta]2^2+\[Beta]2^3+\[Alpha]1 \[Alpha]2 \[Beta]3+\[Alpha]1 \[Alpha]3 \[Beta]3+\[Alpha]2 \[Alpha]3 \[Beta]3-\[Alpha]1 \[Beta]1 \[Beta]3-\[Alpha]2 \[Beta]1 \[Beta]3-\[Alpha]3 \[Beta]1 \[Beta]3+\[Beta]1^2 \[Beta]3-\[Alpha]1 \[Beta]2 \[Beta]3-\[Alpha]2 \[Beta]2 \[Beta]3-\[Alpha]3 \[Beta]2 \[Beta]3+\[Beta]1 \[Beta]2 \[Beta]3+\[Beta]2^2 \[Beta]3-\[Alpha]1 \[Beta]3^2-\[Alpha]2 \[Beta]3^2-\[Alpha]3 \[Beta]3^2+\[Beta]1 \[Beta]3^2+\[Beta]2 \[Beta]3^2+\[Beta]3^3- \[Alpha]1 \[Alpha]2 \[Alpha]3)/(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3) Co[4,3,3,minus,{rest}]


Co[4,3,3,0,{0,plus,rest___}]:=-4NPlusTestFact[{0,plus,rest}] (\[Alpha]1 \[Alpha]2 \[Beta]1+\[Alpha]1 \[Alpha]3 \[Beta]1+\[Alpha]2 \[Alpha]3 \[Beta]1-\[Alpha]1 \[Beta]1^2-\[Alpha]2 \[Beta]1^2-\[Alpha]3 \[Beta]1^2+\[Beta]1^3+\[Alpha]1 \[Alpha]2 \[Beta]2+\[Alpha]1 \[Alpha]3 \[Beta]2+\[Alpha]2 \[Alpha]3 \[Beta]2-\[Alpha]1 \[Beta]1 \[Beta]2-\[Alpha]2 \[Beta]1 \[Beta]2-\[Alpha]3 \[Beta]1 \[Beta]2+\[Beta]1^2 \[Beta]2-\[Alpha]1 \[Beta]2^2-\[Alpha]2 \[Beta]2^2-\[Alpha]3 \[Beta]2^2+\[Beta]1 \[Beta]2^2+\[Beta]2^3+\[Alpha]1 \[Alpha]2 \[Beta]3+\[Alpha]1 \[Alpha]3 \[Beta]3+\[Alpha]2 \[Alpha]3 \[Beta]3-\[Alpha]1 \[Beta]1 \[Beta]3-\[Alpha]2 \[Beta]1 \[Beta]3-\[Alpha]3 \[Beta]1 \[Beta]3+\[Beta]1^2 \[Beta]3-\[Alpha]1 \[Beta]2 \[Beta]3-\[Alpha]2 \[Beta]2 \[Beta]3-\[Alpha]3 \[Beta]2 \[Beta]3+\[Beta]1 \[Beta]2 \[Beta]3+\[Beta]2^2 \[Beta]3-\[Alpha]1 \[Beta]3^2-\[Alpha]2 \[Beta]3^2-\[Alpha]3 \[Beta]3^2+\[Beta]1 \[Beta]3^2+\[Beta]2 \[Beta]3^2+\[Beta]3^3- \[Alpha]1 \[Alpha]2 \[Alpha]3)/(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3) Co[4,3,3,plus,{rest}]


Co[4,3,3,0,ll:{(0)...,r:(plus|minus),rest___}]:=NPlusTestFact[{0,r,rest}] Module[{n=Length[ll//.{z___,(plus|minus),___}->{z}]+1},(2)^(n)Plus@@(Cases[sym[n+1,-\[Beta]1,-\[Beta]2,-\[Beta]3,\[Alpha]1,\[Alpha]2,\[Alpha]3],_?(Not[FreeQ[#,\[Beta]1|\[Beta]2|\[Beta]3]]&&FreeQ[#,(\[Alpha]1|\[Alpha]2|\[Alpha]3)^n_]&)])]  Co[4,3,3,r,{rest}]/(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3)


Co[4,3,3,plus,{r_,rest___}]:=coeff[4,3,3,plus,{r,rest}]Co[4,3,3,r,{rest}]If[OddQ[Count[{r,rest},plus]],xpart1[-1,0,x],xpart1[1,0,x]]


Co[4,3,3,plus,{}]:=(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3) xpart1[1,0,x]


Co[4,3,3,minus,{}]:=\[Alpha]4


coeff[4,3,3,minus,_?(EvenQ[Count[#,plus]]&)]:=\[Alpha]4


coeff[4,3,3,minus,_?(OddQ[Count[#,plus]]&)]:=(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3)


coeff[4,3,3,plus,_?(EvenQ[Count[#,plus]]&)]:=(\[Alpha]1+\[Alpha]2+\[Alpha]3-\[Beta]1-\[Beta]2-\[Beta]3)


coeff[4,3,3,plus,_?(OddQ[Count[#,plus]]&)]:=\[Alpha]4


De2[j_,\[Alpha]_,jref_:1]:=Product[HypExpi+jj+If[MatchQ[Precision[\[Alpha]],\[Infinity]],\[Alpha],Num[\[Alpha]]] HypExp\[Epsilon],{jj,jref,j-1}]/;j>=jref


De2[j_,\[Alpha]_,jref_:1]:=Product[1/(HypExpi+jj+If[MatchQ[Precision[\[Alpha]],\[Infinity]],\[Alpha],Num[\[Alpha]]] HypExp\[Epsilon]),{jj,j,jref-1}]/;j<jref


De2[2,\[Alpha],0]


DeHalf[j_,\[Alpha]_]:=Product[If[j>=0,HypExpi+jj+1/2+If[MatchQ[Precision[\[Alpha]],\[Infinity]],\[Alpha],Num[\[Alpha]]] HypExp\[Epsilon],1/(HypExpi+j+jj+1/2+If[MatchQ[Precision[\[Alpha]],\[Infinity]],\[Alpha],Num[\[Alpha]]] HypExp\[Epsilon])],{jj,0,If[j>=0,j-1,-j-1]}]


ConvertToDen2={intmarker*((a_Integer:0)+2 HypExpi+\[Alpha]_. HypExp\[Epsilon])^(n_:1):>2^n DenHalf[(a-1)/2,-n,x,\[Alpha]/2],intmarker*((a_Integer:0)+2 HypExpi)^(n_:1):>2^n DenHalf[(a-1)/2,-n,x],intmarker*((a_Integer:0)+HypExpi+\[Alpha]_. HypExp\[Epsilon])^(n_:1):>Den[a,-n,\[Alpha],x],intmarker*(a_.+HypExpi)^(n_:1):>Den[a,-n,0,x],intmarker HypExpi^e_.->Den[0,-e,0,x],intmarker->Den[0,0,0,x]};
ConvertToDenNeg2={(p_ HypExpi+a_Integer?Negative+\[Alpha]_. HypExp\[Epsilon])^(n_:1):>p^n Den[a/p,-n,\[Alpha]/p,x]/intmarker/;Mod[a,p]==0,(HypExpi+a_Integer?Negative+\[Alpha]_. HypExp\[Epsilon])^(n_:1):>Den[a,-n,\[Alpha],x]/intmarker,(HypExpi+a_Integer?Negative)^(n_:1):>Den[a,-n,0,x]/intmarker};


HPLINT[4,3,3]=HPLInt1;
HPLINT[3,2,2]=HPLInt1;
HPLINT[3,1,1]=HPLInt1;
HPLINT[4,1,1]=HPLInt1;
HPLINT[3,0,1]=HPLInt2;
HPLINT[2,1,1]=HPLInt1;
HPLINT[2,0,1]=HPLInt2;
HPLINT[2,2,1]=HPLInt2;
HPLINT[3,3,2]=HPLInt2;


XPART[4,3,3]=xpart1;
XPART[3,2,2]=xpart1;
XPART[3,1,1]=xpart1;
XPART[4,1,1]=xpart1;
XPART[3,0,1]=xpart;
XPART[2,1,1]=xpart1;
XPART[2,0,1]=xpart;
XPART[2,2,1]=xpart;
XPART[2,1,0]=xpart1;
XPART[3,1,0]=xpart1;
XPART[3,3,2]=xpart;



ansypm[2,1,0,o_]:=Function[{\[Alpha]1,\[Alpha]2,\[Beta]1},Ansatz[2,1,0,o][\[Alpha]1,\[Alpha]2,\[Beta]1]/.HPL3[mm_,x]:>HPL`Private`HH@@HPLMtoA[mm]/.xpart1[0,1/2,x]->ypart[0,1,y]+2 ypart[1,1,y]+ypart[2,1,y]/.xpart1[0,0,x]->ypart[0,0,y]]


ansypm[3,1,0,o_]:=Function[{\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Beta]1,\[Beta]2},Ansatz[3,1,0,o][\[Alpha]1,\[Alpha]2,\[Alpha]3,\[Beta]1,\[Beta]2]/.HPL3[mm_,x]:>HPL`Private`HH@@HPLMtoA[mm]/.xpart1[0,1/2,x]->ypart[0,1,y]+2 ypart[1,1,y]+ypart[2,1,y]/.xpart1[0,0,x]->1]


IntBase[2,1,0,j_,n_,order_,\[Alpha]_List]:=JPlus[2,1,0][j,n,order,\[Alpha]]


IntBase[3,1,0,j_,n_,order_,\[Alpha]_List]:=JPlus[3,1,0][j,n,order,\[Alpha]]


IntBase[J_,r_,s_,j_,n_,order_,\[Alpha]_List]:=Nest[(XPART[J,r,s][-2 j,0,x] HPLINT[J,r,s][#,-2+2 j]//HPLProductExpand)&,(Ansatz[J,r,s,order]@@\[Alpha]//Expand),n]


DerBase[J_,r_,s_,j_,n_,order_,\[Alpha]_List]:=Nest[(XPART[J,r,s][-2 j+2,0,x] D[# XPART[J,r,s][2 j,0,x],x]//HPLProductExpand)&,(Ansatz[J,r,s,order]@@\[Alpha]//Expand),n]


B[J_,r_,s_,ns_List,ms_List,n_,o_,\[Alpha]_List]:=Series[Product[Pochhammer[1/2+\[Alpha][[l]] \[Epsilon]+ns[[l]],n], {l,1,r}] Product[Pochhammer[ns[[l]]+\[Alpha][[l]] \[Epsilon],n], {l,r+1,J}]/(Product[Pochhammer[ms[[l]]+1/2+\[Alpha][[J+l]] \[Epsilon],n], {l,1,s}] Product[Pochhammer[ms[[l]]+\[Alpha][[J+l]] \[Epsilon],n], {l,s+1,J-1}])/n!,{\[Epsilon],0,o}]//Normal


IntNegJBase[J:(2|3),1,0,ns_List,ms_List,j_,n_,order_,\[Alpha]\[Alpha]_,\[Alpha]_List]:=Module[{y,Const={},int=ansypm[J,1,0,order]@@\[Alpha],res},
int=(int JF[J,1,0][-j-1]-Sum[B[J,1,0,ns,ms,jj,order,\[Alpha]] JF[J,1,0][jj-j-1] ,{jj,1,j}]) //HPLProductExpand;
(*Print[int]*);
res=XPART[J,1,0][2 j,0,x] Sum[(-\[Alpha]\[Alpha] \[Epsilon])^k (n+k-1)!/((n-1)! k!) Collect[ HPL`Private`HProductExpand[Nest[myint2[( JF[J,1,0][-1] #)//HPL`Private`HProductExpand]&,Normal[Series[myint2[int //HPL`Private`HProductExpand],{\[Epsilon],0,Max[0,order-k]}]],n-1+k]]/.HPL`Private`HH[mm__]:>HPL3[{mm},x],_HPL3]//.y2xrule,{k,0,order}];
(*Print[res]*);res=res+ (Sum[B[J,1,0,ns,ms,jj,order,\[Alpha]] XPART[J,1,0][2 jj,0,x]/(jj-j+\[Alpha]\[Alpha] \[Epsilon])^n,{jj,1,j-1}]+ B[J,1,0,ns,ms,j,order+n,\[Alpha]] XPART[J,1,0][2 j,0,x]/(\[Alpha]\[Alpha] \[Epsilon])^n);
res]


IntNegJBase[J_,r_,s_,ns_List,ms_List,j_,n_,order_,\[Alpha]\[Alpha]_,\[Alpha]_List]:=Module[
{y,Const={},int=Ansatz[J,r,s,order]@@\[Alpha],res},
int=(int-Sum[B[J,r,s,ns,ms,jj,order,\[Alpha]] XPART[J,r,s][2 jj,0,x],{jj,1,j}]) XPART[J,r,s][-2 j,0,x]//HPLProductExpand;
(*Print[Const,int];*)
res=XPART[J,r,s][2 j,0,x] Sum[(-\[Alpha]\[Alpha] \[Epsilon])^k (n+k-1)!/((n-1)! k!) Nest[(HPLINT[J,r,s][#,-2]//HPLProductExpand)&,(Series[int,{\[Epsilon],0,Max[0,order-k]}]//Normal//Expand),n+k],{k,0,order}];
res=res+Sum[B[J,r,s,ns,ms,jj,order,\[Alpha]] XPART[J,r,s][2 jj,0,x]/(jj-j+\[Alpha]\[Alpha] \[Epsilon])^n,{jj,1,j-1}]+B[J,r,s,ns,ms,j,order+n,\[Alpha]] XPART[J,r,s][2 j,0,x]/(\[Alpha]\[Alpha] \[Epsilon])^n;
res
]


HaHypExpAlg[J_,r_,s_,ns_List,ms_List,a_List,\[Alpha]_List,b_List,\[Beta]_List,order_]:=Module[{res,intern,extern,orderint,remember=$HPLAutoConvertToKnownFunctions,remember2=$HPLAutoReduceToMinimalSet},
$HPLAutoConvertToKnownFunctions=False;$HPLAutoReduceToMinimalSet=False;
orderint=Sum[If[ms[[l]]>0&&b[[l]]<=0,1,0],{l,s+1,J-1}];
If[orderint==0,orderint=orderint+Sum[If[ns[[l]]>0&&a[[l]]<=0,-1,0],{l,r+1,J}]];
orderint=orderint+Sum[If[ns[[l]]<=0&&a[[l]]>0,1,0],{l,r+1,J}];
orderint=order+orderint;
res=MyTermsHalf[J,r,s,ns,ms,a,\[Alpha],b,\[Beta],Max[order,orderint]]/.DenCoeffRule;
res=res/.{HypExp\[Epsilon]^exp_. DenHalf[j_,n_?Positive,x]:>HypExp\[Epsilon]^exp IntBase[J,r,s,j+1/2,n,Max[0,orderint-exp],Join[\[Alpha],\[Beta]]], DenHalf[j_,n_?Positive,x]:> IntBase[J,r,s,j+1/2,n,orderint,Join[\[Alpha],\[Beta]]]};
res=res/.{HypExp\[Epsilon]^exp_. Den[j_,n_?Positive,0,x]:>HypExp\[Epsilon]^exp IntBase[J,r,s,j,n,Max[0,orderint-exp],Join[\[Alpha],\[Beta]]], Den[j_,n_?Positive,0,x]:> IntBase[J,r,s,j,n,orderint,Join[\[Alpha],\[Beta]]]};
res=res/.{HypExp\[Epsilon]^exp_. Den[j_,n_?Negative,0,x]:>HypExp\[Epsilon]^exp DerBase[J,r,s,j,-n,Max[orderint-exp,0],Join[\[Alpha],\[Beta]]], Den[j_,n_,0,x]:>DerBase[J,r,s,j,-n,orderint,Join[\[Alpha],\[Beta]]]};
res=res/.{HypExp\[Epsilon]^exp_. Den[j_?Negative,n_?Positive,\[Alpha]\[Alpha]_,x]:>HypExp\[Epsilon]^exp IntNegJBase[J,r,s,ns,ms,-j,n,Max[orderint-exp,0],\[Alpha]\[Alpha],Join[\[Alpha],\[Beta]]], Den[j_?Negative,n_?Positive,\[Alpha]\[Alpha]_,x]:> IntNegJBase[J,r,s,ns,ms,-j,n,orderint,\[Alpha]\[Alpha],Join[\[Alpha],\[Beta]]]};
intern=Series[res/.HypExp\[Epsilon]->\[Epsilon],{\[Epsilon],0,orderint}]//Normal;
tt=intern;
extern=Product[DeHalf[b[[l]]+ms[[l]]-1/2,\[Beta][[l]]],{l,1,s}] Product[De2[b[[l]],\[Beta][[l]],ms[[l]]],{l,s+1,J-1}]/(Product[DeHalf[a[[l]]+ns[[l]]-1/2,\[Alpha][[l]]], {l,1,r}] Product[De2[a[[l]],\[Alpha][[l]],ns[[l]]], {l,r+1,J}])/.{HypExpi->0,HypExp\[Epsilon]->\[Epsilon]}//Expand;
ttt=extern;
tttt=Series[1+extern intern,{\[Epsilon],0,order}];
res=Series[1+extern intern//HPLProductExpand,{\[Epsilon],0,order}]//Simplify;
$HPLAutoConvertToKnownFunctions=remember;$HPLAutoReduceToMinimalSet=remember2;
Return[res/.HPL12HPLrule/.HPL22HPLrule/.HPL32HPLrule/.xpart1rule/.xpart2rule//Normal]
]


MyTermsHalf[J_,r_,s_,ns_List,ms_List,a_List,\[Alpha]_List,b_List,\[Beta]_List,order_,opts___Rule]:=
Module[{t,j,n,x},

t=(Product[DeHalf[a[[l]]+ns[[l]]-1/2,\[Alpha][[l]]], {l,1,r}] Product[De2[a[[l]],\[Alpha][[l]],ns[[l]]], {l,r+1,J}])/(Product[DeHalf[b[[l]]+ms[[l]]-1/2,\[Beta][[l]]],{l,1,s}] Product[De2[b[[l]],\[Beta][[l]],ms[[l]]],{l,s+1,J-1}])/De2[1,0];

(*Print[{t,a,b,ns,ms}];*)

t=Collect[Expand[intmarker Apart[t,HypExpi]],{intmarker HypExpi^(_:1),intmarker*(HypExpi+aa___)^(_:1),intmarker*(2 HypExpi+aa___)^(_:1),intmarker}];

t=t/.ConvertToDenNeg2;
t=Normal[Series[t,{HypExp\[Epsilon],0,order}]];
t=Collect[Expand[Apart[t,HypExpi]],{intmarker HypExpi^(_:1),intmarker*(HypExpi+aa___)^(_:1),intmarker*(2 HypExpi+aa___)^(_:1),intmarker}];

t=t/.ConvertToDen2;

t=Collect[t,{Den[___],DenHalf[___],HypExp\[Epsilon]},DenCoeff[Simplify[#]]&];

t=Expand[t];

DenCoeffRule=t/.{Den[j_,n_,\[Gamma]_,x_] HypExp\[Epsilon]^e_. DenCoeff[coeff_]:>DenCoeff[j,n,\[Gamma],x,e]->coeff,Den[j_,n_,\[Gamma]_,x_] DenCoeff[coeff_]:>DenCoeff[j,n,\[Gamma],x,0]->Simplify[coeff],DenHalf[j_,n_,x_] HypExp\[Epsilon]^e_. DenCoeff[coeff_]:>DenCoeff[j+1/2,n,x,e]->coeff,DenHalf[j_,n_,x_] DenCoeff[coeff_]:>DenCoeff[j+1/2,n,x,0]->Simplify[coeff]};
DenCoeffRule=If[Head[DenCoeffRule]===Plus,Apply[List,DenCoeffRule],DenCoeffRule]/.Num[x_]->x;
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["DenCoeffRule: ",DenCoeffRule]];
t=t/.{Den[j_,n_,\[Gamma]_,x_] HypExp\[Epsilon]^e_. DenCoeff[coeff_]:>Den[j,n,\[Gamma],x]HypExp\[Epsilon]^e  DenCoeff[j,n,\[Gamma],x,e],Den[j_,n_,\[Gamma]_,x_] DenCoeff[coeff_]:>Den[j,n,\[Gamma],x] DenCoeff[j,n,\[Gamma],x,0],DenHalf[j_,n_,x_] HypExp\[Epsilon]^e_. DenCoeff[coeff_]:>DenHalf[j,n,x]HypExp\[Epsilon]^e  DenCoeff[j+1/2,n,x,e],DenHalf[j_,n_,x_] DenCoeff[coeff_]:>DenHalf[j,n,x] DenCoeff[j+1/2,n,x,0]};
Return[t/.Num[x_]->x]]


MySort[\[Epsilon]_][x_,y_]:=Switch[{x,y}/.\[Epsilon]->0,
{Rational[_,2],Rational[_,2]},Greater[x/.\[Epsilon]->0,y/.\[Epsilon]->0],
{_Integer,Rational[_,2]},False,
{Rational[_,2],_Integer},True,
{_Integer,_Integer},Greater[x/.\[Epsilon]->0,y/.\[Epsilon]->0]
]


JrsKnown={2,0,1}|{2,1,1}|{2,2,1}|{2,1,0}|{3,0,1}|{3,1,0}|{3,1,1}|{3,2,2}|{3,3,2}|{4,1,1}|{4,3,3}|{_Integer,0,0}


HaHypExp[a_List,b_List,\[Epsilon]_,n_]:=Module[{J,A,B,as,bs,\[Alpha]s,\[Beta]s,res,r,s},
J=Length[a];
If[Length[b]!=J-1,Print["Not a \!\(\*SubscriptBox[\"F\", 
RowBox[{\"J\", \"-\", \"1\"}]]\) !"];Return[$Failed]];
A=Sort[a,MySort[\[Epsilon]]];
B=Sort[b,MySort[\[Epsilon]]];
as=Rationalize[(A/.\[Epsilon]->0),0];bs=Rationalize[(B/.\[Epsilon]->0),0];
\[Alpha]s=If[Precision[#]!=\[Infinity]||#===0,Num[#],#]&/@Coefficient[A,\[Epsilon]];
\[Beta]s=If[Precision[#]!=\[Infinity]||#===0,Num[#],#]&/@Coefficient[B,\[Epsilon]];
r=Count[as,Rational[_,2]];
s=Count[bs,Rational[_,2]];
If[r+Count[as,_Integer]!=J,Print["Wrong arguments..."];Return [$Failed]];
If[s+Count[bs,_Integer]!=J-1,Print["Wrong arguments..."];Return [$Failed]];

res=Switch[{J,r,s},
{2,0,1},HaHypExpAlg[2,0,1,{1,0},{0},as,\[Alpha]s,bs,\[Beta]s,n],
{2,1,1},HaHypExpAlg[2,1,1,{0,1},{0},as,\[Alpha]s,bs,\[Beta]s,n],
{2,2,1},HaHypExpAlg[2,2,1,{0,0},{0},as,\[Alpha]s,bs,\[Beta]s,n],
{2,1,0},HaHypExpAlg[2,1,0,{0,1},{1},as,\[Alpha]s,bs,\[Beta]s,n],
{3,0,1},HaHypExpAlg[3,0,1,{1,1,0},{0,1},as,\[Alpha]s,bs,\[Beta]s,n],
{3,1,0},HaHypExpAlg[3,1,0,{0,1,1},{1,1},as,\[Alpha]s,bs,\[Beta]s,n],
{3,1,1},HaHypExpAlg[3,1,1,{0,1,1},{0,1},as,\[Alpha]s,bs,\[Beta]s,n],
{3,2,2},HaHypExpAlg[3,2,2,{0,0,1},{0,0},as,\[Alpha]s,bs,\[Beta]s,n],
{3,3,2},HaHypExpAlg[3,3,2,{0,0,0},{0,0},as,\[Alpha]s,bs,\[Beta]s,n],
{4,1,1},HaHypExpAlg[4,1,1,{0,1,1,1},{0,1,1},as,\[Alpha]s,bs,\[Beta]s,n],
{4,3,3},HaHypExpAlg[4,3,3,{0,0,0,1},{0,0,0},as,\[Alpha]s,bs,\[Beta]s,n],
_,Message[HypExp::sorry];$HypExpFailed
];
res//.Num[x_]->x
]


JF[2|3,1,0][k_?(#>-2&)]:=4^(k+1) Sum[Binomial[2k+4,jj] (-1)^jj ypart[k+jj,3+2 k,y],{jj,0,2k+4}]


JF[2|3,1,0][k_?(#<=-2&)]:=4^(k+1) Sum[Binomial[-2k-3,jj] ( ypart[k+jj,0,y]-ypart[k+jj+1,0,y]),{jj,0,-2k-3}]


y2xrule={ypart[j_,k_?(Positive[#]||Negative[#]&),y_:y]:>(x/4/Sqrt[1-x])^k  ypart[j-k,0],ypart[j_?Positive,0,y_:y]:>((2-2 Sqrt[1-x]-x)/x)^j,ypart[j_?NonPositive,0,y_:y]:>((2+2 Sqrt[1-x]-x)/x)^-j};


JPlus[2,1,1][j_,n_,o_,\[Alpha]_]:=
xpart1[-2 j,0]Nest[myint[( JF[2,1,1][-1] #)//HPL`Private`HProductExpand]&,myint[( JF[2,1,1][j-1] ansy[2,1,1,o]@@\[Alpha])//HPL`Private`HProductExpand],n-1]


JPlus[J:(2|3),1,0][j_,n_,o_,\[Alpha]_]:=
Collect[xpart1[-2 j,0] HPL`Private`HProductExpand[Nest[myint2[( JF[J,1,0][-1] #)//HPL`Private`HProductExpand]&,Collect[myint2[( JF[J,1,0][j-1] ansypm[J,1,0,o]@@\[Alpha])//HPL`Private`HProductExpand],{_ypart,_HPL`Private`HH}],n-1]]/.HPL`Private`HH[mm__]:>HPL3[{mm},x],_HPL3]//.y2xrule


De[j_,\[Alpha]_]:=Product[If[j>=0,HypExpi+jj+If[MatchQ[Precision[\[Alpha]],\[Infinity]],\[Alpha],Num[\[Alpha]]] HypExp\[Epsilon],1/(HypExpi+j+jj+If[MatchQ[Precision[\[Alpha]],\[Infinity]],\[Alpha],Num[\[Alpha]]] HypExp\[Epsilon])],{jj,0,If[j>=0,j-1,-j-1]}]


MyTerms[J_,a_List,\[Alpha]_List,b_List,\[Beta]_List,order_,opts___Rule]:=(
Module[{t,j,n,x},t=Product[De[a[[j]],\[Alpha][[j]]],{j,1,J}]/Product[De[b[[j]],\[Beta][[j]]],{j,1,J-1}]/De[1,0];
t=Collect[Expand[intmarker Apart[t,HypExpi]],{intmarker HypExpi^(_:1),intmarker*(HypExpi+aa___)^(_:1),intmarker}]/.ConvertToDenNeg; 
t=Normal[Series[t,{HypExp\[Epsilon],0,order}]];
t=Collect[Expand[Apart[t,HypExpi]],{intmarker HypExpi^(_:1),intmarker*(HypExpi+aa___)^(_:1),intmarker}];
t=t/.ConvertToDen;
t=Collect[t,{Den[___],HypExp\[Epsilon]},DenCoeff[Simplify[#]]&];
t=Expand[t];
DenCoeffRule=t/.{Den[j_,n_,x_] HypExp\[Epsilon]^e_. DenCoeff[coeff_]:>DenCoeff[j,n,x,e]->coeff,Den[j_,n_,x_] DenCoeff[coeff_]:>DenCoeff[j,n,x,0]->Simplify[coeff]};
DenCoeffRule=If[Head[DenCoeffRule]===Plus,Apply[List,DenCoeffRule],DenCoeffRule]/.Num[x_]->x;
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["DenCoeffRule: ",DenCoeffRule]];t=t/.{Den[j_,n_,x_] HypExp\[Epsilon]^e_. DenCoeff[coeff_]->Den[j,n,x]HypExp\[Epsilon]^e  DenCoeff[j,n,x,e],Den[j_,n_,x_] DenCoeff[coeff_]->Den[j,n,x] DenCoeff[j,n,x,0]};
Return[t/.Num[x_]->x]
])


(*MyTerms[J_,a_List,\[Alpha]_List,b_List,\[Beta]_List,order_]:=(
Module[{t},t=Product[De[a[[j]],\[Alpha][[j]] HypExp\[Epsilon]],{j,1,J}]/Product[De[b[[j]],\[Beta][[j]] HypExp\[Epsilon]],{j,1,J-1}]/De[1,0];
t>>test0.m;
t=Collect[int Apart[t,HypExpi],{HypExpi,(HypExpi+aa___)^e_}]/.ConvertToDen; 
Return[Series[t,{HypExp\[Epsilon],0,order}]]
])*)


ConvertToDen={intmarker*(a_.+HypExpi+\[Alpha]_. HypExp\[Epsilon])^(n_:1):>Den[a,-n,\[Alpha]],intmarker*(a_.+HypExpi)^(n_:1):>Den[a,-n,0],intmarker HypExpi^e_.->Den[0,-e,0],intmarker->Den[0,0,0]}
ConvertToDenNeg={(p_ HypExpi+a_?Negative+\[Alpha]_. HypExp\[Epsilon])^(n_:1):>p^n Den[a/p,-n,\[Alpha]/p]/intmarker,(HypExpi+a_?Negative+\[Alpha]_. HypExp\[Epsilon])^(n_:1):>Den[a,-n,\[Alpha]]/intmarker,(HypExpi+a_?Negative)^(n_:1):>Den[a,-n,0]/intmarker}


RuleDenPositive[order_]=Den[j_,n_,\[Alpha]_]:>Sum[Den[j,n+l,0] (-\[Alpha] HypExp\[Epsilon])^l ((n+l-1)!/(l! (n-1)!)),{l,0,order}]/;j>=0&&Not[MatchQ[\[Alpha],0]]


ZPart[J_,a_List,\[Alpha]_List,b_List,\[Beta]_List,order_]:=Product[(1+Sum[(HypExp\[Epsilon] \[Alpha][[j]])^jj Z[HypExpi-1,Table[1,{ii,jj}],Table[1,{ii,jj}]],{jj,order}]),{j,1,J}] Product[(1+Sum[(-HypExp\[Epsilon] \[Beta][[j]])^jj S[HypExpi-1,Table[1,{ii,jj}],Table[1,{ii,jj}]],{jj,order}]),{j,1,J-1}]


MEx[mm_List]:=Table[Prepend[mm[[2]][[jj]],mm[[1]]],{jj,1,Length[mm[[2]]]}]
MEx[mm_List]:={{mm[[1]]}}/;Length[mm[[2]]]==0
ZProd[n_]:=Apply[Join,Table[MEx[{j,ZProd[n-j]}],{j,1,n}]]
ZProd[0]:=1
ZPr[1,0]:=1;
ZPr[1,n_]:=Apply[Plus,PZ[J,n,#] Z[HypExpi-1,#,Table[1,{k,1,n}]]&/@{Table[1,{kkk,1,n}]}]
ZPr[J_,n_]:=Apply[Plus,PZ[J,n,#] Z[HypExpi-1,#,Table[1,{k,1,n}]]&/@ZProd[n]]
ZP[J_,n_]:=Sum[HypExp\[Epsilon]^j ZPr[J,j],{j,0,n}]


MyHypExpansion2[J_,a_List,\[Alpha]_List,b_List,\[Beta]_List,z_,eps_,order_,opts___Rule]:=Module[{A,B,n,remember1,remember2},
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["HypExp, Debugging mode for :",a,\[Alpha],b,\[Beta],{z,eps,order}]];
Module[{i},For[i=1,i<=J,i++,If[a[[i]]<0&&\[Alpha][[i]]==0,Print["Negative parameter without \[Epsilon] part, may give wrong result..." ]]]];
A=Table[a[[ii]]+HypExp\[Epsilon] \[Alpha][[ii]],{ii,1,J}];
B=Table[b[[ii]]+HypExp\[Epsilon] \[Beta][[ii]],{ii,1,J-1}];
n=0;
If[MatchQ[z,1.],Return[MyHypExpansion2[J,a,\[Alpha],b,\[Beta],1,eps,order,opts]]];
If[Plus@@b-Plus@@a<=0&&MatchQ[z,1|1.],Message[HypExp::divergent,A/.HypExp\[Epsilon]->eps,B/.HypExp\[Epsilon]->eps]];
remember1=$HPLAutoConvertToKnownFunctions;
remember2=$HPLAutoReduceToMinimalSet;
If[MatchQ[z,1|1.],$HPLAutoConvertToKnownFunctions=False;$HPLAutoReduceToMinimalSet=True];

NumberOfBle0=0;
NumberOfAle0=0;
NumberOfAeq0=0;
Module[{ii},
For[ii=1,ii<J,ii++,NumberOfBle0=If[b[[ii]]<=0,NumberOfBle0+1,NumberOfBle0]];
For[ii=1,ii<=J,ii++,NumberOfAle0=If[a[[ii]]<=0,NumberOfAle0+1,NumberOfAle0]];
For[ii=1,ii<=J,ii++,NumberOfAeq0=If[a[[ii]]==0,NumberOfAeq0+1,NumberOfAeq0]]
];
OrderToExpandExternSum=Max[order+NumberOfAle0-NumberOfAeq0 ,0];
OrderToExpandInternSum=Max[order-NumberOfAeq0+NumberOfBle0,0];
(*OrderToExpandGammaInExternSum=Max[order+AdditionalOrdersForNegA[order,a]-NumberOfAeq0+NumberOfBle0,0];*)
OrderToExpandGammaInExternSum=Max[order+NumberOfAle0-NumberOfAeq0+NumberOfBle0,0];
OrderToExpandGammaInInternSum2=Max[order-NumberOfAle0+AdditionalOrdersForNegA[order,a]+NumberOfBle0,0]+2;
OrderToExpandGammaInInternSum3=Max[order-NumberOfAle0+AO[a]+NumberOfBle0,0];
OrderToExpandGammaInInternSum=Max[order-NumberOfAeq0+NumberOfBle0,0];
(*********************************************
Note: These all dont work because for each -j you get 
(i-j)(i-j+1)...(i-1)
 in the denominator, so that you have an (i-1)^n
with n the number of negative den's. 
********************************************)

(* Prefactor *)

time=SessionTime[];

extern=Product[invG[A[[j]]],{j,1,J}] Product[G[B[[j]]],{j,1,J-1}];
extern=GammaExpand[extern,OrderToExpandGammaInExternSum];
extern=NumZ[NumS[extern]];
extern=Product[Gamma[1+HypExp\[Epsilon] \[Alpha][[j]]],{j,1,J}] Product[Gamma[1+HypExp\[Epsilon] \[Beta][[j]]],{j,1,J-1}]^-1 extern;
extern=Simplify[Series[extern,{HypExp\[Epsilon],0,OrderToExpandExternSum}]];

If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["extern: ",extern]];

(* inner sum *)
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["**************************** OrderToExpandGammaInInternSum:",OrderToExpandGammaInInternSum]];

test=MyTerms[J,a,\[Alpha],b,\[Beta],OrderToExpandGammaInInternSum,opts] ;
test=test ZP[J,OrderToExpandGammaInInternSum];
test=test//.RuleDenPositive[OrderToExpandGammaInInternSum];
test=Normal[Series[test,{HypExp\[Epsilon],0,OrderToExpandGammaInInternSum}]];
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["**************************** After Myterms:",test]];
test=Collect[test,{Z[_,_,_] Den[_,_,_], Den[_,_,_],Z[_,_,_]}];
test=test//.RuleDenPositive[OrderToExpandGammaInInternSum];
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["**************************** Before MyNegOffset",test]];
test=MyNegOffset[test,OrderToExpandGammaInInternSum];
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["****************************  After MyNegOffset"]];

test=test//.Den[j_,n_,0]:>Den[j,n,1]/;j>=0;

test=Normal[Series[test,{HypExp\[Epsilon],0,OrderToExpandGammaInInternSum}]];

test=MyReduceDen[test];

internresult=Collect[test,{Z[_,_,_] Den[_,_,_],Den[_,_,_],Z[_,_,_]}];

internresult=internresult//.LastZConstruct2;


internresult=internresult//.FinalReplaceDen;
internresult=internresult//.FinalNegOffset[OrderToExpandGammaInInternSum];
internresult=internresult//.FinalReplaceZ;
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["internresult: ",internresult]];

result=Series[1+Normal[extern internresult],{HypExp\[Epsilon],0,order}];
If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["result1: ",result]];
result=result/.DenCoeffRule/.PZReplacementRules[J,OrderToExpandGammaInInternSum][Apply[Sequence,Flatten[Join[\[Alpha],\[Beta]]]]]/.{x->z,HypExp\[Epsilon]->eps};

If[(HypExpDebug/.{opts}/.HypExpDebug->False)==True,Print["result: ",result]];

If[Not[MatchQ[z,1|1.]],result=result/.OneOverOneMinusZ[x_]:>1/(1-x)];

If[MatchQ[z,1|1.],$HPLAutoConvertToKnownFunctions=remember1;$HPLAutoReduceToMinimalSet=remember2];
If[MatchQ[z,1|1.]&&Not[FreeQ[result,HPL[{1},1]|OneOverOneMinusZ]],result=Simplify[result]];
Return[result]
]


knownName=If[StringMatchQ[$System,"*Windows*"],"known.m",".known.m"];
known=Get[ToFileName[{$HypExpPath},knownName]];
loaded={};


IsKnownToOrder[ab___,order_]:=(
Module[{J,a,b},
J=(Length[{ab}]+1)/2;
If[Not[IntegerQ[J]],Message[HypExpIsKnownToOrder::notodd];Return[$HypExpFailed]];
a=Sort[Take[{ab},{1,J}]];
b=Sort[Take[{ab},{J+1,2 J-1}]];
MemberQ[known,Join[a,b],{order,Infinity}]])

HypExpIsKnownToOrder[ab___,order_]:=IsKnownToOrder[ab,order]


KnownTillQ[a___]:=(Module[{order},For[order=1,IsKnownToOrder[a,order]==True,order++];
Return[order-1]])


CompleteForOrder[a_,n_]:=Module[{j,t},If[Depth[a]<n+2,t=a;For[j=1,Depth[t]<n+2,j++,t=Insert[t,{StringJoin["knowntoorder",ToString[Depth[t]]]},Table[-1,{ii,1,Depth[t]-1}]]];t,a]]


AddToKnown[a___,order_]:=(
If[KnownTillQ[a]!=0,If[KnownTillQ[a]>=order,Print[{a}," is already known to this or a higher order..."];Return[],RemoveFromKnown[a]]];
known=CompleteForOrder[known,order];
known=Insert[
known
,{a},Append[Table[-1,{ii,1,order-1}],-2]];
Put[known,ToFileName[{$HypExpPath},knownName]]
 );


RemoveFromKnown[a___]:=(
Module[{order,ii},order=KnownTillQ[a];
If[order==0,Print[a," was not in the known expansions..."];Return[]];
For[ii=2,ii<=Length[known[[Sequence@@Table[-1,{jj,1,order-1}]]]-1],ii++,If[MatchQ[known[[Sequence@@Table[-1,{jj,1,order-1}],ii]],{a}],known=Delete[known,Append[Table[-1,{jj,1,order-1}],ii]];Return[]]]
])


AddToLoaded[a1_,a2_,b1_]:=(loaded=If[MemberQ[loaded,{a1,a2,b1}],loaded,Insert[loaded,{a1,a2,b1},-1]]);


LoadFromBib[ab___]:=(Module[{bibfile},
bibfile=StringJoin["hypexp",ToString/@{ab},".m"];
bibhypexp[ab]=Get[ToFileName[{$HypExpPath,ToString[KnownTillQ[ab]]},bibfile]];
AddToLoaded[ab]];
)


HypExpAddToLib[ab___,order_]:=(
Module[{J,l},
If[IsKnownToOrder[ab,order],Print["The expansion for {a,b} = ",{ab}," is already known to that order!"];Return[]];
If[Max[Abs/@{ab}]>=10,Message[HypExpAddToLiB::LargerThan9];Return[$HypExpFailed]];
l=Length[{ab}];
If[Mod[l,2]!=1,Message[HypExpAddToLiB::ArgNoMatch];Return[$HypExpFailed]];
J=Quotient[l,2]+1;
tobib=Simplify[MyHypExpansion2[J,Table[{ab}[[j]],{j,1,J}],Table[ToExpression[StringJoin["a",ToString[j]]],{j,1,J}],Table[{ab}[[j]],{j,J+1,l}],Table[ToExpression[StringJoin["b",ToString[j]]],{j,J+1,l}],x,e,order]];
If[MatchQ[FileType[ToFileName[{$HypExpPath},ToString[order]]],None],CreateDirectory[ToString[$HypExpPath] <>"/"<>ToString[order]]];
Put[Function[Evaluate[Join[Table[ToExpression[StringJoin["a",ToString[j]]],{j,1,J}],Table[ToExpression[StringJoin["b",ToString[j+J]]],{j,1,J-1}],{x,e}]],Evaluate[tobib]],ToFileName[{$HypExpPath,ToString[order]},StringJoin["hypexp",StringJoin[ToString/@{ab}],".m"]]]
];
AddToKnown[ab,order])

HypExpAddToLib::ArgNoMatch="The numer of arguments does not match an \!\(\*SubscriptBox[\"F\", 
RowBox[{\"J\", \"-\", \"1\"}]]\) function."
HypExpAddToLib::LargerThan9="The package HypExp only supports library for arguments smaller than 10."


TestParam2F1[A1_,A2_,B1_,\[Epsilon]_]:=(Module[{\[Alpha]1,\[Alpha]2,\[Beta]1,a1,a2,b1},
\[Alpha]1=Coefficient[Expand[A1],\[Epsilon]];
\[Alpha]2=Coefficient[Expand[A2],\[Epsilon]];
\[Beta]1=Coefficient[Expand[B1],\[Epsilon]];
a1=Coefficient[A1 \[Epsilon],\[Epsilon]];
a2=Coefficient[A2 \[Epsilon],\[Epsilon]];
b1=Coefficient[B1 \[Epsilon],\[Epsilon]];

If [!(Head[a1]===Integer),Return[False]];
If [!(Head[a2]===Integer),Return[False]];
If [!(Head[b1]===Integer),Return[False]];
Return[True];
])


TestParamPFQ[A_List,B_List,\[Epsilon]_]:=(Module[{\[Alpha],\[Beta],a,b,ii,J},J=Length[A];
If[Length[B]!=J-1,Return[False]];
If[Length[B]==0,Return[False]];
\[Alpha]=Table[Coefficient[Expand[A[[ii]]],\[Epsilon]],{ii,1,J}];
a=Table[Coefficient[A[[ii]] \[Epsilon],\[Epsilon]],{ii,1,J}];
\[Beta]=Table[Coefficient[Expand[B[[ii]]],\[Epsilon]],{ii,1,J-1}];
b=Table[Coefficient[B[[ii]] \[Epsilon],\[Epsilon]],{ii,1,J-1}];

(*
testing the input parameters
*)

For[ii=1,ii<=J,ii++,If [!(Head[a[[ii]]]===Integer),Return[False]]];
For[ii=1,ii<=J-1,ii++,If [!(Head[b[[ii]]]===Integer),Return[False]]];
Return[True];
])


TestParam2F1Half[A1_,A2_,B1_,\[Epsilon]_]:=(Module[{\[Alpha]1,\[Alpha]2,\[Beta]1,a1,a2,b1},
\[Alpha]1=Coefficient[Expand[A1],\[Epsilon]];
\[Alpha]2=Coefficient[Expand[A2],\[Epsilon]];
\[Beta]1=Coefficient[Expand[B1],\[Epsilon]];
a1=Coefficient[A1 \[Epsilon],\[Epsilon]];
a2=Coefficient[A2 \[Epsilon],\[Epsilon]];
b1=Coefficient[B1 \[Epsilon],\[Epsilon]];

If [!(MatchQ[a1,_Integer|Rational[_,2]]),Return[False]];
If [!(MatchQ[a2,_Integer|Rational[_,2]]),Return[False]];
If [!(MatchQ[b1,_Integer|Rational[_,2]]),Return[False]];
Return[True];
])


TestParamPFQHalf[A_List,B_List,\[Epsilon]_]:=(Module[{\[Alpha],\[Beta],a,b,ii,J},J=Length[A];
If[Length[B]!=J-1,Return[False]];
If[Length[B]==0,Return[False]];
\[Alpha]=Table[Coefficient[Expand[A[[ii]]],\[Epsilon]],{ii,1,J}];
a=Table[Coefficient[A[[ii]] \[Epsilon],\[Epsilon]],{ii,1,J}];
\[Beta]=Table[Coefficient[Expand[B[[ii]]],\[Epsilon]],{ii,1,J-1}];
b=Table[Coefficient[B[[ii]] \[Epsilon],\[Epsilon]],{ii,1,J-1}];

(*
testing the input parameters
*)

For[ii=1,ii<=J,ii++,If [!(MatchQ[a[[ii]],_Integer|Rational[_,2]]),Return[False]]];
For[ii=1,ii<=J-1,ii++,If [!(MatchQ[a[[ii]],_Integer|Rational[_,2]]),Return[False]]];
Return[True];
])


HypExp[Hypergeometric2F1[A1_,A2_,B1_,1|1.],\[Epsilon]_,order_Integer]:=Normal[Series[Gamma[B1-A1-A2] Gamma[B1]/(Gamma[B1-A1] Gamma[B1-A2]),{\[Epsilon],0,order}]];



HypExp[Hypergeometric2F1[A1_,A2_,B1_,x_],\[Epsilon]_,order_Integer]:=(Module[{a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1},
Return[HypExp[MyHypergeometric2F1[A2,A1,B1,x],\[Epsilon],order]];
])/;TestParam2F1[A1,A2,B1,\[Epsilon]];
HypExp[MyHypergeometric2F1[A1_,A2_,B1_,x_],\[Epsilon]_,order_Integer]:=(Module[{a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1},
If[!(Head[\[Epsilon]])===Symbol,Message[MyHypExpansion::nosymbolicexpansionparameter,\[Epsilon]];Return[$HypExpFailed]];
\[Alpha]1=Coefficient[Expand[A1],\[Epsilon]];
\[Alpha]2=Coefficient[Expand[A2],\[Epsilon]];
\[Beta]1=Coefficient[Expand[B1],\[Epsilon]];
a1=Coefficient[A1 \[Epsilon],\[Epsilon]];
a2=Coefficient[A2 \[Epsilon],\[Epsilon]];
b1=Coefficient[B1 \[Epsilon],\[Epsilon]];

If[a1>a2,Return[HypExp[MyHypergeometric2F1[A2,A1,B1,x],\[Epsilon],order]]];

Return[If[IsKnownToOrder[a1,a2,b1,order],
	If[MemberQ[loaded,{a1,a2,b1}],
		knownandloaded[a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1,x,\[Epsilon],order],	
		knownbutnotloaded[a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1,x,\[Epsilon],order]
	],
neitherknownnorloaded[a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1,x,\[Epsilon],order]
]
];

If[b1==0&&\[Beta]1==0,Return[$HypExpFailed];Message[MyHypExpansion::zeroC]];

])/;TestParam2F1[A1,A2,B1,\[Epsilon]];




HypExp[Hypergeometric2F1[A1_,A2_,B1_,xx_],\[Epsilon]\[Epsilon]_,order_Integer]:=(HaHypExp[{A1,A2},{B1},\[Epsilon]\[Epsilon],order]/.{x->xx,\[Epsilon]->\[Epsilon]\[Epsilon]})/;TestParam2F1Half[A1,A2,B1,\[Epsilon]\[Epsilon]];


HypExp[x_,\[Epsilon]_,order_]:=x;


knownandloaded[a1_,a2_,b1_,\[Alpha]1_,\[Alpha]2_,\[Beta]1_,z_,\[Epsilon]_,order_]:=Normal[Series[bibhypexp[a1,a2,b1][\[Alpha]1,\[Alpha]2,\[Beta]1,z,\[Epsilon]],{\[Epsilon],0,order}]]; 
knownbutnotloaded[a1_,a2_,b1_,\[Alpha]1_,\[Alpha]2_,\[Beta]1_,z_,\[Epsilon]_,order_]:=(
LoadFromBib[a1,a2,b1];
Return[knownandloaded[a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1,z,\[Epsilon],order]];
);
neitherknownnorloaded[a1_,a2_,b1_,\[Alpha]1_,\[Alpha]2_,\[Beta]1_,x_,\[Epsilon]_,order_]:=If[withTobias[{a1,a2,b1,order}],
Return[Tobias[{a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1,x,\[Epsilon],order}]],
Return[Daniel[{a1,a2,b1,\[Alpha]1,\[Alpha]2,\[Beta]1,x,\[Epsilon],order}]]
];



THEmaxeps[a1_,a2_,b1_]:=If[((b1<0)&&(a1<0)&&(a2<0)&&(b1>a1)&&(b1>a2))||((b1<0)&&(a1>0)&&(a2<0)&&(b1>a2))||((b1<0)&&(a1<0)&&(a2>0)&&(b1>a1))||((b1<0)&&(a1>0)&&(a2>0))||((b1==0)&&(a1!=0)&&(a2!=0))||((b1>0)&&(a1>0)&&(a2>0)&&(b1>a1)&&(b1>a2)),4,5];
withTobias[{a1_,a2_,b1_,order_}]:=If[order<=THEmaxeps[a1,a2,b1],True,False];


Daniel[{a1_,a2_,b1_,\[Alpha]1_,\[Alpha]2_,\[Beta]1_,x_,\[Epsilon]_,order_}]:=Normal[MyHypExpansion2[2,{a1,a2},{\[Alpha]1,\[Alpha]2},{b1},{\[Beta]1},x,\[Epsilon],Max[order,0]]]


HypExp[HypergeometricPFQ[A_List?(Length[#]==2&),B_List?(Length[#]==1&),1|1.],\[Epsilon]_,order_Integer]:=HypExp[Hypergeometric2F1[Sequence@@A,Sequence@@B,1],\[Epsilon],order]


HypExp[HypergeometricPFQ[A_List?(Length[#]==2&),B_List?(Length[#]==1&),x_],\[Epsilon]_,order_Integer]:=HypExp[Hypergeometric2F1[Sequence@@A,Sequence@@B,x],\[Epsilon],order]


HaHypExpAtOneNonCrit[A_List,B_List,eps_,order_]:=Module[{res,resprime,erg1,\[Delta],xx,remem},remem=$HPLAutoConvertToKnownFunctions;$HPLAutoConvertToKnownFunctions=False;res=HaHypExp[A,B,eps,order];res=res//Expand;res=Collect[res,{\[Epsilon],HPL[f_List,g_]},Simplify];resprime=res//.{HPL[AA_List,z_]:>HPLArgTransform[HPL[AA,z],x->1/x,\[Delta]]/;MatchQ[Simplify[z-I Power[x/(1-x),1/2]],0]};(*resprime=resprime//Expand;*)resprime=resprime//.{HPL[AB_List,z_]:>HPL[AB,0]/;MatchQ[Simplify[z+I Power[x/(1-x),-1/2]],0]};resprime=resprime//.{x:>1-bar[xx]};resprime=resprime//.{Power[(1-bar[xx])/bar[xx],dr_]:>Power[1-bar[xx],dr]/Power[bar[xx],dr]};resprime=Collect[resprime,\[Epsilon],Simplify];resprime=Collect[resprime,\[Epsilon],Expand];resprime=Collect[resprime,\[Epsilon],Apart[#,bar[xx]]&];resprime=resprime//.{bar[xx]:>0};$HPLAutoConvertToKnownFunctions=remem;erg1=Collect[resprime,\[Epsilon],Expand];erg1=erg1//.{Power[\[Delta],s_Integer]:>Power[\[Delta],s-2]/;s>1};erg1=Expand[FunctionExpand[Expand[erg1]]];erg1=Collect[erg1,\[Epsilon],Expand];erg1=erg1//.{\[Delta]:>1};erg1=erg1//.{\[Epsilon]:>eps};erg1=Collect[erg1,eps,Expand];Return[erg1]]/;((MatchQ[Length[B],Length[A]-1])&&(((Apply[Plus,B]-Apply[Plus,A])//.{eps:>0})>0)&&(Length[B]!=0));


HaHypExpAtOneCrit[A_List,B_List,\[Epsilon]_,order_]:=Module[{zwischen,res,rres,C},zwischen=HypExpAtOne[A,B,\[Epsilon]];res=Collect[zwischen,_HypergeometricPFQ,C];res=res/.C[x_]:>C[x,Switch[rres=Series[x,{\[Epsilon],0,0}],_SeriesData,rres[[-3]],_,0]];res=res/.{C[coeff_,n_] HypergeometricPFQ[dr_List,sw_List,1]:>Normal[Series[Normal[Series[coeff,{\[Epsilon],0,order+Length[A]+Length[B]}]]*Evaluate[HaHypExpAtOneNonCrit[dr,sw,\[Epsilon],Max[0,order-n]]],{\[Epsilon],0,order}]],C[coeff_,n_]->coeff};
Return[Collect[res,\[Epsilon],Expand]]]/;((MatchQ[Length[B],Length[A]-1])&&(((Apply[Plus,B]-Apply[Plus,A])//.{\[Epsilon]:>0})<=0)&&(Not[FreeQ[Expand[Apply[Plus,B]-Apply[Plus,A]],\[Epsilon]]])&&(Length[B]!=0))


HypExp[HypergeometricPFQ[Aunsorted_List,Bunsorted_List,1|1.],\[Epsilon]_,order_Integer]:=Normal[HypExpAtOne[Aunsorted,Bunsorted,\[Epsilon],order]]/;MatchQ[Length[Bunsorted],Length[Aunsorted]-1]&&((Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted])/.\[Epsilon]->0)<=0&&Not[FreeQ[Expand[Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted]],\[Epsilon]]]&&Length[Bunsorted]!=0&&TestParamPFQ[Aunsorted,Bunsorted,\[Epsilon]]


HypExp[HypergeometricPFQ[Aunsorted_List,Bunsorted_List,1|1.],\[Epsilon]\[Epsilon]_,order_Integer]:=(Normal[HaHypExpAtOneCrit[Aunsorted,Bunsorted,\[Epsilon]\[Epsilon],order]]/.\[Epsilon]->\[Epsilon]\[Epsilon])/;MatchQ[Length[Bunsorted],Length[Aunsorted]-1]&&((Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted])/.\[Epsilon]\[Epsilon]->0)<=0&&Not[FreeQ[Expand[Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted]],\[Epsilon]\[Epsilon]]]&&Length[Bunsorted]!=0&&TestParamPFQHalf[Aunsorted,Bunsorted,\[Epsilon]\[Epsilon]]


HypExp[HypergeometricPFQ[Aunsorted_List,Bunsorted_List,1|1.],\[Epsilon]_,order_Integer]:=(Message[HypExp::expnotdef,Aunsorted,Bunsorted];Return[$HypExpFailed])/;MatchQ[Length[Bunsorted],Length[Aunsorted]-1]&&((Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted])/.\[Epsilon]->0)<=0&&FreeQ[Expand[Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted]],\[Epsilon]]


HypExp[HypergeometricPFQ[Aunsorted_List,Bunsorted_List,x_],\[Epsilon]_,order_Integer]:=(Module[{A,B,a,b,\[Alpha],\[Beta],J,ii},
A=Sort[Aunsorted,(#1/.\[Epsilon]->0)<(#2/.\[Epsilon]->0)&];
B=Sort[Bunsorted,(#1/.\[Epsilon]->0)<(#2/.\[Epsilon]->0)&];
If[!(Head[\[Epsilon]])===Symbol,Message[MyHypExpansion::nosymbolicexpansionparameter,\[Epsilon]];Return[$HypExpFailed]];

J=Length[A];
If[Length[B]!=J-1,Message[HypExp::notJFJm1,J,Length[B]];Return[$HypExpFailed]];
\[Alpha]=Table[Coefficient[Expand[A[[ii]]],\[Epsilon]],{ii,1,J}];
a=Table[Coefficient[A[[ii]] \[Epsilon],\[Epsilon]],{ii,1,J}];
\[Beta]=Table[Coefficient[Expand[B[[ii]]],\[Epsilon]],{ii,1,J-1}];
b=Table[Coefficient[B[[ii]] \[Epsilon],\[Epsilon]],{ii,1,J-1}];

Return[If[IsKnownToOrder[Sequence@@Join[a,b],order]&&Not[MatchQ[x,1|1.]],
	If[MemberQ[loaded,Join[a,b]],
		knownandloaded[a,\[Alpha],b,\[Beta],x,\[Epsilon],order],	
		knownbutnotloaded[a,\[Alpha],b,\[Beta],x,\[Epsilon],order]
	],
neitherknownnorloaded[a,\[Alpha],b,\[Beta],x,\[Epsilon],order]]];
])/;Not[MatchQ[x,1|1.]&&MatchQ[Length[Bunsorted],Length[Aunsorted]-1]&&((Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted])/.\[Epsilon]->0)<=0]&&TestParamPFQ[Aunsorted,Bunsorted,\[Epsilon]]


knownandloaded[a_List,\[Alpha]_List,b_List,\[Beta]_List,z_,\[Epsilon]_,order_]:=Normal[Series[bibhypexp[Sequence@@Join[a,b]][Sequence@@Join[\[Alpha],\[Beta]],z,\[Epsilon]],{\[Epsilon],0,order}]]; 


knownbutnotloaded[a_List,\[Alpha]_List,b_List,\[Beta]_List,z_,\[Epsilon]_,order_]:=(
LoadFromBib[Sequence@@Join[a,b]];
Return[knownandloaded[a,\[Alpha],b,\[Beta],z,\[Epsilon],order]];
)


neitherknownnorloaded[a_List,\[Alpha]_List,b_List,\[Beta]_List,x_,\[Epsilon]_,order_?NonNegative]:=Normal[MyHypExpansion2[Length[a],a,\[Alpha],b,\[Beta],x,\[Epsilon],order]]


neitherknownnorloaded[a_List,\[Alpha]_List,b_List,\[Beta]_List,x_,\[Epsilon]_,order_?Negative]:=Normal[Series[MyHypExpansion2[Length[a],a,\[Alpha],b,\[Beta],x,\[Epsilon],0],{\[Epsilon],0,order}]]


HypExp[HypergeometricPFQ[Aunsorted_List,Bunsorted_List,xx_],\[Epsilon]\[Epsilon]_,order_Integer]:= (HaHypExp[Aunsorted,Bunsorted,\[Epsilon]\[Epsilon],order]/.\[Epsilon]->\[Epsilon]\[Epsilon]/.x->xx)/;TestParamPFQHalf[Aunsorted,Bunsorted,\[Epsilon]\[Epsilon]]&&(!MatchQ[xx,1|1.])


HypExp[HypergeometricPFQ[Aunsorted_List,Bunsorted_List,xx_],\[Epsilon]\[Epsilon]_,order_Integer]:=(HaHypExpAtOneNonCrit[Aunsorted,Bunsorted,\[Epsilon]\[Epsilon],order]/.\[Epsilon]->\[Epsilon]\[Epsilon]/.x->xx)/;TestParamPFQHalf[Aunsorted,Bunsorted,\[Epsilon]\[Epsilon]]&&MatchQ[xx,1|1.]&&MatchQ[Length[Bunsorted],Length[Aunsorted]-1]&&!(((Apply[Plus,Bunsorted]-Apply[Plus,Aunsorted])/.\[Epsilon]\[Epsilon]->0)<=0)


(*here are some problems in Mathematica 5.0 for unprotecting the hyergeometric function, calling twice the rule seems to solve the problem. The problem is not present in the version 5.1*)
If[StringMatchQ[$Version,"*5.0*"]||StringMatchQ[$Version,"*6.0*"],Off[TagSetDelayed::write];Off[SetDelayed::write]]

If[StringMatchQ[$Version,"*5.1*"]|| StringMatchQ[$Version,"*5.2*"]|| StringMatchQ[$Version,"*6.0*"],
Unprotect[Series];

Series/:Series[p__ Hypergeometric2F1[a1_,a2_,b1_,x_],{\[Epsilon]_,0,n_Integer}]:=Module[{res,rres,np},np=Switch[rres=Series[Times[p],{\[Epsilon],0,0}],_SeriesData,rres[[-3]],_,0];
res=HypExp[Hypergeometric2F1[a1,a2,b1,x],\[Epsilon],Max[0,n-np]];
If[MatchQ[res,0],SeriesData[\[Epsilon],0,List[],n+1,n+1,1],Series[Series[res,{\[Epsilon],0,Max[0,n-np]}] Times[p],{\[Epsilon],0,n}]]]/;HypExp`Private`TestParam2F1[a1,a2,b1,\[Epsilon]]||HypExp`Private`TestParam2F1Half[a1,a2,b1,\[Epsilon]];


Series/:Series[p__+q__ Hypergeometric2F1[a1_,a2_,b1_,x_],{\[Epsilon]_,0,n_Integer}]:=Series[Plus[p],{\[Epsilon],0,n}]+Series[q Hypergeometric2F1[a1,a2,b1,x],{\[Epsilon],0,n}]/;HypExp`Private`TestParam2F1[a1,a2,b1,\[Epsilon]]||HypExp`Private`TestParam2F1Half[a1,a2,b1,\[Epsilon]];

Series/:Series[p__ Hypergeometric2F1Regularized[a1_,a2_,b1_,x_],{\[Epsilon]_,0,n_Integer}]:=Module[{res,rres,np},np=Switch[rres=Series[Times[p],{\[Epsilon],0,0}],_SeriesData,rres[[-3]],_,0];
res=Series[Hypergeometric2F1Regularized[a1,a2,b1,x],{\[Epsilon],0,Max[0,n-np]}];
If[MatchQ[res,0],SeriesData[\[Epsilon],0,List[],n+1,n+1,1],Series[res Times[p],{\[Epsilon],0,n}]]]/;HypExp`Private`TestParam2F1[a1,a2,b1,\[Epsilon]]||HypExp`Private`TestParam2F1Half[a1,a2,b1,\[Epsilon]];

Series/:Series[p__+q__ Hypergeometric2F1Regularized[a1_,a2_,b1_,x_],{\[Epsilon]_,0,n_Integer}]:=Series[Plus[p],{\[Epsilon],0,n}]+Series[q Hypergeometric2F1Regularized[a1,a2,b1,x],{\[Epsilon],0,n}]/;HypExp`Private`TestParam2F1[a1,a2,b1,\[Epsilon]]||HypExp`Private`TestParam2F1Half[a1,a2,b1,\[Epsilon]];


ga=(a_.+b_. \[Epsilon]_|b_. \[Epsilon]_|a_Integer?NonNegative);gan=(aa_Integer?NonPositive+bb_. \[Epsilon]\[Epsilon]_);
Series/:Series[p__ thebeta:(Beta[z_,gan,ga]|Beta[z_,ga,gan]),{\[Epsilon]_,0,n_Integer}]:=Module[{res,rres,np},np=Switch[rres=Series[Times[p],{\[Epsilon],0,0}],_SeriesData,rres[[-3]],_,0];
res=Series[thebeta,{\[Epsilon],0,Max[0,n-np]}];
If[MatchQ[res,0],SeriesData[\[Epsilon],0,List[],n+1,n+1,1],Series[res Times[p],{\[Epsilon],0,n}]]];

Series/:Series[p__+q__ thebeta:(Beta[z_,gan,ga]|Beta[z_,ga,gan]),{\[Epsilon]_,0,n_Integer}]:=Series[Plus[p],{\[Epsilon],0,n}]+Series[q thebeta,{\[Epsilon],0,n}];

Protect[Series]
]

Unprotect[Hypergeometric2F1]
Hypergeometric2F1/:Series[Hypergeometric2F1[a1_,a2_,b1_,x_],{\[Epsilon]_,0,n_Integer}]:=Module[{res},res=HypExp[Hypergeometric2F1[a1,a2,b1,x],\[Epsilon],n];
If[MatchQ[res,0],SeriesData[\[Epsilon],0,List[],n+1,n+1,1],Series[res,{\[Epsilon],0,n}]]]/;TestParam2F1[a1,a2,b1,\[Epsilon]]||TestParam2F1Half[a1,a2,b1,\[Epsilon]]
Protect[Hypergeometric2F1];

Unprotect[Hypergeometric2F1];
Hypergeometric2F1/:Series[Hypergeometric2F1[a1_,a2_,b1_,x_],{\[Epsilon]_,0,n_Integer}]:=Module[{res},res=HypExp[Hypergeometric2F1[a1,a2,b1,x],\[Epsilon],n];
If[MatchQ[res,0],SeriesData[\[Epsilon],0,List[],n+1,n+1,1],Series[res,{\[Epsilon],0,n}]]]/;TestParam2F1[a1,a2,b1,\[Epsilon]]||TestParam2F1Half[a1,a2,b1,\[Epsilon]]
Protect[Hypergeometric2F1];

Unprotect[HypergeometricPFQ];HypergeometricPFQ/:Series[HypergeometricPFQ[A_List,B_List,x_],{\[Epsilon]\[Epsilon]_,0,n_Integer}]:=Module[{res},res=HypExp[HypergeometricPFQ[A,B,x],\[Epsilon],n];
If[MatchQ[res,0],SeriesData[\[Epsilon],0,List[],n+1,n+1,1],Series[res,{\[Epsilon],0,n}]]]/;TestParamPFQ[A,B,\[Epsilon]\[Epsilon]]||TestParamPFQHalf[A,B,\[Epsilon]\[Epsilon]]
Protect[HypergeometricPFQ];

Unprotect[HypergeometricPFQ];
HypergeometricPFQ/:Series[HypergeometricPFQ[A_List,B_List,x_],{\[Epsilon]_,0,n_Integer}]:=Module[{res},res=HypExp[HypergeometricPFQ[A,B,x],\[Epsilon],n];
If[MatchQ[res,0],SeriesData[\[Epsilon],0,List[],n+1,n+1,1],Series[res,{\[Epsilon],0,n}]]]/;TestParamPFQ[A,B,\[Epsilon]]||TestParamPFQHalf[A,B,\[Epsilon]]
(*Protect[HypergeometricPFQ]*)


Unprotect[HypergeometricPFQ];
Unprotect[HypergeometricPFQ];
HypergeometricPFQ[mm1:({___,SeriesData[\[Epsilon]_,0,_,m:(0|1),n_,1],___}),mm2___List,x_]:=Series[HypergeometricPFQ[Normal/@mm1,Normal/@mm2,x],{\[Epsilon],0,n-1}]/;TestParamPFQ[Normal[mm1],Normal[mm2],\[Epsilon]]||TestParamPFQHalf[Normal[mm1],Normal[mm2],\[Epsilon]]

HypergeometricPFQ[mm1___List,mm2:({___,SeriesData[\[Epsilon]_,0,_,m:(0|1),n_,1],___}),x_]:=Series[HypergeometricPFQ[Normal/@mm1,Normal/@mm2,x],{\[Epsilon],0,n-1}]/;TestParamPFQ[Normal[mm1],Normal[mm2],\[Epsilon]]||TestParamPFQHalf[Normal[mm1],Normal[mm2],\[Epsilon]]
Protect[HypergeometricPFQ];



If[StringMatchQ[$Version,"*5.0*"]||StringMatchQ[$Version,"*6.0*"],Off[TagSetDelayed::write];Off[SetDelayed::write]]



Unprotect[Beta]
Beta/:Series[Beta[z_,p_.+\[Alpha]_. \[Epsilon]_,q_.+\[Beta]_. \[Epsilon]_],{\[Epsilon]_,0,n_}]:=Series[z^(p+\[Alpha] \[Epsilon])/(p+\[Alpha] \[Epsilon]) Hypergeometric2F1[p+\[Alpha] \[Epsilon],1-q-\[Beta] \[Epsilon],1+p+\[Alpha] \[Epsilon],z],{\[Epsilon],0,n}]
Beta/:Series[Beta[z_,p_,q_.+\[Beta]_. \[Epsilon]_],{\[Epsilon]_,0,n_}]:=Series[z^(p+\[Alpha] \[Epsilon])/(p+\[Alpha] \[Epsilon]) Hypergeometric2F1[p+\[Alpha] \[Epsilon],1-q-\[Beta] \[Epsilon],1+p+\[Alpha] \[Epsilon],z],{\[Epsilon],0,n}]/;Not[IntegerQ[p]&p<=0]
Beta/:Series[Beta[z_,p_.+\[Alpha]_. \[Epsilon]_,q_],{\[Epsilon]_,0,n_}]:=Series[z^(p+\[Alpha] \[Epsilon])/(p+\[Alpha] \[Epsilon]) Hypergeometric2F1[p+\[Alpha] \[Epsilon],1-q-\[Beta] \[Epsilon],1+p+\[Alpha] \[Epsilon],z],{\[Epsilon],0,n}]
Protect[Beta]


Unprotect[Beta]
Derivative[0,n_Integer?Positive,0][Beta][x_,p_,q_]:=n! SeriesCoefficient[Series[z^(p+\[Epsilon])/(p+\[Epsilon]) Hypergeometric2F1[p+\[Epsilon],1-q,1+p+\[Epsilon],x],{\[Epsilon],0,n}],n]
Protect[Beta]


Unprotect[Hypergeometric2F1Regularized]
Hypergeometric2F1Regularized/:Series[Hypergeometric2F1Regularized[a1_,a2_,b1_,x_],{\[Epsilon]_,0,n_Integer?NonNegative}]:=Series[Hypergeometric2F1[a1,a2,b1,x]/Gamma[b1],{\[Epsilon],0,n}]/;TestParam2F1[a1,a2,b1,\[Epsilon]]
Protect[Hypergeometric2F1Regularized]

Unprotect[HypergeometricPFQRegularized]
HypergeometricPFQRegularized/:Series[HypergeometricPFQRegularized[A_List,B_List,x_],{\[Epsilon]_,0,n_Integer?NonNegative}]:=Series[HypergeometricPFQ[A,B,x]/(Apply[Times,Gamma/@B]),{\[Epsilon],0,n}]/;TestParamPFQ[A,B,\[Epsilon]]
Protect[HypergeometricPFQRegularized]



Derivative[n1_Integer?NonNegative,n2_Integer?NonNegative,n3_Integer?NonNegative,0][Hypergeometric2F1][a1_Integer,a2_Integer,b1_Integer,x_]:=Module[{t,\[Epsilon],res,\[Alpha]1,\[Alpha]2,\[Beta]1},
res=Series[Hypergeometric2F1[a1+\[Alpha]1 \[Epsilon],a2+\[Alpha]2 \[Epsilon],b1+\[Beta]1 \[Epsilon],x],{\[Epsilon],0,n1+n2+n3}];rres=Expand[SeriesCoefficient[res,n1+n2+n3]];
Return[(n1! n2! n3!) Coefficient[rres,\[Alpha]1^n1 \[Alpha]2^n2 \[Beta]1^n3]]]


Derivative[n1_Integer?NonNegative,n2_Integer?NonNegative,n3_Integer?NonNegative,0][Hypergeometric2F1Regularized][a1_Integer,a2_Integer,b1_Integer,x_]:=Module[{t,\[Epsilon],res,\[Alpha]1,\[Alpha]2,\[Beta]1},
res=Series[Hypergeometric2F1[a1+\[Alpha]1 \[Epsilon],a2+\[Alpha]2 \[Epsilon],b1+\[Beta]1 \[Epsilon],x]/Gamma[b1+\[Beta]1 \[Epsilon]],{\[Epsilon],0,n1+n2+n3}];rres=Expand[SeriesCoefficient[res,n1+n2+n3]];
Return[(n1! n2! n3!) Coefficient[rres,\[Alpha]1^n1 \[Alpha]2^n2 \[Beta]1^n3]]]


Derivative[n1_List,n2_List,0][HypergeometricPFQ][a_List,b_List,x_]:=Module[{t,\[Epsilon],res,\[Alpha],\[Beta],\[Alpha]vect,\[Beta]vect,order},
\[Alpha]vect=MapIndexed[f,a]/.f[i_,j_]:>\[Alpha]@@j;
\[Beta]vect=MapIndexed[f,b]/.f[i_,j_]:>\[Beta]@@j;
order=Plus@@(Flatten[{n1,n2}]);
res=Series[HypergeometricPFQ[a+\[Alpha]vect \[Epsilon],b+\[Beta]vect \[Epsilon],x],{\[Epsilon],0,order}];
rres=Expand[SeriesCoefficient[res,order]];
Return[(Times@@(n1!)) (Times@@(n2!)) Coefficient[rres,Times@@(\[Alpha]vect^n1) Times@@(\[Beta]vect^n2)]]]/;ArrayQ[n1,1,IntegerQ[#]&&NonNegative[#]&]&&ArrayQ[n2,1,IntegerQ[#]&&NonNegative[#]&]&&ArrayQ[a,1,IntegerQ]&&ArrayQ[b,1,IntegerQ]


Derivative[n1_List,n2_List,0][HypergeometricPFQRegularized][a_List,b_List,x_]:=Module[{t,\[Epsilon],res,\[Alpha],\[Beta],\[Alpha]vect,\[Beta]vect,order},
\[Alpha]vect=MapIndexed[f,a]/.f[i_,j_]:>\[Alpha]@@j;
\[Beta]vect=MapIndexed[f,b]/.f[i_,j_]:>\[Beta]@@j;
order=Plus@@(Flatten[{n1,n2}]);
res=Series[HypergeometricPFQ[a+\[Alpha]vect \[Epsilon],b+\[Beta]vect \[Epsilon],x]/(Apply[Times,Gamma/@(b+\[Beta]vect \[Epsilon])]),{\[Epsilon],0,order}];
rres=Expand[SeriesCoefficient[res,order]];
Return[(Times@@(n1!)) (Times@@(n2!))Coefficient[rres,Times@@(\[Alpha]vect^n1) Times@@(\[Beta]vect^n2)]]]/;ArrayQ[n1,1,IntegerQ[#]&&NonNegative[#]&]&&ArrayQ[n2,1,IntegerQ[#]&&NonNegative[#]&]&&ArrayQ[a,1,IntegerQ]&&ArrayQ[b,1,IntegerQ]


TestParamPFQHalfKnown[A_,B_]:=Module[{J,as,bs,\[Alpha]s,\[Beta]s},
J=Length[A];
r=Count[A,Rational[_,2]];
s=Count[B,Rational[_,2]];
Return[MatchQ[{J,r,s},JrsKnown]]]


Derivative[n1_Integer?NonNegative,n2_Integer?NonNegative,n3_Integer?NonNegative,0][Hypergeometric2F1][a1:(_Integer|Rational[_,2]),a2:(_Integer|Rational[_,2]),b1:(_Integer|Rational[_,2]),x_]:=Module[{t,\[Epsilon],res,\[Alpha]1,\[Alpha]2,\[Beta]1},
res=Series[Hypergeometric2F1[a1+\[Alpha]1 \[Epsilon],a2+\[Alpha]2 \[Epsilon],b1+\[Beta]1 \[Epsilon],x],{\[Epsilon],0,n1+n2+n3}];rres=Expand[SeriesCoefficient[res,n1+n2+n3]];
Return[(n1! n2! n3!) Coefficient[rres,\[Alpha]1^n1 \[Alpha]2^n2 \[Beta]1^n3]]]/;TestParamPFQHalfKnown[{a1,a2},{b1}]


Derivative[n1_Integer?NonNegative,n2_Integer?NonNegative,n3_Integer?NonNegative,0][Hypergeometric2F1Regularized][a1:(_Integer|Rational[_,2]),a2:(_Integer|Rational[_,2]),b1:(_Integer|Rational[_,2]),x_]:=Module[{t,\[Epsilon],res,\[Alpha]1,\[Alpha]2,\[Beta]1},
res=Series[Hypergeometric2F1[a1+\[Alpha]1 \[Epsilon],a2+\[Alpha]2 \[Epsilon],b1+\[Beta]1 \[Epsilon],x]/Gamma[b1+\[Beta]1 \[Epsilon]],{\[Epsilon],0,n1+n2+n3}];rres=Expand[SeriesCoefficient[res,n1+n2+n3]];
Return[(n1! n2! n3!) Coefficient[rres,\[Alpha]1^n1 \[Alpha]2^n2 \[Beta]1^n3]]]TestParamPFQHalfKnown[{a1,a2},{b1}]


Derivative[n1:{(_Integer?NonNegative)..},n2:{(_Integer?NonNegative)..},0][HypergeometricPFQ][a:{(_Integer|Rational[_,2])..},b:{(_Integer|Rational[_,2])..},x_]:=Module[{t,\[Epsilon],res,\[Alpha],\[Beta],\[Alpha]vect,\[Beta]vect,order},
\[Alpha]vect=MapIndexed[f,a]/.f[i_,j_]:>\[Alpha]@@j;
\[Beta]vect=MapIndexed[f,b]/.f[i_,j_]:>\[Beta]@@j;
order=Plus@@(Flatten[{n1,n2}]);
res=Series[HypergeometricPFQ[a+\[Alpha]vect \[Epsilon],b+\[Beta]vect \[Epsilon],x],{\[Epsilon],0,order}];
rres=Expand[SeriesCoefficient[res,order]];
Return[(Times@@(n1!)) (Times@@(n2!)) Coefficient[rres,Times@@(\[Alpha]vect^n1) Times@@(\[Beta]vect^n2)]]]/;TestParamPFQHalfKnown[a,b]


Derivative[n1:{(_Integer?NonNegative)..},n2:{(_Integer?NonNegative)..},0][HypergeometricPFQRegularized][a:{(_Integer|Rational[_,2])..},b:{(_Integer|Rational[_,2])..},x_]:=Module[{t,\[Epsilon],res,\[Alpha],\[Beta],\[Alpha]vect,\[Beta]vect,order},
\[Alpha]vect=MapIndexed[f,a]/.f[i_,j_]:>\[Alpha]@@j;
\[Beta]vect=MapIndexed[f,b]/.f[i_,j_]:>\[Beta]@@j;
order=Plus@@(Flatten[{n1,n2}]);
res=Series[HypergeometricPFQ[a+\[Alpha]vect \[Epsilon],b+\[Beta]vect \[Epsilon],x]/(Apply[Times,Gamma/@(b+\[Beta]vect \[Epsilon])]),{\[Epsilon],0,order}];
rres=Expand[SeriesCoefficient[res,order]];
Return[(Times@@(n1!)) (Times@@(n2!)) Coefficient[rres,Times@@(\[Alpha]vect^n1) Times@@(\[Beta]vect^n2)]]]/;TestParamPFQHalfKnown[a,b]


Get[ToFileName[{$HypExpPath},"rulesalgorithm.m"]];
rrlpn=Get[ToFileName[{$HypExpPath},"rrlpnHPL_private.out2"]];
rrhypfunc=Get[ToFileName[{$HypExpPath},"collectedfunctions.out"]];
Get[ToFileName[{$HypExpPath},"rrarg.m"]];


Tobias[{a1_,a2_,b1_,\[Alpha]1_,\[Alpha]2_,\[Beta]1_,xx_,eps_,maxeps_}]:=(
Module[{remember,result,zet},
remember=$HypExpPolyLogRules;
$HypExpPolyLogRules=True;
expressiontoexpand=HyperGeometric2F1Expand[a1,\[Alpha]1,a2,\[Alpha]2,b1,\[Beta]1,zet];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand/.rulekummerab;
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand/.rulekummernuraa;
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand/.rulekummernurbb;
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.ruleccupnegative;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_],Simplify];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.rulebbupnegativecm1;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.ruleaaupanegbm2cm1;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.ruleaaupanegbgem1cm1;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.rulebbdownspecialcm1;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.ruleaadowndelayedcm1;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.rulebbdowndelayedcm1;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.rulebbupnegative;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_]];
expressiontoexpand=expressiontoexpand//.ruleaaupanegbneg;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_]];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.rulebonceup;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_],Simplify];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.ruleaaupanegbpos;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_]];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.rulebbdownspecial;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_]];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.ruleaaupaminusonecpos;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_]];
expressiontoexpand=expressiontoexpand/.ruleABsymmetric;
expressiontoexpand=expressiontoexpand//.ruleaadowndelayed;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_],Simplify];
expressiontoexpand=expressiontoexpand//.rulebbdowndelayed;
expressiontoexpand=expressiontoexpand//.ruleABsymmetric;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
expressiontoexpand=expressiontoexpand//.ruleccdowndelayed;
expressiontoexpand=Collect[expressiontoexpand,HyperGeometric2F1Expand[a_,b_,c_,d_,e_,f_,z_](*,Simplify*)];
result=Series[(expressiontoexpand//.rrhypfunc),{HypExp\[Epsilon],0,maxeps}];
result=result//.rrarg;
result=result//.rrlpn;
result=result//Expand;
result=Collect[result/.{zet_/((zet_-1) (zet_/(zet_-1)-1)):>zet},{HypExp\[Epsilon],HHPPLL[ess___],PolyLog[a_,b_,zet_],PolyLog[t_,u_]^(_:1)*PolyLog[r_,q_]^(_:1),PolyLog[w_,x_]^(_:1)*Log[p_]^(_:1)*Log[f_]^(_:1),PolyLog[a_,b_]^(_:1)*Log[c_]^(_:1),PolyLog[v_,m_]^(_:1),Log[d_]^(_:1)*Log[k_]^(_:1),Log[l_]^(_:1)},(*Full*)Simplify;Factor]/.{\[Beta]1 zet-\[Beta]1:>\[Beta]1 (zet-1),\[Beta]1-\[Beta]1 zet:>-\[Beta]1 (zet-1),zet_/((zet_-1) (zet_/(zet_-1)-1)):>zet};
result=result/.HHPPLL[esss___]:>HPL[esss];
$HypExpPolyLogRules=remember;
Return[result]/.{zet->xx,HypExp\[Epsilon]->eps}

])


Unprotect[PolyLog];
PolyLog/:PolyLog[2,(zet_)/(-1+(zet_))]:=-PolyLog[2,zet]-(1/2)*Log[1-zet]^2/;$HypExpPolyLogRules

PolyLog/:PolyLog[2,1-(zet_)^(-1)]:=(1/2)*Log[-(1/zet)]^2-Log[1/zet]*Log[(zet-1)/zet]+PolyLog[2,zet]+Pi^2/3/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,1-(zet_)^(-1)]:=(1/2)*Log[-(1/zet)]^2-Log[1/zet]*Log[(zet-1)/zet]+PolyLog[2,zet]+Pi^2/3/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,(-1+(zet_))/(zet_)]:=(1/2)*Log[-(1/zet)]^2-Log[1/zet]*Log[(zet-1)/zet]+PolyLog[2,zet]+Pi^2/3/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,1-(zet_)]:=-PolyLog[2,zet]+Pi^2/6-Log[zet]*Log[1-zet]/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,(1-(zet_))^(-1)]:=PolyLog[2,zet]-(1/2)*Log[1-zet]^2+Pi^2/6+Log[1-zet]*Log[-zet]/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,(zet_)^(-1)]:=(-(1/2))*Log[-(1/zet)]^2-PolyLog[2,zet]-Pi^2/6/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,(zet_)/(-1+(zet_))]:=-PolyLog[3,zet]-PolyLog[3,1-zet]+Zeta[3]+(Pi^2/6)*Log[1-zet]-(1/2)*Log[zet]*Log[1-zet]^2+(1/6)*Log[1-zet]^3/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,(-1+(zet_))/(zet_)]:=(-(1/6))*Log[1/zet-1]^3-(1/6)*Pi^2*Log[1/zet-1]+(1/6)*Log[1-zet]^3+(1/6)*Pi^2*Log[1-zet]-(1/2)*Log[1-zet]^2*Log[zet]-PolyLog[3,1-zet]-PolyLog[3,zet]+Zeta[3]/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,(1-(zet_))^(-1)]:=(1/6)*Log[1-zet]^3-(1/2)*Log[-zet]*Log[1-zet]^2+(1/2)*Log[zet]*Log[1-zet]^2-(1/3)*Pi^2*Log[1-zet]+PolyLog[3,1-zet]/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,(zet_)^(-1)]:=PolyLog[3,zet]-(Pi^2/6)*Log[-zet^(-1)]-(1/6)*Log[-zet^(-1)]^3/;$HypExpPolyLogRules
PolyLog/:PolyLog[4,(1-(zet_))^(-1)]:=(-(1/24))*Log[1-zet]^4+(1/6)*Log[-zet]*Log[1-zet]^3-(1/6)*Log[zet]*Log[1-zet]^3+(1/6)*Pi^2*Log[1-zet]^2-PolyLog[4,1-zet]+Pi^4/45/;$HypExpPolyLogRules
PolyLog/:PolyLog[4,1-(zet_)^(-1)]:=-PolyLog[4,zet/(zet-1)]-(1/24)*Log[1/zet-1]^4-(Pi^2/12)*Log[1/zet-1]^2-7*(Pi^4/360)/;$HypExpPolyLogRules
PolyLog/:PolyLog[4,(-1+(zet_))/(zet_)]:=-PolyLog[4,zet/(zet-1)]-(1/24)*Log[1/zet-1]^4-(Pi^2/12)*Log[1/zet-1]^2-7*(Pi^4/360)/;$HypExpPolyLogRules
PolyLog/:PolyLog[5,(1-(zet_))^(-1)]:=(1/120)*Log[1-zet]^5-(1/24)*Log[-zet]*Log[1-zet]^4+(1/24)*Log[zet]*Log[1-zet]^4-(1/18)*Pi^2*Log[1-zet]^3-(1/45)*Pi^4*Log[1-zet]+PolyLog[5,1-zet]/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,2,(1-(zet_))^(-1)]:=(-(1/6))*Log[-zet]*Log[1-zet]^3+(1/3)*Log[zet]*Log[1-zet]^3+(1/4)*Log[-zet]^2*Log[1-zet]^2-(1/2)*Log[-zet]*Log[zet]*Log[1-zet]^2-(1/12)*Pi^2*Log[1-zet]^2+(1/6)*Pi^2*Log[-zet]*Log[1-zet]+PolyLog[3,1-zet]*Log[1-zet]-Zeta[3]*Log[1-zet]-Log[-zet]*PolyLog[3,1-zet]-PolyLog[4,1-zet]-PolyLog[4,zet]-PolyLog[4,zet/(zet-1)]+Log[-zet]*Zeta[3]+Pi^4/72/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,2,(zet_)/(-1+(zet_))]:=(1/12)*Log[1-zet]^4-(1/3)*Log[zet]*Log[1-zet]^3+(1/12)*Pi^2*Log[1-zet]^2-PolyLog[3,1-zet]*Log[1-zet]-PolyLog[3,zet]*Log[1-zet]+PolyLog[4,1-zet]+PolyLog[4,zet]+PolyLog[4,zet/(zet-1)]-Pi^4/90/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,2,1-(zet_)]:=(-(1/24))*Log[1-zet]^4+(1/6)*Log[zet]*Log[1-zet]^3-(1/4)*Log[zet]^2*Log[1-zet]^2-(1/12)*Pi^2*Log[1-zet]^2+(1/6)*Pi^2*Log[zet]*Log[1-zet]-Log[zet]*PolyLog[3,1-zet]+PolyLog[4,1-zet]-PolyLog[4,zet]-PolyLog[4,zet/(zet-1)]+Log[zet]*Zeta[3]-Pi^4/120/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,2,zet_]:=Log[1-zet]^4/24-(Log[zet]*Log[1-zet]^3)/6+(Pi^2*Log[1-zet]^2)/12-PolyLog[3,zet]*Log[1-zet]+Zeta[3]*Log[1-zet]-PolyLog[4,1-zet]+PolyLog[4,zet]+PolyLog[4,zet/(zet-1)]+Pi^4/90/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,3,(1-(zet_))^(-1)]:=(-(1/60))*Log[1-zet]^5+(1/8)*Log[zet]*Log[1-zet]^4+(1/12)*Log[-zet]^2*Log[1-zet]^3-(1/3)*Log[-zet]*Log[zet]*Log[1-zet]^3-(1/36)*Pi^2*Log[1-zet]^3-(1/12)*Log[-zet]^3*Log[1-zet]^2+(1/12)*Pi^2*Log[-zet]*Log[1-zet]^2+(1/4)*Log[-zet]^2*Log[zet]*Log[1-zet]^2+(1/2)*PolyLog[3,1-zet]*Log[1-zet]^2-(1/12)*Pi^2*Log[-zet]^2*Log[1-zet]-Log[-zet]*PolyLog[3,1-zet]*Log[1-zet]-PolyLog[4,1-zet]*Log[1-zet]-PolyLog[4,zet/(zet-1)]*Log[1-zet]-(1/90)*Pi^4*Log[1-zet]-(1/90)*Pi^4*Log[-zet]+(1/2)*Log[-zet]^2*PolyLog[3,1-zet]+Log[-zet]*PolyLog[4,1-zet]+Log[-zet]*PolyLog[4,zet]+Log[-zet]*PolyLog[4,zet/(zet-1)]+PolyLog[5,1-zet]-2*PolyLog[5,zet]-2*PolyLog[5,zet/(zet-1)]+PolyLog[3,2,zet]+Zeta[5]-(1/2)*Log[-zet]^2*Zeta[3]-(1/6)*Pi^2*Zeta[3]/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,3,(zet_)/(-1+(zet_))]:=(1/24)*Log[1-zet]^5-(1/6)*Log[zet]*Log[1-zet]^4+(1/18)*Pi^2*Log[1-zet]^3-(1/2)*PolyLog[3,1-zet]*Log[1-zet]^2-(1/2)*PolyLog[3,zet]*Log[1-zet]^2+(1/2)*Zeta[3]*Log[1-zet]^2+PolyLog[4,1-zet]*Log[1-zet]+PolyLog[4,zet/(zet-1)]*Log[1-zet]+(1/90)*Pi^4*Log[1-zet]-2*PolyLog[5,1-zet]+PolyLog[5,zet]+PolyLog[5,zet/(zet-1)]-PolyLog[3,2,zet]+2*Zeta[5]/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,3,1-(zet_)]:=(1/24)*Log[zet]*Log[1-zet]^4-(1/6)*Log[zet]^2*Log[1-zet]^3+(1/6)*Log[zet]^3*Log[1-zet]^2+(1/12)*Pi^2*Log[zet]*Log[1-zet]^2-(1/12)*Pi^2*Log[zet]^2*Log[1-zet]-PolyLog[4,zet]*Log[1-zet]+Log[zet]*Zeta[3]*Log[1-zet]+(1/90)*Pi^4*Log[1-zet]+(1/90)*Pi^4*Log[zet]+(1/2)*Log[zet]^2*PolyLog[3,1-zet]-Log[zet]*PolyLog[4,1-zet]+Log[zet]*PolyLog[4,zet]+Log[zet]*PolyLog[4,zet/(zet-1)]-PolyLog[3,2,zet]+2*Zeta[5]-(1/2)*Log[zet]^2*Zeta[3]-(1/6)*Pi^2*Zeta[3]/;$HypExpPolyLogRules
PolyLog/:PolyLog[2,3,zet_]:=(-(1/30))*Log[1-zet]^5+(1/8)*Log[zet]*Log[1-zet]^4-(1/18)*Pi^2*Log[1-zet]^3+(1/2)*PolyLog[3,zet]*Log[1-zet]^2-(1/2)*Zeta[3]*Log[1-zet]^2+PolyLog[4,1-zet]*Log[1-zet]-PolyLog[4,zet/(zet-1)]*Log[1-zet]-PolyLog[5,1-zet]-PolyLog[5,zet]-PolyLog[5,zet/(zet-1)]+PolyLog[3,2,zet]+Zeta[5]/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,2,(1-(zet_))^(-1)]:=(1/24)*Log[-zet]*Log[1-zet]^4-(1/12)*Log[zet]*Log[1-zet]^4-(1/12)*Log[-zet]^2*Log[1-zet]^3+(1/6)*Log[-zet]*Log[zet]*Log[1-zet]^3+(1/36)*Pi^2*Log[1-zet]^3-(1/12)*Pi^2*Log[-zet]*Log[1-zet]^2+(1/2)*Zeta[3]*Log[1-zet]^2-PolyLog[4,1-zet]*Log[1-zet]+PolyLog[4,zet]*Log[1-zet]-Log[-zet]*Zeta[3]*Log[1-zet]-(1/72)*Pi^4*Log[1-zet]-(1/90)*Pi^4*Log[-zet]+Log[-zet]*PolyLog[4,1-zet]+2*PolyLog[5,1-zet]-PolyLog[5,zet]-PolyLog[5,zet/(zet-1)]+PolyLog[3,2,zet]-(1/6)*Pi^2*Zeta[3]/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,2,(zet_)/(-1+(zet_))]:=(1/60)*Log[1-zet]^5-(1/24)*Log[zet]*Log[1-zet]^4+(1/36)*Pi^2*Log[1-zet]^3+(1/2)*Zeta[3]*Log[1-zet]^2-PolyLog[4,zet]*Log[1-zet]+PolyLog[4,zet/(zet-1)]*Log[1-zet]+(1/90)*Pi^4*Log[1-zet]-PolyLog[5,1-zet]+2*PolyLog[5,zet]+2*PolyLog[5,zet/(zet-1)]-PolyLog[3,2,zet]+Zeta[5]/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,2,1-(zet_)]:=(-(1/120))*Log[1-zet]^5+(1/24)*Log[zet]*Log[1-zet]^4-(1/12)*Log[zet]^2*Log[1-zet]^3-(1/36)*Pi^2*Log[1-zet]^3+(1/12)*Pi^2*Log[zet]*Log[1-zet]^2-PolyLog[4,zet]*Log[1-zet]+Log[zet]*Zeta[3]*Log[1-zet]-(1/120)*Pi^4*Log[1-zet]+(1/90)*Pi^4*Log[zet]-Log[zet]*PolyLog[4,1-zet]+PolyLog[5,1-zet]+PolyLog[5,zet]+PolyLog[5,zet/(zet-1)]-PolyLog[3,2,zet]+Zeta[5]-(1/6)*Pi^2*Zeta[3]/;$HypExpPolyLogRules
PolyLog/:PolyLog[3,2,-1]:=(1/12)*Pi^2*Zeta[3]-(29*Zeta[5])/32/;$HypExpPolyLogRules

Protect[PolyLog];


$HypExpPolyLogRules=False;


Get[ToFileName[{$HypExpPath},"listintegralsminimal.m"]];


HypExpInt[m___]:=(Message[HypExpInt::args,Length[{m}]];
Return[$HypExpFailed])/;Length[{m}]!=6


HypExpInt[(\[Chi]1_Integer)?NonNegative,(\[Chi]2_Integer)?NonNegative,(\[Chi]3_Integer)?NonNegative,0,(\[Chi]5_Integer)?NonNegative,0|0.]:=(-1)^\[Chi]5*HypExpU[\[Chi]2,\[Chi]3,\[Chi]1]


HypExpInt[(\[Chi]1_Integer)?NonNegative,(\[Chi]2_Integer)?NonNegative,(\[Chi]3_Integer)?NonNegative,(\[Chi]4_Integer)?Positive,(\[Chi]5_Integer)?NonNegative,0|0.]:=0


HypExpInt[(\[Chi]1_Integer)?NonNegative,(\[Chi]2_Integer)?NonNegative,(\[Chi]3_Integer)?NonNegative,(\[Chi]4_Integer)?NonNegative,(\[Chi]5_Integer)?NonNegative,1|1.]:=Module[{jom},Expand[(-1)^\[Chi]5*Sum[(-1)^jom*Binomial[\[Chi]1,jom]*HypExpU[\[Chi]3+\[Chi]4,\[Chi]2,jom-\[Chi]5],{jom,0,\[Chi]1}]]]/;\[Chi]2>=\[Chi]5


HypExpInt[(\[Chi]1_Integer)?NonNegative,(\[Chi]2_Integer)?NonNegative,(\[Chi]3_Integer)?NonNegative,(\[Chi]4_Integer)?NonNegative,(\[Chi]5_Integer)?NonNegative,(aarrgg_)/((aarrgg_)-1)]:=Module[{internint,argum,zet,auxkern,ableitung},
argum=aarrgg;
internint=kern[\[Chi]1,\[Chi]2,\[Chi]3,\[Chi]4,\[Chi]5,zet];If[internint[[5]]>9,Message[HypExpInt::long]];
While[!FreeQ[internint,kern[a_,b_,c_,d_,e_,dcr_]/;a>0],Module[{kaka,koko,kuku,kiki},internint=Expand[internint/.{kern[chi1_,chi2_,chi3_,chi4_,chi5_,zet_]:>Sum[Binomial[chi1,kaka]*kern[0,chi2,chi3,chi4,chi5-kaka,zet],{kaka,0,chi1}]/zet^chi1/;chi1>0&&chi1<=chi5}];
internint=Expand[internint/.{kern[chi1_,chi2_,chi3_,chi4_,chi5_,zet_]:>(Sum[Binomial[chi1,koko]*kern[0,chi2,chi3,chi4,chi5-koko,zet],{koko,0,chi5}]+Sum[Binomial[chi1,kuku]*auxkern[kuku-chi5,chi2,chi3,chi4,0],{kuku,chi5+1,chi1}])/zet^chi1/;chi1>0&&chi1>chi5}];
internint=Expand[internint/.{auxkern[chi1_,chi2_,chi3_,chi4_,0]:>Sum[zet^kiki*(-1)^(chi1-kiki)*Binomial[chi1,kiki]*kern[kiki,chi2,chi3,chi4,0,zet],{kiki,0,chi1}]/;chi1>0}];internint=Expand[internint/.{kern[chi1_,chi2_,chi3_,chi4_,0,zet_]:>(chi1*kern[chi1-1,chi2,chi3,chi4,0,zet])/(chi1+1)+(chi2*kern[chi1-1,chi2-1,chi3,chi4,0,zet])/(chi1+1)-(chi2*kern[chi1,chi2-1,chi3,chi4,0,zet])/(chi1+1)-(chi3*kern[chi1,chi2,chi3-1,chi4,0,zet])/(chi1+1)+(zet*chi4*kern[chi1,chi2,chi3,chi4-1,1,zet])/(chi1+1)-(zet*chi4*kern[chi1+1,chi2,chi3,chi4-1,1,zet])/(chi1+1)/;chi1>0}]]];
While[!FreeQ[internint,kern[a_,b_,c_,d_,e_,byh_]/;e>0],Module[{kk,vau1,jot},internint=Expand[internint/.{kern[0,chi2_,chi3_,chi4_,chi5_,zet_]:>-Sum[Binomial[chi5,kk]*kern[0,chi2,chi3,chi4,kk,zet],{kk,0,chi5-1}]+((-zet)^chi5*Sum[(chi4!*Sum[(Binomial[chi5-1,jot]*(-1)^jot)/jot^vau1,{jot,1,chi5-1}]*ableitung[chi5,kern[0,chi2,chi3,chi4-vau1+1,0,zet]])/(chi4-vau1+1)!,{vau1,0,chi4}])/(chi5-1)!/;chi5>1}];internint=Expand[internint/.{kern[0,chi2_,chi3_,chi4_,chi5_,zet_]:>-kern[0,chi2,chi3,chi4,0,zet]+(zet*ableitung[chi5,kern[0,chi2,chi3,chi4+1,0,zet]])/(chi4+1)/;chi5==1}]]];internint=Expand[internint//.listintegralsminimal//.rrlpn];While[!FreeQ[internint,ableitung[ahah_,sdf_]/;ahah>0],internint=Expand[internint/.{ableitung[xcc_,kintt_]:>ableitung[xcc,Expand[kintt]]}];internint=Expand[internint/.{ableitung[xc_,kint_]:>ableitung[xc-1,Expand[D[kint,zet]]]/;xc>0}];internint=Expand[internint/.{Derivative[1][myfunc][zet]:>PolyLog[2,zet]^2/zet,Derivative[1][myfunc][1-zet]:>-(PolyLog[2,1-zet]^2/(zet-1))}];
internint=Expand[internint//.rrlpn]];
internint=Expand[internint/.{ableitung[xccc_,kinttt_]:>ableitung[xccc,Expand[kinttt]]}];internint=Expand[internint//.{ableitung[0,sdf_]:>sdf}];
internint=Expand[internint//.{myfunc[zet]->2*HypExp`Private`HHPPLL[{3,2},zet]+4*PolyLog[3,2,zet],myfunc[1-zet]->2*(-HypExp`Private`HHPPLL[{2,2,1},zet]+(1/15)*Log[1-zet]^5-(1/4)*Log[zet]*Log[1-zet]^4-(1/6)*Log[zet]^2*Log[1-zet]^3+(1/9)*Pi^2*Log[1-zet]^3+(1/12)*Pi^2*Log[zet]*Log[1-zet]^2-(1/2)*Log[zet]*PolyLog[2,zet]*Log[1-zet]^2-PolyLog[3,zet]*Log[1-zet]^2+Zeta[3]*Log[1-zet]^2-(1/2)*PolyLog[2,zet]^2*Log[1-zet]+(1/6)*Pi^2*PolyLog[2,zet]*Log[1-zet]-Log[zet]*PolyLog[3,1-zet]*Log[1-zet]-2*PolyLog[4,1-zet]*Log[1-zet]+2*PolyLog[4,zet/(zet-1)]*Log[1-zet]-(1/72)*Pi^4*Log[1-zet]-(1/90)*Pi^4*Log[zet]-PolyLog[2,zet]*PolyLog[3,1-zet]+(1/6)*Pi^2*PolyLog[3,1-zet]+Log[zet]*PolyLog[4,1-zet]+2*PolyLog[5,1-zet]+2*PolyLog[5,zet]+2*PolyLog[5,zet/(zet-1)]-2*PolyLog[3,2,zet]-(7*Zeta[5])/2+PolyLog[2,zet]*Zeta[3])}];
internint=Expand[internint//.rrlpn];
internint=Expand[internint/.{zet->zet/(zet-1)}];internint=Expand[internint//.rrarg//.rrlpn];
internint=Collect[internint/.{(zetzet_)/(((zetzet_)-1)*((zetzet_)/((zetzet_)-1)-1)):>zetzet},{HypExp`Private`HHPPLL[essdf___,zetol_],PolyLog[ah_,bh_,zeth_],PolyLog[th_,uh_]^(_:1)*PolyLog[rh_,qh_]^(_:1),PolyLog[wh_,xh_]^(_:1)*Log[ph_]^(_:1)*Log[fh_]^(_:1),PolyLog[ahh_,bhh_]^(_:1)*Log[chh_]^(_:1),PolyLog[vh_,mh_]^(_:1),Log[dh_]^(_:1)*Log[khh_]^(_:1),Log[hhl_]^(_:1)},Simplify]/.{beta1*zet-beta1:>beta1*(zet-1),beta1-beta1*zet:>(-beta1)*(zet-1),(zetzet_)/(((zetzet_)-1)*((zetzet_)/((zetzet_)-1)-1)):>zetzet};
internint=internint//.rrlpn;
internint=Collect[internint,{HypExp`Private`HHPPLL[essdf___,zetol_],PolyLog[ah_,bh_,zeth_],PolyLog[th_,uh_]^(_:1)*PolyLog[rh_,qh_]^(_:1),PolyLog[wh_,xh_]^(_:1)*Log[ph_]^(_:1)*Log[fh_]^(_:1),PolyLog[ahh_,bhh_]^(_:1)*Log[chh_]^(_:1),PolyLog[vh_,mh_]^(_:1),Log[dh_]^(_:1)*Log[khh_]^(_:1),Log[hhl_]^(_:1)},Simplify;Factor];
internint=internint/.{zet:>argum};
internint=internint/.HHPPLL[esss___]:>HPL[esss];
Return[internint]]/;\[Chi]2+\[Chi]3+\[Chi]4+1-KroneckerDelta[\[Chi]5,0]<=5&&!MatchQ[aarrgg,0]


HypExpInt[\[Chi]1_Integer?NonNegative,\[Chi]2_Integer?NonNegative,\[Chi]3_Integer?NonNegative,\[Chi]4_Integer?NonNegative,\[Chi]5_Integer?NonNegative,aarrgg_]:=Module[{remember,internint,argum,zet,auxkern,ableitung},remember=$HypExpPolyLogRules;$HypExpPolyLogRules=True;argum=aarrgg;internint=kern[\[Chi]1,\[Chi]2,\[Chi]3,\[Chi]4,\[Chi]5,zet];If[internint[[5]]>9,Message[HypExpInt::"long"]];While[!FreeQ[internint,kern[a_,b_,c_,d_,e_,ff_]/;a>0],Module[{kaka,koko,kuku,kiki},internint=Expand[internint/. {kern[chi1_,chi2_,chi3_,chi4_,chi5_,zet_]:>1/zet^chi1 (Sum[Binomial[chi1,kaka] kern[0,chi2,chi3,chi4,chi5-kaka,zet],{kaka,0,chi1}])/;chi1>0&&chi1<=chi5}];internint=Expand[internint/. {kern[chi1_,chi2_,chi3_,chi4_,chi5_,zet_]:>1/zet^chi1 (Sum[Binomial[chi1,koko] kern[0,chi2,chi3,chi4,chi5-koko,zet],{koko,0,chi5}]+Sum[Binomial[chi1,kuku] auxkern[kuku-chi5,chi2,chi3,chi4,0],{kuku,chi5+1,chi1}])/;chi1>0&&chi1>chi5}];internint=Expand[internint/. {auxkern[chi1_,chi2_,chi3_,chi4_,0]:>Sum[zet^kiki (-1)^(chi1-kiki) Binomial[chi1,kiki] kern[kiki,chi2,chi3,chi4,0,zet],{kiki,0,chi1}]/;chi1>0}];internint=Expand[internint/. {kern[chi1_,chi2_,chi3_,chi4_,0,zet_]:>1/(chi1+1) chi1 kern[chi1-1,chi2,chi3,chi4,0,zet]+1/(chi1+1) chi2 kern[chi1-1,chi2-1,chi3,chi4,0,zet]-1/(chi1+1) chi2 kern[chi1,chi2-1,chi3,chi4,0,zet]-1/(chi1+1) chi3 kern[chi1,chi2,chi3-1,chi4,0,zet]+1/(chi1+1) zet chi4 kern[chi1,chi2,chi3,chi4-1,1,zet]-1/(chi1+1) zet chi4 kern[chi1+1,chi2,chi3,chi4-1,1,zet]/;chi1>0}]]];While[!FreeQ[internint,kern[a_,b_,c_,d_,e_,gg_]/;e>0],Module[{kk,vau1,jot},internint=Expand[internint/. {kern[0,chi2_,chi3_,chi4_,chi5_,zet_]:>-Sum[Binomial[chi5,kk] kern[0,chi2,chi3,chi4,kk,zet],{kk,0,chi5-1}]+(-zet)^chi5*Sum[(1/(chi4 - vau1 + 1)!)*
    (chi4!*Sum[(Binomial[chi5 - 1, jot]*(-1)^jot)/jot^vau1, 
      {jot, 1, chi5 - 1}]*ableitung[chi5, kern[0, chi2, chi3, 
       chi4 - vau1 + 1, 0, zet]]), {vau1, 0, chi4}]/(chi5-1)!/;chi5>1}];internint=Expand[internint/. {kern[0,chi2_,chi3_,chi4_,chi5_,zet_]:>-kern[0,chi2,chi3,chi4,0,zet]+1/(chi4+1) zet ableitung[chi5,kern[0,chi2,chi3,chi4+1,0,zet]]/;chi5==1}]]];internint=Expand[internint//. listintegralsminimal//. rrlpn];While[!FreeQ[internint,ableitung[ahah_,sdf_]/;ahah>0],internint=Expand[internint/. {ableitung[xcc_,kintt_]:>ableitung[xcc,Expand[kintt]]}];internint=Expand[internint/. {ableitung[xc_,kint_]:>ableitung[xc-1,Expand[\!\(
\*SubscriptBox[\(\[PartialD]\), \(zet\)]kint\)]]/;xc>0}];internint=Expand[internint/. {
\!\(\*SuperscriptBox["myfunc", "\[Prime]",
MultilineFunction->None]\)[zet]:>PolyLog[2,zet]^2/zet,
\!\(\*SuperscriptBox["myfunc", "\[Prime]",
MultilineFunction->None]\)[1-zet]:>-(PolyLog[2,1-zet]^2/(zet-1))}];internint=Expand[internint//. rrlpn]];internint=Expand[internint/. {ableitung[xccc_,kinttt_]:>ableitung[xccc,Expand[kinttt]]}];internint=Expand[internint//. {ableitung[0,sdf_]:>sdf}];internint=Expand[internint//. {myfunc[zet]->2 HypExp`Private`HHPPLL[{3,2},zet]+4 PolyLog[3,2,zet],myfunc[1-zet]->2 (-HypExp`Private`HHPPLL[{2,2,1},zet]+1/15 Log[1-zet]^5-1/4 Log[zet] Log[1-zet]^4-1/6 Log[zet]^2 Log[1-zet]^3+1/9 \[Pi]^2 Log[1-zet]^3+1/12 \[Pi]^2 Log[zet] Log[1-zet]^2-1/2 Log[zet] PolyLog[2,zet] Log[1-zet]^2-PolyLog[3,zet] Log[1-zet]^2+Zeta[3] Log[1-zet]^2-1/2 PolyLog[2,zet]^2 Log[1-zet]+1/6 \[Pi]^2 PolyLog[2,zet] Log[1-zet]-Log[zet] PolyLog[3,1-zet] Log[1-zet]-2 PolyLog[4,1-zet] Log[1-zet]+2 PolyLog[4,zet/(zet-1)] Log[1-zet]-1/72 \[Pi]^4 Log[1-zet]-1/90 \[Pi]^4 Log[zet]-PolyLog[2,zet] PolyLog[3,1-zet]+1/6 \[Pi]^2 PolyLog[3,1-zet]+Log[zet] PolyLog[4,1-zet]+2 PolyLog[5,1-zet]+2 PolyLog[5,zet]+2 PolyLog[5,zet/(zet-1)]-2 PolyLog[3,2,zet]-(7 Zeta[5])/2+PolyLog[2,zet] Zeta[3])}];internint=Expand[internint//. rrlpn];internint=Collect[internint,{HypExp`Private`HHPPLL[essdf___,zetol_],PolyLog[ah_,bh_,zeth_],PolyLog[th_,uh_]^(_:1) PolyLog[rh_,qh_]^(_:1),PolyLog[wh_,xh_]^(_:1) Log[ph_]^(_:1) Log[fh_]^(_:1),PolyLog[ahh_,bhh_]^(_:1) Log[chh_]^(_:1),PolyLog[vh_,mh_]^(_:1),Log[dh_]^(_:1) Log[khh_]^(_:1),Log[hhl_]^(_:1)},Simplify;Factor];internint=internint/. {zet:>argum};internint=internint/. HHPPLL[esss___]:>HPL[esss];$HypExpPolyLogRules=remember;Return[internint]]/;\[Chi]2+\[Chi]3+\[Chi]4+1-KroneckerDelta[\[Chi]5,0]<=5&&!MatchQ[aarrgg,0]&&!MatchQ[aarrgg,1|1.]


HypExpU[0,0,0]:=1;


HypExpU[m___]:=(Message[HypExpU::args,Length[{m}]];Return[HypExpFailed])/;Length[{m}]!=3


HypExpU[n_Integer?NonNegative,m_Integer?(#>=1&),-1]:=(
Module[{nuruint,nuruintseries,lambda,mju,p,q,r,jp,ipl,nuruinttest,jpk,laengenzaehler},
sumlambda=Expand[-Sum[lambda^p*grossA[p],{p,1,m}]];
nurusummand[1]=sumlambda//Expand;
If[m>1,Do[nurusummand[jp]=nurusummand[jp-1]*sumlambda//Expand;
nurusummand[jp]=nurusummand[jp]/.{lambda^(gaga_):>0/;(gaga>m)},{jp,2,m}]];
nuruint=1/mju+Sum[nurusummand[q]/mju/Factorial[q],{q,1,m}];
Clear[nurusummand];
nuruint=Factorial[m]*Coefficient[nuruint,lambda^m]//Expand;
nuruint=nuruint/.{grossA[pp_]:>Sum[mju^r*grossAAh[pp,r],{r,1,n+1}]};
nuruintseries=Series[nuruint,{mju,0,n}];nuruint=Factorial[n]*SeriesCoefficient[nuruintseries,n];
Clear[nuruintseries];
nuruint=nuruint/.{grossAAh[ols_,olk_]:>((-1)^(ols+olk)*Factorial[ols+olk-1]/Factorial[ols]/Factorial[olk]*Zeta[ols+olk])};If[(MatchQ[Head[nuruint],Times])&&(Length[nuruint]==2)&&(MatchQ[Head[nuruint[[2]]],Plus]),Do[nuruinttest[ipl]=(nuruint[[1]])*((nuruint[[2]])[[ipl]])//Expand,{ipl,1,Length[nuruint[[2]]]}];
laengenzaehler=Length[nuruint[[2]]];nuruint=Sum[nuruinttest[jpk],{jpk,1,laengenzaehler}];
,nuruint=Expand[nuruint];];
Clear[sumlambda,nuruinttest,laengenzaehler];
Return[nuruint]
]
)


HypExpU[nn_Integer?NonNegative,mm_Integer?NonNegative,pp_Integer?NonPositive]:=(Module[{internu,thau,kkapa,jott1,jott2},
If[nn+mm-pp>=30,Message[HypExpU::long]];
internu=numint[nn,mm,-pp];
internu=Expand[internu];
While[!(FreeQ[internu,numint[n_,m_,p_]/;((p>1)&&(n>0))]),internu=internu/.{numint[n_,m_,p_]:>(n/(p-1)*numint[n-1,m,p]-m/(p-1)*numint[m-1,n,1]-m/(p-1)*Sum[numint[n,m-1,thau],{thau,1,p-1}])/;((p>1)&&(n>0))}//Expand;];While[!(FreeQ[internu,numint[0,m_,p_]/;(p>1)]),internu=internu/.{numint[0,m_,p_]:>(-m/(p-1)*Sum[numint[0,m-1,kkapa],{kkapa,1,p-1}])/;(p>1)}//Expand;];internu=internu/.{numint[n_,m_,0]:>numint[m,n,0]/;(n<m)}//Expand;While[!(FreeQ[internu,numint[n_,m_,0]/;(n>0)]),internu=internu/.{numint[n_,m_,0]:>(-n*Sum[(-1)^(m-jott1)*Factorial[m]/Factorial[jott1]*numint[n-1,jott1,0],{jott1,0,m}]+n*Sum[(-1)^(m-jott2)*Factorial[m]/Factorial[jott2]*numint[n-1,jott2,1],{jott2,1,m}])/;(n>0)}//Expand;internu=internu/.{numint[n_,m_,0]:>numint[m,n,0]/;(n<m)}//Expand;];internu=internu/.{numint[n_,m_,0]:>numint[m,n,0]/;(n<m)}//Expand;
Return[Expand[internu/.numint[mmm_,nnn_,ppp_]:>HypExpU[mmm,nnn,-ppp]]]
])/;mm+pp>=0


HypExpU[nn_Integer?NonNegative,mm_Integer?NonNegative,pp_Integer?Positive]:=(Module[{pospint,lastint},
If[nn+mm+pp>=25,Message[HypExpU::long]];
pospint=lastint[nn,mm,pp];
While[!(FreeQ[pospint,lastint[n_,m_,p_]/;(p>0)]),pospint=pospint/.{lastint[n_,m_,p_]:>(p/(p+1)*lastint[n,m,p-1]+n/(p+1)*lastint[n-1,m,p-1]-n/(p+1)*lastint[n-1,m,p]-m/(p+1)*lastint[n,m-1,p])/;(p>0)};pospint=Expand[pospint];];
Return[Expand[pospint/.lastint[mmm_,nnn_,ppp_]:>HypExpU[mmm,nnn,ppp]]]
])


HypExpAtOne[A_List,B_List,\[Epsilon]_]:=(Module[{innput,aavektor,bbvektor,bbvektorkopie,aasumme,bbsumme,aasummeinteger,bbsummeinteger,unionbb,vielfachheit,pbzzaehler,pbznenner,pbzbruch,uniqueka,phaa,phbb,zerlegt,zerlegtpiece,kacoeff,kabruch,bbvergleich,kabruchpower,ult,kwq,fvt,hypterm,intermedPFQ,ultim,res,kiop,nochmalzwischen,kioopp},innput={A,B,1};
aavektor=Sort[Expand[innput[[1]]]];bbvektor=Sort[Expand[innput[[2]]]];
Do[bbvektorkopie[laeufer]=Expand[bbvektor],{laeufer,1,Length[bbvektor]}];
aasumme=Sum[aavektor[[jj]],{jj,1,Length[aavektor]}]//Expand;
bbsumme=Sum[bbvektor[[pp]],{pp,1,Length[bbvektor]}]//Expand;
aasummeinteger=Sum[((aavektor[[ii]])/.{\[Epsilon]:>0}),{ii,1,Length[aavektor]}]//Expand;
bbsummeinteger=Sum[((bbvektor[[uu]])/.{\[Epsilon]:>0}),{uu,1,Length[bbvektor]}]//Expand;
unionbb=Union[Expand[bbvektor]];
vielfachheit=Length[Cases[Expand[bbvektor],#]]&/@unionbb;
pbzzaehler=Product[(uniqueka+phaa[jkj]),{jkj,1,Length[aavektor]}];
pbznenner=Product[(uniqueka+phbb[ok])^(vielfachheit[[ok]]),{ok,1,Length[unionbb]}];
pbzbruch=pbzzaehler/pbznenner;
zerlegt=Apart[pbzbruch,uniqueka]-uniqueka+Expand[Sum[vielfachheit[[neph]]*phbb[neph],{neph,1,Length[unionbb]}]]-Expand[Sum[phaa[bvc],{bvc,1,Length[aavektor]}]];
Do[zerlegtpiece[ult]=zerlegt[[ult]];
kacoeff[ult]=zerlegtpiece[ult]/.{Power[uniqueka+phbb[asko_],pow_]:>1/;((IntegerQ[pow])&&(pow<=-1))};
kabruch[ult]=zerlegtpiece[ult]/kacoeff[ult]//Simplify;
bbvergleich[ult]=(kabruch[ult][[1]]-uniqueka)//Expand;
kabruchpower[ult]=-kabruch[ult][[2]];
bbvektorkopie[ult]=Flatten[Table[Table[phbb[kwq],{fvt,1,vielfachheit[[kwq]]}],{kwq,1,Length[unionbb]}]];
bbvektorkopie[ult]=DeleteCases[bbvektorkopie[ult],bbvergleich[ult]];
Do[bbvektorkopie[ult]=Append[bbvektorkopie[ult],bbvergleich[ult]+1],{kiop,1,kabruchpower[ult]}];
nochmalzwischen=Length[bbvektorkopie[ult]];
Do[bbvektorkopie[ult]=Append[bbvektorkopie[ult],bbvergleich[ult]],{kioopp,1,Length[bbvektor]-nochmalzwischen}];
Clear[nochmalzwischen];
hypterm[ult]=(((kacoeff[ult])/(bbvergleich[ult])^(kabruchpower[ult])*intermedPFQ[aavektor,bbvektorkopie[ult],1])/.{phaa[jmn_]:>aavektor[[jmn]],phbb[jjmmnn_]:>unionbb[[jjmmnn]]}),{ult,1,Length[zerlegt]}];
res=Collect[Sum[hypterm[ultim]/(bbsumme-aasumme),{ultim,1,Length[zerlegt]}],intermedPFQ[{nhy___},{tgb___},1],Simplify;Factor];
res=res/.intermedPFQ[AA_List,BB_List,1]:>HypExpAtOne[AA,BB,\[Epsilon]]/;((Apply[Plus,BB]-Apply[Plus,AA])/.\[Epsilon]->0)<=0;
Return[Collect[res/.intermedPFQ->HypergeometricPFQ,HypergeometricPFQ[_,_,_],Simplify;Factor]]])



HypExpAtOne[A_List,B_List,\[Epsilon]_,order_]:=Module [{res,rres,C},
res=HypExp`Private`HypExpAtOne[A,B,\[Epsilon]];
res=Collect[res,_HypergeometricPFQ,C];
res=res/.C[x_]:>C[x,Switch[rres=Series[x,{\[Epsilon],0,0}],_SeriesData,rres[[-3]],_,0]];
res=res/.{C[coeff_,n_] h_HypergeometricPFQ:>coeff Series[h,{\[Epsilon],0,Max[0,order-n]}],C[coeff_,n_]->coeff};
Return[Simplify[res]]
]


If[spellswitchedoff==True,On[General::spell1]];
If[seriesdataswitchedoff==True,On[SeriesData::sdatc]];
(*On[Syntax::bktwrn];*)
End[]
EndPackage[]


Print[HypExp::loaded]
Print["More info in hep-ph/0507094 and at \n http://krone.physik.unizh.ch/~maitreda/HypExp/"]
